
/*  A Bison parser, made from f2jparse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	PLUS	257
#define	MINUS	258
#define	OP	259
#define	CP	260
#define	STAR	261
#define	POW	262
#define	DIV	263
#define	CAT	264
#define	CM	265
#define	EQ	266
#define	COLON	267
#define	NL	268
#define	NOT	269
#define	AND	270
#define	OR	271
#define	RELOP	272
#define	EQV	273
#define	NEQV	274
#define	NAME	275
#define	DOUBLE	276
#define	INTEGER	277
#define	EXPONENTIAL	278
#define	CONST	279
#define	TrUE	280
#define	FaLSE	281
#define	ICON	282
#define	RCON	283
#define	LCON	284
#define	CCON	285
#define	FLOAT	286
#define	CHARACTER	287
#define	LOGICAL	288
#define	COMPLEX	289
#define	NONE	290
#define	IF	291
#define	THEN	292
#define	ELSE	293
#define	ELSEIF	294
#define	ENDIF	295
#define	DO	296
#define	GOTO	297
#define	ASSIGN	298
#define	TO	299
#define	CONTINUE	300
#define	STOP	301
#define	RDWR	302
#define	END	303
#define	STRING	304
#define	CHAR	305
#define	OPEN	306
#define	CLOSE	307
#define	BACKSPACE	308
#define	REWIND	309
#define	ENDFILE	310
#define	FORMAT	311
#define	PROGRAM	312
#define	FUNCTION	313
#define	SUBROUTINE	314
#define	ENTRY	315
#define	CALL	316
#define	RETURN	317
#define	TYPE	318
#define	DIMENSION	319
#define	COMMON	320
#define	EQUIVALENCE	321
#define	EXTERNAL	322
#define	PARAMETER	323
#define	INTRINSIC	324
#define	IMPLICIT	325
#define	SAVE	326
#define	DATA	327
#define	COMMENT	328
#define	READ	329
#define	WRITE	330
#define	FMT	331
#define	EDIT_DESC	332
#define	REPEAT	333
#define	LOWER_THAN_COMMENT	334

#line 8 "f2jparse.y"


/*****************************************************************************
 * f2jparse                                                                  *
 *                                                                           *
 * This is a yacc parser for a subset of Fortran 77.  It builds an AST       *
 * which is used by codegen() to generate Java code.                         *
 *                                                                           *
 *****************************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<string.h>
#include"f2j.h"
#include"class.h"
#include"constant_pool.h"

/*****************************************************************************
 * Define YYDEBUG as 1 to get debugging output from yacc.                    *
 *****************************************************************************/

#define YYDEBUG 0

/*****************************************************************************
 * Global variables.                                                         *
 *****************************************************************************/

int 
  debug = FALSE,                  /* set to TRUE for debugging output        */
  emittem = 1,                    /* set to 1 to emit Java, 0 to just parse  */
  len = 1,                        /* keeps track of the size of a data type  */
  temptok;                        /* temporary token for an inline expr      */

char
  tempname[60];                   /* temporary string                        */

AST 
  * equivList = NULL;             /* list to keep track of equivalences      */

CPNODE
  * lastConstant;                 /* last constant inserted into the c.pool  */

/*****************************************************************************
 * Function prototypes:                                                      *
 *****************************************************************************/

int 
  yylex();

double
  eval_const_expr(AST *);

char 
  * strdup(const char *),
  * strcat(char *, const char*),
  * lowercase(char * ),
  * print_nodetype (AST *),
  * tok2str(int );

void 
  yyerror(char *),
  start_vcg(),
  emit(),
  jas_emit(),
  init_tables(),
  addEquiv(AST *),
  assign(AST *),
  typecheck(AST *),
  optScalar(AST *),
  type_insert (SYMTABLE * , AST * , int , char *),
  type_hash(AST *),
  merge_common_blocks(AST *),
  arg_table_load(AST *),
  exp_to_double (char *, char *),
  prepend_minus(char *);

AST 
  * dl_astnode_examine(Dlist l),
  * addnode(),
  * switchem(),
  * gen_incr_expr(AST *, AST *),
  * gen_iter_expr(AST *, AST *, AST *),
  * initialize_name(char *);

SYMTABLE 
  * new_symtable (int );


#line 98 "f2jparse.y"
typedef union {
   struct ast_node *ptnode;
   int tok;
   enum returntype type;
   char lexeme[80];
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		431
#define	YYFLAG		-32768
#define	YYNTBASE	82

#define YYTRANSLATE(x) ((unsigned)(x) <= 334 ? yytranslate[x] : 189)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    81,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     7,     9,    11,    13,    15,    20,    25,
    30,    34,    39,    43,    49,    51,    53,    56,    58,    60,
    62,    64,    66,    68,    70,    72,    74,    77,    79,    83,
    87,    89,    93,    97,   103,   105,   109,   113,   115,   118,
   123,   126,   129,   135,   139,   141,   145,   148,   150,   154,
   159,   161,   165,   167,   170,   174,   176,   180,   182,   190,
   194,   200,   202,   205,   208,   210,   212,   214,   216,   218,
   220,   222,   224,   226,   228,   230,   232,   234,   236,   238,
   240,   243,   249,   253,   256,   260,   263,   265,   269,   273,
   275,   279,   285,   287,   289,   293,   295,   297,   299,   301,
   303,   308,   310,   314,   316,   318,   322,   324,   328,   330,
   335,   342,   344,   348,   351,   354,   358,   363,   370,   373,
   377,   382,   384,   387,   389,   391,   393,   395,   397,   401,
   405,   407,   409,   411,   413,   415,   417,   420,   424,   433,
   435,   437,   441,   443,   447,   449,   453,   462,   473,   475,
   479,   480,   482,   492,   504,   508,   520,   521,   523,   526,
   534,   535,   539,   545,   556,   561,   568,   570,   574,   575,
   579,   583,   585,   589,   593,   595,   599,   601,   605,   607,
   610,   612,   613,   618,   620,   623,   626,   630,   634,   636,
   640,   644,   646,   650,   652,   656,   658,   660,   662,   664,
   668,   670,   672,   674,   676,   678,   680,   682,   684,   686,
   688,   691,   694,   698,   705,   713,   715,   719,   725,   727,
   731,   733,   737
};

static const short yyrhs[] = {    83,
     0,    84,     0,    83,    84,     0,    85,     0,    86,     0,
    87,     0,   114,     0,    88,    91,   112,   117,     0,    89,
    91,   112,   117,     0,    90,    91,   112,   117,     0,    58,
   125,    14,     0,    60,   125,   118,    14,     0,    60,   125,
    14,     0,   122,    59,   125,   118,    14,     0,    92,     0,
    93,     0,    92,    93,     0,    94,     0,    96,     0,    99,
     0,   102,     0,   188,     0,   120,     0,   187,     0,   184,
     0,   103,     0,   104,    14,     0,   114,     0,    65,    95,
    14,     0,   127,    11,    95,     0,   127,     0,    67,    97,
    14,     0,     5,    98,     6,     0,    97,    11,     5,    98,
     6,     0,   132,     0,    98,    11,   132,     0,    66,   100,
    14,     0,   101,     0,   100,   101,     0,     9,   125,     9,
   119,     0,    10,   119,     0,    72,    14,     0,    72,     9,
   119,     9,    14,     0,    72,   119,    14,     0,    71,     0,
    71,    36,    14,     0,    73,   105,     0,   106,     0,   105,
    11,   106,     0,   109,     9,   107,     9,     0,   108,     0,
   107,    11,   108,     0,   175,     0,     4,   175,     0,   175,
     7,   175,     0,   110,     0,   110,    11,   109,     0,   132,
     0,     5,   132,    11,   125,    12,   111,     6,     0,   176,
    11,   176,     0,   176,    11,   176,    11,   176,     0,   113,
     0,   112,   113,     0,   131,    14,     0,   162,     0,   157,
     0,   158,     0,   153,     0,   134,     0,   179,     0,   182,
     0,   181,     0,   137,     0,   145,     0,   146,     0,   149,
     0,   180,     0,   115,     0,   114,     0,   116,     0,    74,
    14,     0,    53,     5,   125,     6,    14,     0,    55,   125,
    14,     0,    49,    14,     0,     5,   119,     6,     0,     5,
     6,     0,   125,     0,   119,    11,   125,     0,   121,   123,
    14,     0,   122,     0,   122,   130,   176,     0,   122,   130,
     5,   130,     6,     0,    64,     0,   124,     0,   123,    11,
   124,     0,   125,     0,   127,     0,    21,     0,    50,     0,
    51,     0,   125,     5,   128,     6,     0,   129,     0,   128,
    11,   129,     0,   163,     0,   130,     0,   163,    13,   163,
     0,     7,     0,   132,    12,   163,     0,   125,     0,   125,
     5,   133,     6,     0,   125,     5,   163,    13,   163,     6,
     0,   163,     0,   133,    11,   163,     0,   135,   136,     0,
    42,   176,     0,    42,   176,    11,     0,   131,    11,   163,
    14,     0,   131,    11,   163,    11,   163,    14,     0,   176,
   113,     0,   176,   138,    14,     0,    57,     5,   139,     6,
     0,   140,     0,   139,   140,     0,   141,     0,   142,     0,
   143,     0,    78,     0,   125,     0,   125,    81,   175,     0,
     5,   139,     6,     0,   126,     0,   144,     0,    11,     0,
     9,     0,    10,     0,   176,     0,     3,   176,     0,   176,
    46,    14,     0,    76,     5,   147,    11,   148,     6,   150,
    14,     0,   163,     0,     7,     0,    77,    12,   176,     0,
   176,     0,    77,    12,     7,     0,     7,     0,    77,    12,
   126,     0,    75,     5,   147,    11,   148,     6,   150,    14,
     0,    75,     5,   147,    11,   148,    11,   152,     6,   150,
    14,     0,   151,     0,   150,    11,   151,     0,     0,   163,
     0,     5,   163,    11,   125,    12,   163,    11,   163,     6,
     0,     5,   163,    11,   125,    12,   163,    11,   163,    11,
   163,     6,     0,    49,    12,   176,     0,    37,     5,   163,
     6,    38,    14,   112,   154,   156,    41,    14,     0,     0,
   155,     0,   154,   155,     0,    40,     5,   163,     6,    38,
    14,   112,     0,     0,    39,    14,   112,     0,    37,     5,
   163,     6,   113,     0,    37,     5,   163,     6,   176,    11,
   176,    11,   176,    14,     0,   125,     5,   161,     6,     0,
   125,     5,   163,    13,   163,     6,     0,   163,     0,   161,
    11,   163,     0,     0,    62,   159,    14,     0,    62,   125,
    14,     0,   164,     0,   163,    19,   164,     0,   163,    20,
   164,     0,   165,     0,   164,    17,   165,     0,   166,     0,
   165,    16,   166,     0,   167,     0,    15,   167,     0,   169,
     0,     0,   167,    18,   168,   167,     0,   170,     0,     4,
   170,     0,     3,   170,     0,   169,     3,   170,     0,   169,
     4,   170,     0,   171,     0,   170,     9,   171,     0,   170,
     7,   171,     0,   172,     0,   172,     8,   171,     0,   173,
     0,   172,    10,   173,     0,   125,     0,   175,     0,   159,
     0,   160,     0,     5,   163,     6,     0,    26,     0,    27,
     0,   176,     0,   177,     0,   178,     0,   174,     0,   126,
     0,    23,     0,    22,     0,    24,     0,    63,    14,     0,
    47,    14,     0,    43,   176,    14,     0,    43,     5,   183,
     6,   163,    14,     0,    43,     5,   183,     6,    11,   163,
    14,     0,   176,     0,   183,    11,   176,     0,    69,     5,
   185,     6,    14,     0,   186,     0,   185,    11,   186,     0,
   131,     0,    68,   119,    14,     0,    70,   119,    14,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   169,   214,   233,   255,   261,   267,   273,   281,   333,   399,
   465,   484,   507,   526,   565,   573,   577,   584,   588,   592,
   596,   600,   604,   608,   612,   616,   620,   624,   630,   641,
   647,   658,   668,   683,   700,   704,   711,   722,   726,   733,
   764,   794,   805,   821,   838,   844,   854,   863,   867,   874,
   902,   906,   913,   917,   922,   938,   942,   949,   953,   963,
   973,   992,   996,  1003,  1008,  1013,  1018,  1023,  1028,  1033,
  1038,  1043,  1048,  1053,  1058,  1063,  1068,  1073,  1078,  1083,
  1090,  1100,  1107,  1114,  1129,  1136,  1144,  1148,  1162,  1184,
  1189,  1194,  1201,  1213,  1223,  1231,  1235,  1254,  1276,  1287,
  1300,  1358,  1368,  1376,  1380,  1384,  1397,  1411,  1424,  1430,
  1461,  1477,  1488,  1500,  1509,  1514,  1521,  1535,  1557,  1566,
  1594,  1602,  1612,  1633,  1638,  1642,  1648,  1654,  1658,  1663,
  1674,  1678,  1684,  1690,  1695,  1702,  1706,  1721,  1731,  1772,
  1778,  1785,  1790,  1794,  1802,  1810,  1816,  1828,  1842,  1852,
  1858,  1864,  1868,  1885,  1906,  1917,  1942,  1943,  1947,  1955,
  1967,  1968,  1978,  1988,  2015,  2069,  2095,  2105,  2111,  2120,
  2125,  2141,  2145,  2157,  2171,  2175,  2189,  2193,  2207,  2211,
  2222,  2226,  2227,  2240,  2244,  2259,  2273,  2286,  2301,  2305,
  2318,  2333,  2337,  2348,  2352,  2367,  2368,  2373,  2374,  2375,
  2394,  2402,  2413,  2418,  2422,  2426,  2430,  2436,  2446,  2472,
  2485,  2491,  2498,  2509,  2520,  2533,  2537,  2544,  2554,  2558,
  2565,  2624,  2635
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PLUS","MINUS",
"OP","CP","STAR","POW","DIV","CAT","CM","EQ","COLON","NL","NOT","AND","OR","RELOP",
"EQV","NEQV","NAME","DOUBLE","INTEGER","EXPONENTIAL","CONST","TrUE","FaLSE",
"ICON","RCON","LCON","CCON","FLOAT","CHARACTER","LOGICAL","COMPLEX","NONE","IF",
"THEN","ELSE","ELSEIF","ENDIF","DO","GOTO","ASSIGN","TO","CONTINUE","STOP","RDWR",
"END","STRING","CHAR","OPEN","CLOSE","BACKSPACE","REWIND","ENDFILE","FORMAT",
"PROGRAM","FUNCTION","SUBROUTINE","ENTRY","CALL","RETURN","TYPE","DIMENSION",
"COMMON","EQUIVALENCE","EXTERNAL","PARAMETER","INTRINSIC","IMPLICIT","SAVE",
"DATA","COMMENT","READ","WRITE","FMT","EDIT_DESC","REPEAT","LOWER_THAN_COMMENT",
"'.'","F2java","Sourcecodes","Sourcecode","Fprogram","Fsubroutine","Ffunction",
"Program","Subroutine","Function","Specstmts","SpecStmtList","Specstmt","Dimension",
"ArraydecList","EquivalenceStmt","EquivalenceList","EquivalenceItem","Common",
"CommonList","CommonSpec","Save","Implicit","Data","DataList","DataItem","DataConstantList",
"DataConstant","LhsList","DataLhs","LoopBounds","Statements","Statement","Comment",
"Close","Rewind","End","Functionargs","Namelist","Typestmt","Types","Type","Typevarlist",
"Typevar","Name","String","Arraydeclaration","Arraynamelist","Arrayname","Star",
"Assignment","Lhs","Arrayindexlist","Doloop","Do_incr","Do_vals","Label","Format",
"FormatExplist","FormatExp","RepeatableItem","UnRepeatableItem","FormatSeparator",
"RepeatSpec","Continue","Write","WriteFileDesc","FormatSpec","Read","IoExplist",
"IoExp","EndSpec","Blockif","Elseifs","Elseif","Else","Logicalif","Arithmeticif",
"Subroutinecall","SubstringOp","Explist","Call","Exp","log_disjunct","log_term",
"log_factor","log_primary","@1","arith_expr","term","factor","char_expr","primary",
"Boolean","Constant","Integer","Double","Exponential","Return","Stop","Goto",
"ComputedGoto","Intlist","Parameter","Pdecs","Pdec","External","Intrinsic", NULL
};
#endif

static const short yyr1[] = {     0,
    82,    83,    83,    84,    84,    84,    84,    85,    86,    87,
    88,    89,    89,    90,    91,    92,    92,    93,    93,    93,
    93,    93,    93,    93,    93,    93,    93,    93,    94,    95,
    95,    96,    97,    97,    98,    98,    99,   100,   100,   101,
   101,   102,   102,   102,   103,   103,   104,   105,   105,   106,
   107,   107,   108,   108,   108,   109,   109,   110,   110,   111,
   111,   112,   112,   113,   113,   113,   113,   113,   113,   113,
   113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
   114,   115,   116,   117,   118,   118,   119,   119,   120,   121,
   121,   121,   122,   123,   123,   124,   124,   125,   126,   126,
   127,   128,   128,   129,   129,   129,   130,   131,   132,   132,
   132,   133,   133,   134,   135,   135,   136,   136,   137,   137,
   138,   139,   139,   140,   140,   140,   141,   141,   141,   141,
   142,   142,   143,   143,   143,   144,   144,   145,   146,   147,
   147,   148,   148,   148,   148,   148,   149,   149,   150,   150,
   150,   151,   151,   151,   152,   153,   154,   154,   154,   155,
   156,   156,   157,   158,   159,   160,   161,   161,   161,   162,
   162,   163,   163,   163,   164,   164,   165,   165,   166,   166,
   167,   168,   167,   169,   169,   169,   169,   169,   170,   170,
   170,   171,   171,   172,   172,   173,   173,   173,   173,   173,
   174,   174,   175,   175,   175,   175,   175,   176,   177,   178,
   179,   180,   181,   182,   182,   183,   183,   184,   185,   185,
   186,   187,   188
};

static const short yyr2[] = {     0,
     1,     1,     2,     1,     1,     1,     1,     4,     4,     4,
     3,     4,     3,     5,     1,     1,     2,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     2,     1,     3,     3,
     1,     3,     3,     5,     1,     3,     3,     1,     2,     4,
     2,     2,     5,     3,     1,     3,     2,     1,     3,     4,
     1,     3,     1,     2,     3,     1,     3,     1,     7,     3,
     5,     1,     2,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     5,     3,     2,     3,     2,     1,     3,     3,     1,
     3,     5,     1,     1,     3,     1,     1,     1,     1,     1,
     4,     1,     3,     1,     1,     3,     1,     3,     1,     4,
     6,     1,     3,     2,     2,     3,     4,     6,     2,     3,
     4,     1,     2,     1,     1,     1,     1,     1,     3,     3,
     1,     1,     1,     1,     1,     1,     2,     3,     8,     1,
     1,     3,     1,     3,     1,     3,     8,    10,     1,     3,
     0,     1,     9,    11,     3,    11,     0,     1,     2,     7,
     0,     3,     5,    10,     4,     6,     1,     3,     0,     3,
     3,     1,     3,     3,     1,     3,     1,     3,     1,     2,
     1,     0,     4,     1,     2,     2,     3,     3,     1,     3,
     3,     1,     3,     1,     3,     1,     1,     1,     1,     3,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     2,     3,     6,     7,     1,     3,     5,     1,     3,
     1,     3,     3
};

static const short yydefact[] = {     0,
     0,     0,    93,     0,     1,     2,     4,     5,     6,     0,
     0,     0,     7,     0,    98,     0,     0,    81,     3,     0,
     0,     0,     0,     0,     0,    45,     0,     0,     0,    15,
    16,    18,    19,    20,    21,    26,     0,    28,    23,     0,
    90,    25,    24,    22,     0,     0,     0,    11,     0,    13,
     0,     0,     0,    31,     0,     0,     0,    38,     0,     0,
     0,    87,     0,     0,     0,     0,    42,     0,     0,    47,
    48,     0,    56,   109,    58,   208,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    62,    79,    78,
    80,     0,     0,    69,     0,    73,    74,    75,    76,    68,
    66,    67,    65,     0,    70,    77,    72,    71,    17,    27,
     0,    94,    96,    97,   107,     0,     0,     0,     0,    86,
     0,    12,    29,     0,     0,     0,    41,    37,    39,     0,
    35,     0,    32,     0,   222,   221,     0,   219,   223,    46,
     0,    44,     0,     0,     0,     0,     0,     0,   115,     0,
     0,   212,     0,     0,     0,     0,   211,     0,     0,     0,
    63,     8,    64,     0,     0,   114,     0,     0,   119,     0,
     0,    89,     0,    91,     9,    10,     0,    85,     0,     0,
     0,     0,   209,   210,   201,   202,    99,   100,   196,   207,
     0,   102,   105,   198,   199,   104,   172,   175,   177,   179,
   181,   184,   189,   192,   194,   206,   197,   203,   204,   205,
    30,     0,    33,     0,     0,    88,     0,     0,     0,     0,
    49,     0,     0,    51,    53,    57,     0,   112,     0,   116,
   216,     0,   213,     0,    83,   169,   171,   170,   141,     0,
   140,     0,    84,   108,     0,   138,     0,   120,    95,     0,
    14,   186,   185,     0,   180,   169,   101,     0,     0,     0,
     0,     0,     0,   182,     0,     0,     0,     0,     0,     0,
    40,    36,     0,   218,   220,    43,     0,    54,    50,     0,
     0,   110,     0,     0,     0,     0,     0,     0,     0,   167,
     0,     0,     0,     0,     0,   134,   135,   133,   127,   128,
   131,     0,   122,   124,   125,   126,   132,   136,    92,   200,
   167,   103,   106,   173,   174,   176,   178,     0,   187,   188,
   191,   190,   193,   195,    34,     0,    52,    55,   113,     0,
     0,   163,     0,     0,     0,   217,    82,   165,     0,   145,
     0,     0,   143,     0,     0,   117,   137,     0,     0,   121,
   123,     0,   183,     0,     0,   111,     0,     0,     0,   214,
   168,     0,   151,     0,   151,     0,   130,   129,     0,    59,
     0,   157,     0,   215,   144,   146,   142,     0,     0,   149,
   152,     0,     0,     0,   118,   166,    60,     0,   161,   158,
     0,     0,     0,   147,     0,   151,   139,     0,     0,     0,
   159,     0,     0,     0,   150,   155,     0,    61,     0,     0,
     0,   164,     0,   148,     0,   162,   156,     0,     0,     0,
     0,     0,   160,     0,   153,     0,     0,   154,     0,     0,
     0
};

static const short yydefgoto[] = {   429,
     5,     6,     7,     8,     9,    10,    11,    12,    29,    30,
    31,    32,    52,    33,    60,   130,    34,    57,    58,    35,
    36,    37,    70,    71,   223,   224,    72,    73,   354,    87,
    88,    89,    90,    91,   162,    51,    61,    39,    40,    41,
   111,   112,   189,   190,    54,   191,   192,   193,    92,    93,
   227,    94,    95,   166,    96,   170,   302,   303,   304,   305,
   306,   307,    97,    98,   240,   342,    99,   379,   380,   383,
   100,   389,   390,   402,   101,   102,   194,   195,   289,   103,
   381,   197,   198,   199,   200,   318,   201,   202,   203,   204,
   205,   206,   207,   208,   209,   210,   105,   106,   107,   108,
   232,    42,   137,   138,    43,    44
};

static const short yypact[] = {     3,
    -4,    -4,-32768,    15,     3,-32768,-32768,-32768,-32768,   641,
   641,   641,-32768,    13,-32768,    69,    71,-32768,-32768,    -4,
   174,    82,    -4,    86,    -4,    66,   207,    10,   519,   641,
-32768,-32768,-32768,-32768,-32768,-32768,   105,-32768,-32768,    -4,
   119,-32768,-32768,-32768,   519,   519,    -4,-32768,    36,-32768,
   120,   124,   152,   158,    -4,    -4,   278,-32768,    -4,   180,
   238,-32768,    -4,   263,   198,    -4,-32768,   302,    -4,   219,
-32768,   225,   230,   257,-32768,-32768,   261,   250,    20,   266,
   332,    -4,    -4,   328,   345,   352,   398,-32768,-32768,-32768,
-32768,   340,   334,-32768,    -4,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   322,-32768,-32768,-32768,-32768,-32768,-32768,
   308,-32768,   152,-32768,-32768,    48,   398,   398,   356,-32768,
    12,-32768,-32768,   564,    -4,   357,   359,-32768,-32768,    41,
-32768,   371,-32768,    -4,-32768,-32768,   112,-32768,-32768,-32768,
   211,-32768,   372,    10,   221,    10,   639,   639,   379,   250,
   386,-32768,    -4,   394,    99,   396,-32768,   595,   595,   397,
-32768,-32768,-32768,   639,   402,-32768,   403,   411,-32768,   412,
    -4,-32768,   119,-32768,-32768,-32768,   418,-32768,   150,   150,
   639,   677,-32768,-32768,-32768,-32768,-32768,-32768,   420,-32768,
   187,-32768,-32768,-32768,-32768,   109,   416,   421,-32768,   424,
   327,   244,-32768,   296,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    -4,-32768,    -4,    -4,-32768,   425,    -4,   432,    -4,
-32768,   276,   349,-32768,   442,-32768,   231,   220,    73,-32768,
-32768,   249,-32768,   444,-32768,   639,-32768,-32768,-32768,   437,
   354,   443,-32768,   354,   639,-32768,   258,-32768,-32768,   446,
-32768,   244,   244,   145,   424,   639,-32768,   564,   639,   639,
   639,   639,   639,-32768,   150,   150,   150,   150,   150,   150,
   359,-32768,   264,-32768,-32768,-32768,   447,-32768,-32768,   221,
   276,-32768,   639,   639,   441,   626,   250,   449,   284,   354,
     7,     7,   139,   250,   258,-32768,-32768,-32768,-32768,   377,
-32768,   157,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   245,-32768,   354,   416,   416,   421,-32768,   677,   244,   244,
-32768,-32768,-32768,-32768,-32768,   250,-32768,-32768,   354,   169,
   451,-32768,   381,   639,   277,-32768,-32768,-32768,   639,-32768,
   454,   317,-32768,   461,   639,-32768,-32768,   176,   276,-32768,
-32768,   639,   450,   463,   459,-32768,   519,   250,   291,-32768,
   354,     9,   670,   422,   670,   301,-32768,-32768,   184,-32768,
   250,   484,   464,-32768,-32768,-32768,-32768,   639,   324,-32768,
   354,   465,   470,   330,-32768,-32768,   469,   476,   348,-32768,
   250,    95,   670,-32768,   250,   670,-32768,   250,   639,   468,
-32768,   445,   471,    -4,-32768,-32768,   341,-32768,   186,   519,
   473,-32768,   477,-32768,   452,   519,-32768,   639,   478,    55,
   519,   639,   519,   129,-32768,   639,   204,-32768,   491,   493,
-32768
};

static const short yypgoto[] = {-32768,
-32768,   490,-32768,-32768,-32768,-32768,-32768,-32768,   369,-32768,
   467,-32768,   373,-32768,-32768,   285,-32768,-32768,   453,-32768,
-32768,-32768,-32768,   355,-32768,   222,   360,-32768,-32768,   -43,
   -83,   100,-32768,-32768,   288,   382,    24,-32768,-32768,   329,
-32768,   337,    -1,  -206,   -35,-32768,   251,   -34,   -57,   -19,
-32768,-32768,-32768,-32768,-32768,-32768,   216,  -292,-32768,-32768,
-32768,-32768,-32768,-32768,   353,   226,-32768,  -332,   121,-32768,
-32768,-32768,   130,-32768,-32768,-32768,   430,-32768,-32768,-32768,
   -27,   133,   260,   262,  -174,-32768,-32768,  -167,   162,-32768,
   253,-32768,  -134,    -9,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   310,-32768,-32768
};


#define	YYLAST		728


static const short yytable[] = {    16,
    17,   117,   118,   161,   114,   136,   116,   255,    75,   351,
   225,   252,   253,   340,    69,   375,    15,   178,    53,   104,
   169,    62,   134,    62,   150,    62,    74,    74,    18,    76,
    15,    76,   384,   161,   161,   104,   104,   165,   113,   131,
   301,   120,    76,    74,    74,   119,   213,    62,    64,   143,
    68,   214,   173,   126,    62,   351,    15,    74,   187,   188,
     1,    74,     2,   407,    62,   422,     3,    74,   149,   151,
    76,    47,   121,   260,   261,    49,     4,   104,   285,   127,
   154,   155,    48,   341,    50,    74,    59,   278,   301,   141,
    63,   260,   261,    74,   104,   301,   196,   319,   320,    13,
   310,    65,    74,   236,    13,   404,   174,   104,   104,    38,
    38,    38,   237,   260,   261,    74,    74,   217,   110,   228,
   229,   259,   218,    53,    75,   115,    75,   260,   261,    38,
   241,   241,   216,   122,   425,   114,   244,   123,   250,   426,
   231,   301,    74,   353,    74,   225,   328,   260,   261,   345,
   310,   234,   346,   254,   181,   376,   124,   260,   261,   294,
   136,   295,   350,   260,   261,   296,   297,   298,   125,   113,
    15,   183,    76,   184,   356,   185,   186,    15,   294,    76,
   295,   367,    55,    56,   296,   297,   298,   260,   261,   386,
   132,   415,   257,   133,   272,   131,    15,   258,    76,   187,
   188,   332,   260,   261,   260,   261,   187,   188,   290,   428,
    62,   140,    74,    74,   368,    66,    74,   293,   277,   219,
    67,   134,   260,   261,   222,   187,   188,    15,   311,   144,
   196,   313,   284,   145,   299,   271,   282,   308,   260,   261,
   146,   283,   183,    76,   184,   300,   185,   186,   134,   169,
   267,   135,   268,   299,   286,   329,   330,   352,   335,   287,
   294,   147,   295,   260,   261,   148,   296,   297,   298,   325,
   187,   188,    76,   134,   214,   333,   139,   336,    15,   152,
    76,   343,   343,    74,   347,   308,    55,    56,   161,   338,
   360,   128,   308,   300,   339,   260,   261,   183,    76,   184,
   300,   185,   186,   269,   374,   270,   359,   187,   188,   260,
   261,   361,   134,   372,   385,   142,   355,   366,   171,   260,
   261,   172,   363,   104,   369,   187,   188,   364,    14,   265,
   266,    74,   161,    14,   393,   299,   153,   394,   308,   161,
   393,   157,    15,   397,    76,   164,   300,   104,   373,   158,
   392,   393,   377,   163,   414,    74,   159,   279,    77,   280,
    49,   387,   104,    78,    79,   212,   416,   167,    80,   134,
    74,   409,   260,   261,    81,   215,    82,   423,   168,    45,
    46,   403,   220,    83,    84,   406,   400,   388,   408,   230,
   420,   358,   314,   315,   424,     4,    85,    86,   427,   233,
   104,    15,   413,    76,   175,   176,   104,   235,    74,   238,
   243,   104,   245,   104,    74,   247,   246,    77,    15,    74,
    76,    74,    78,    79,   256,   248,   167,    80,   321,   322,
   323,   251,   262,    81,    77,    82,   263,   168,   274,    78,
    79,   264,    83,    84,    80,   276,   160,   291,   281,   288,
    81,   309,    82,   292,     4,    85,    86,   349,   326,    83,
    84,    15,   337,    76,   357,   362,   365,-32768,   370,   371,
   382,     4,    85,    86,   391,   396,   395,    77,   331,   398,
   399,   410,    78,    79,   412,   411,   417,    80,   418,   419,
   430,   421,   431,    81,    19,    82,   109,   211,   221,   273,
   177,   327,    83,    84,    15,   226,    76,   249,   312,   129,
   348,   242,   156,   405,     4,    85,    86,   344,   401,     0,
    77,   316,   324,   388,   317,    78,    79,   275,     0,     0,
    80,     0,     0,     0,     0,     0,    81,     0,    82,    15,
     0,    76,     0,     0,     0,    83,    84,     0,     0,     0,
     0,     0,     0,     0,     0,    77,     0,     4,    85,    86,
    78,    79,     0,     0,     0,    80,   179,   180,   181,     0,
   115,    81,     0,    82,     0,     0,     0,     0,   182,     0,
    83,    84,     0,     0,    15,   183,    76,   184,     0,   185,
   186,     0,     4,    85,    86,     0,     0,   179,   180,   181,
     0,   239,     0,     0,     0,     0,     0,     0,     0,   182,
     0,     0,     0,   187,   188,    15,   183,    76,   184,     0,
   185,   186,     0,     0,     0,     0,     0,     0,   179,   180,
   181,     0,     0,     0,     0,     0,   334,     0,     0,     0,
   182,   179,   180,   181,   187,   188,    15,   183,    76,   184,
     0,   185,   186,   182,     0,     0,     0,     0,     0,    15,
   183,    76,   184,     0,   185,   186,     0,     0,     0,     0,
     0,     0,   179,   180,   378,   187,   188,     0,     0,   179,
   180,   181,     0,     0,   182,     0,     0,     0,   187,   188,
    15,   183,    76,   184,     0,   185,   186,    15,   183,    76,
   184,     0,   185,   186,     3,    20,    21,    22,    23,    24,
    25,    26,    27,    28,     4,     0,     0,     0,     0,   187,
   188,     0,     0,     0,     0,     0,   187,   188
};

static const short yycheck[] = {     1,
     2,    45,    46,    87,    40,    63,    41,   182,    28,   302,
   145,   179,   180,     7,     5,     7,    21,     6,    20,    29,
   104,    23,    11,    25,     5,    27,    28,    29,    14,    23,
    21,    23,   365,   117,   118,    45,    46,    95,    40,    59,
   247,     6,    23,    45,    46,    47,     6,    49,    25,    69,
    27,    11,     5,    55,    56,   348,    21,    59,    50,    51,
    58,    63,    60,   396,    66,    11,    64,    69,    78,    79,
    23,    59,    49,    19,    20,     5,    74,    87,     6,    56,
    82,    83,    14,    77,    14,    87,     5,   222,   295,    66,
     5,    19,    20,    95,   104,   302,   124,   265,   266,     0,
     6,    36,   104,     5,     5,    11,   116,   117,   118,    10,
    11,    12,    14,    19,    20,   117,   118,     6,    14,   147,
   148,    13,    11,   125,   144,     7,   146,    19,    20,    30,
   158,   159,   134,    14,     6,   171,   164,    14,   173,    11,
   150,   348,   144,   318,   146,   280,   281,    19,    20,    11,
     6,   153,    14,   181,     5,   362,     5,    19,    20,     3,
   218,     5,     6,    19,    20,     9,    10,    11,    11,   171,
    21,    22,    23,    24,     6,    26,    27,    21,     3,    23,
     5,     6,     9,    10,     9,    10,    11,    19,    20,     6,
    11,     6,     6,    14,   214,   215,    21,    11,    23,    50,
    51,   285,    19,    20,    19,    20,    50,    51,   236,     6,
   212,    14,   214,   215,   349,     9,   218,   245,   220,     9,
    14,    11,    19,    20,     4,    50,    51,    21,   256,    11,
   258,   259,    13,     9,    78,   212,     6,   247,    19,    20,
    11,    11,    22,    23,    24,   247,    26,    27,    11,   333,
     7,    14,     9,    78,     6,   283,   284,    13,   286,    11,
     3,     5,     5,    19,    20,     5,     9,    10,    11,     6,
    50,    51,    23,    11,    11,   285,    14,   287,    21,    14,
    23,   291,   292,   285,   294,   295,     9,    10,   372,     6,
    14,    14,   302,   295,    11,    19,    20,    22,    23,    24,
   302,    26,    27,     8,    14,    10,   334,    50,    51,    19,
    20,   339,    11,   357,    14,    14,   326,   345,    11,    19,
    20,    14,     6,   333,   352,    50,    51,    11,     0,     3,
     4,   333,   416,     5,    11,    78,     5,    14,   348,   423,
    11,    14,    21,    14,    23,    12,   348,   357,   358,     5,
   378,    11,   362,    14,    14,   357,     5,     9,    37,    11,
     5,   371,   372,    42,    43,     9,   410,    46,    47,    11,
   372,   399,    19,    20,    53,     5,    55,   421,    57,    11,
    12,   391,    11,    62,    63,   395,    39,    40,   398,    11,
   418,    11,   260,   261,   422,    74,    75,    76,   426,    14,
   410,    21,   404,    23,   117,   118,   416,    14,   410,    14,
    14,   421,    11,   423,   416,     5,    14,    37,    21,   421,
    23,   423,    42,    43,     5,    14,    46,    47,   267,   268,
   269,    14,    17,    53,    37,    55,    16,    57,    14,    42,
    43,    18,    62,    63,    47,    14,    49,    11,     7,     6,
    53,     6,    55,    11,    74,    75,    76,    81,    12,    62,
    63,    21,    14,    23,    14,    12,     6,    18,     6,    11,
    49,    74,    75,    76,    11,     6,    12,    37,    38,    11,
     5,    14,    42,    43,    14,    41,    14,    47,    12,    38,
     0,    14,     0,    53,     5,    55,    30,   125,   144,   215,
   119,   280,    62,    63,    21,   146,    23,   171,   258,    57,
   295,   159,    83,   393,    74,    75,    76,   292,   389,    -1,
    37,   262,   270,    40,   263,    42,    43,   218,    -1,    -1,
    47,    -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    21,
    -1,    23,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    37,    -1,    74,    75,    76,
    42,    43,    -1,    -1,    -1,    47,     3,     4,     5,    -1,
     7,    53,    -1,    55,    -1,    -1,    -1,    -1,    15,    -1,
    62,    63,    -1,    -1,    21,    22,    23,    24,    -1,    26,
    27,    -1,    74,    75,    76,    -1,    -1,     3,     4,     5,
    -1,     7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    15,
    -1,    -1,    -1,    50,    51,    21,    22,    23,    24,    -1,
    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
     5,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
    15,     3,     4,     5,    50,    51,    21,    22,    23,    24,
    -1,    26,    27,    15,    -1,    -1,    -1,    -1,    -1,    21,
    22,    23,    24,    -1,    26,    27,    -1,    -1,    -1,    -1,
    -1,    -1,     3,     4,     5,    50,    51,    -1,    -1,     3,
     4,     5,    -1,    -1,    15,    -1,    -1,    -1,    50,    51,
    21,    22,    23,    24,    -1,    26,    27,    21,    22,    23,
    24,    -1,    26,    27,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    -1,    -1,    -1,    -1,    50,
    51,    -1,    -1,    -1,    -1,    -1,    50,    51
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 170 "f2jparse.y"
{
            AST *temp, *prev, *commentList = NULL;

            if(debug)
              printf("F2java -> Sourcecodes\n");
	    yyval.ptnode = addnode();
	    yyval.ptnode = switchem(yyvsp[0].ptnode);

#if VCG
            if(emittem) start_vcg(yyval.ptnode);
#endif
            prev = NULL;
            for(temp=yyval.ptnode;temp!=NULL;temp=temp->nextstmt)
            {
              if(emittem) {

                if(temp->nodetype == Comment)
                {
                  if((prev == NULL) ||
                     ((prev != NULL) && (prev->nodetype != Comment)))
                    commentList = temp;
                }
                else
                {
                  /* commentList may be NULL here so we must check
                   * for that in codegen.
                   */
                  temp->astnode.source.prologComments = commentList;

                  typecheck(temp);

                  if(omitWrappers)
                    optScalar(temp);

                  emit(temp);

                  commentList = NULL;
                }
              }
              prev = temp;
            }
          ;
    break;}
case 2:
#line 215 "f2jparse.y"
{
                 AST *temp;

                 if(debug)
                   printf("Sourcecodes -> Sourcecode\n"); 
                 yyval.ptnode=yyvsp[0].ptnode;

                 /* insert the name of the program unit into the
                  * global function table.  this will allow optScalar()
                  * to easily get a pointer to a function. 
                  */

                 if(omitWrappers && (yyvsp[0].ptnode->nodetype != Comment)) {
                   temp = yyvsp[0].ptnode->astnode.source.progtype->astnode.source.name;

                   type_insert(global_func_table, yyvsp[0].ptnode, 0, temp->astnode.ident.name);
                 }
               ;
    break;}
case 3:
#line 234 "f2jparse.y"
{
                 AST *temp;

                 if(debug)
                   printf("Sourcecodes -> Sourcecodes Sourcecode\n");
                 yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode; 
                 yyval.ptnode=yyvsp[0].ptnode;

                 /* insert the name of the program unit into the
                  * global function table.  this will allow optScalar()
                  * to easily get a pointer to a function. 
                  */

                 if(omitWrappers && (yyvsp[0].ptnode->nodetype != Comment)) {
                   temp = yyvsp[0].ptnode->astnode.source.progtype->astnode.source.name;

                   type_insert(global_func_table, yyvsp[0].ptnode, 0, temp->astnode.ident.name);
                 }
               ;
    break;}
case 4:
#line 256 "f2jparse.y"
{ 
                  if(debug)
                    printf("Sourcecode -> Fprogram\n"); 
                  yyval.ptnode=yyvsp[0].ptnode;
                ;
    break;}
case 5:
#line 262 "f2jparse.y"
{ 
                  if(debug)
                    printf("Sourcecode -> Fsubroutine\n"); 
                  yyval.ptnode=yyvsp[0].ptnode;
                ;
    break;}
case 6:
#line 268 "f2jparse.y"
{ 
                  if(debug)
                    printf("Sourcecode -> Ffunction\n"); 
                  yyval.ptnode=yyvsp[0].ptnode;
                ;
    break;}
case 7:
#line 274 "f2jparse.y"
{ 
                  if(debug)
                    printf("Sourcecode -> Comment\n"); 
                  yyval.ptnode=yyvsp[0].ptnode;
                ;
    break;}
case 8:
#line 282 "f2jparse.y"
{
                if(debug)
                  printf("Fprogram -> Program  Specstmts  Statements End\n");

                yyval.ptnode = addnode();

                /* store the tables built during parsing into the
                 * AST node for access during code generation.
                 */

                yyval.ptnode->astnode.source.type_table = type_table;
                yyval.ptnode->astnode.source.external_table = external_table;
                yyval.ptnode->astnode.source.intrinsic_table = intrinsic_table;
                yyval.ptnode->astnode.source.args_table = args_table;
                yyval.ptnode->astnode.source.array_table = array_table; 
                yyval.ptnode->astnode.source.format_table = format_table; 
                yyval.ptnode->astnode.source.data_table = data_table; 
                yyval.ptnode->astnode.source.save_table = save_table; 
                yyval.ptnode->astnode.source.common_table = common_table; 
                yyval.ptnode->astnode.source.parameter_table = parameter_table; 
                yyval.ptnode->astnode.source.constants_table = constants_table;
                yyval.ptnode->astnode.source.equivalences = equivList; 

                yyval.ptnode->astnode.source.javadocComments = NULL; 

                /* initialize some values in this node */

                yyval.ptnode->astnode.source.needs_input = FALSE;
                yyval.ptnode->astnode.source.needs_reflection = FALSE;
                yyval.ptnode->astnode.source.needs_blas = FALSE;

                if(omitWrappers)
                  yyval.ptnode->astnode.source.scalarOptStatus = NOT_VISITED;

	        yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                yyval.ptnode->nodetype = Progunit;
                yyval.ptnode->astnode.source.progtype = yyvsp[-3].ptnode;
                yyval.ptnode->astnode.source.typedecs = yyvsp[-2].ptnode;
                yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
                yyval.ptnode->astnode.source.statements = switchem(yyvsp[0].ptnode);

                /* a PROGRAM has no args, so set the symbol table
                   to NULL */
                args_table = NULL;  
              ;
    break;}
case 9:
#line 334 "f2jparse.y"
{
                HASHNODE *ht;
                AST *temp;

                if(debug)
                  printf("Fsubroutine -> Subroutine Specstmts Statements End\n");
                yyval.ptnode = addnode();
	        yyvsp[-3].ptnode->parent = yyval.ptnode; 
	        yyvsp[-2].ptnode->parent = yyval.ptnode;
	        yyvsp[-1].ptnode->parent = yyval.ptnode;
	        yyvsp[0].ptnode->parent = yyval.ptnode;
                yyval.ptnode->nodetype = Progunit;
                yyval.ptnode->astnode.source.progtype = yyvsp[-3].ptnode;

                /* store the tables built during parsing into the
                 * AST node for access during code generation.
                 */

                yyval.ptnode->astnode.source.type_table = type_table;
                yyval.ptnode->astnode.source.external_table = external_table;
                yyval.ptnode->astnode.source.intrinsic_table = intrinsic_table;
                yyval.ptnode->astnode.source.args_table = args_table;
                yyval.ptnode->astnode.source.array_table = array_table; 
                yyval.ptnode->astnode.source.format_table = format_table; 
                yyval.ptnode->astnode.source.data_table = data_table; 
                yyval.ptnode->astnode.source.save_table = save_table; 
                yyval.ptnode->astnode.source.common_table = common_table; 
                yyval.ptnode->astnode.source.parameter_table = parameter_table; 
                yyval.ptnode->astnode.source.constants_table = constants_table;
                yyval.ptnode->astnode.source.equivalences = equivList; 

                yyval.ptnode->astnode.source.javadocComments = NULL; 

                /* initialize some values in this node */

                yyval.ptnode->astnode.source.needs_input = FALSE;
                yyval.ptnode->astnode.source.needs_reflection = FALSE;
                yyval.ptnode->astnode.source.needs_blas = FALSE;

                if(omitWrappers)
                  yyval.ptnode->astnode.source.scalarOptStatus = NOT_VISITED;

                yyval.ptnode->astnode.source.typedecs = yyvsp[-2].ptnode;
                yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
                yyval.ptnode->astnode.source.statements = switchem(yyvsp[0].ptnode);

                /* foreach arg to this program unit, store the array 
                 * size, if applicable, from the hash table into the
                 * node itself.
                 */

                for(temp=yyvsp[-3].ptnode->astnode.source.args;temp!=NULL;temp=temp->nextstmt)
                {
                  if((ht=type_lookup(type_table,temp->astnode.ident.name)) != NULL)
                  {
                    temp->vartype=ht->variable->vartype;
                    temp->astnode.ident.arraylist=ht->variable->astnode.ident.arraylist;
                  }
                }

                type_insert(function_table, yyvsp[-3].ptnode, 0,
                   yyvsp[-3].ptnode->astnode.source.name->astnode.ident.name);
              ;
    break;}
case 10:
#line 400 "f2jparse.y"
{
                HASHNODE *ht;
                AST *temp;

                if(debug)
                  printf("Ffunction ->   Function Specstmts Statements  End\n");

                yyval.ptnode = addnode();

                /* store the tables built during parsing into the
                 * AST node for access during code generation.
                 */

                yyval.ptnode->astnode.source.type_table = type_table;
                yyval.ptnode->astnode.source.external_table = external_table;
                yyval.ptnode->astnode.source.intrinsic_table = intrinsic_table;
                yyval.ptnode->astnode.source.args_table = args_table;
                yyval.ptnode->astnode.source.array_table = array_table; 
                yyval.ptnode->astnode.source.format_table = format_table; 
                yyval.ptnode->astnode.source.data_table = data_table; 
                yyval.ptnode->astnode.source.save_table = save_table; 
                yyval.ptnode->astnode.source.common_table = common_table; 
                yyval.ptnode->astnode.source.parameter_table = parameter_table; 
                yyval.ptnode->astnode.source.constants_table = constants_table;
                yyval.ptnode->astnode.source.equivalences = equivList; 

                yyval.ptnode->astnode.source.javadocComments = NULL; 

                /* initialize some values in this node */

                yyval.ptnode->astnode.source.needs_input = FALSE;
                yyval.ptnode->astnode.source.needs_reflection = FALSE;
                yyval.ptnode->astnode.source.needs_blas = FALSE;
                if(omitWrappers)
                  yyval.ptnode->astnode.source.scalarOptStatus = NOT_VISITED;

	        yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                yyval.ptnode->nodetype = Progunit;
                yyval.ptnode->astnode.source.progtype = yyvsp[-3].ptnode;
                yyval.ptnode->astnode.source.typedecs = yyvsp[-2].ptnode;
		yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
                yyval.ptnode->astnode.source.statements = switchem(yyvsp[0].ptnode);

                /* foreach arg to this program unit, store the array 
                 * size, if applicable, from the hash table into the
                 * node itself.
                 */

                for(temp=yyvsp[-3].ptnode->astnode.source.args;temp!=NULL;temp=temp->nextstmt)
                {
                  if((ht=type_lookup(type_table,temp->astnode.ident.name)) != NULL)
                  {
                    temp->vartype=ht->variable->vartype;
                    temp->astnode.ident.arraylist=ht->variable->astnode.ident.arraylist;
                  }
                }

                type_insert(function_table, yyvsp[-3].ptnode, 0,
                  yyvsp[-3].ptnode->astnode.source.name->astnode.ident.name);
              ;
    break;}
case 11:
#line 466 "f2jparse.y"
{
                 if(debug)
                   printf("Program ->  PROGRAM Name\n");

                 yyval.ptnode = addnode();
	         yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
		 lowercase(yyvsp[-1].ptnode->astnode.ident.name);
		 yyval.ptnode->astnode.source.name = yyvsp[-1].ptnode;
                 yyval.ptnode->nodetype = Program;
                 yyval.ptnode->token = PROGRAM;
                 yyval.ptnode->astnode.source.args = NULL;

                 init_tables();

                 fprintf(stderr," MAIN %s:\n",yyvsp[-1].ptnode->astnode.ident.name);
              ;
    break;}
case 12:
#line 485 "f2jparse.y"
{
                 if(debug)
                   printf("Subroutine ->  SUBROUTINE Name Functionargs NL\n");

                 yyval.ptnode = addnode();
                 yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                 if(yyvsp[-1].ptnode != NULL)
                   yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */

        /*         lowercase($2->astnode.ident.name);
                      commented out 11-7-97 - Keith */

                 yyval.ptnode->astnode.source.name = yyvsp[-2].ptnode; 
                 yyval.ptnode->nodetype = Subroutine;
                 yyval.ptnode->token = SUBROUTINE;
                 if(yyvsp[-1].ptnode == NULL)
                   yyval.ptnode->astnode.source.args = NULL;
                 else
                   yyval.ptnode->astnode.source.args = switchem(yyvsp[-1].ptnode);

                 fprintf(stderr,"\t%s:\n",yyvsp[-2].ptnode->astnode.ident.name);
              ;
    break;}
case 13:
#line 508 "f2jparse.y"
{
                 if(debug)
                   printf("Subroutine ->  SUBROUTINE Name NL\n");

                 init_tables();
                 yyval.ptnode = addnode();
                 yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */

        /*         lowercase($2->astnode.ident.name);  
                       commented out 11-7-97 - Keith */
                 yyval.ptnode->astnode.source.name = yyvsp[-1].ptnode; 
                 yyval.ptnode->nodetype = Subroutine;
                 yyval.ptnode->token = SUBROUTINE;
                 yyval.ptnode->astnode.source.args = NULL;
                 fprintf(stderr,"\t%s:\n",yyvsp[-1].ptnode->astnode.ident.name);
              ;
    break;}
case 14:
#line 527 "f2jparse.y"
{
             HASHNODE *hash_entry;

             if(debug)
               printf("Function ->  Type FUNCTION Name Functionargs NL\n");
             yyval.ptnode = addnode();

  	     yyvsp[-2].ptnode->parent = yyval.ptnode;  /* 9-4-97 - Keith */
             if(yyvsp[-1].ptnode != NULL)
               yyvsp[-1].ptnode->parent = yyval.ptnode;  /* 9-4-97 - Keith */
             yyval.ptnode->astnode.source.name = yyvsp[-2].ptnode;
             yyval.ptnode->nodetype = Function;
             yyval.ptnode->token = FUNCTION;
             yyval.ptnode->astnode.source.returns = yyvsp[-4].type;
             yyval.ptnode->vartype = yyvsp[-4].type;
             if(yyvsp[-1].ptnode == NULL)
               yyval.ptnode->astnode.source.args = NULL;
             else 
               yyval.ptnode->astnode.source.args = switchem(yyvsp[-1].ptnode);

             /* since the function name is the implicit return value
              * and it can be treated as a variable, we insert it into
              * the hash table for lookup later.
              */

             hash_entry = type_lookup(type_table,yyvsp[-2].ptnode->astnode.ident.name);

             if(hash_entry == NULL)
               yyvsp[-2].ptnode->vartype = yyvsp[-4].type;
             else
               yyvsp[-2].ptnode->vartype = hash_entry->variable->vartype;

             type_insert(type_table, yyvsp[-2].ptnode, yyvsp[-2].ptnode->vartype, yyvsp[-2].ptnode->astnode.ident.name);

             fprintf(stderr,"\t%s:\n",yyvsp[-2].ptnode->astnode.ident.name);
           ;
    break;}
case 15:
#line 566 "f2jparse.y"
{
             yyvsp[0].ptnode = switchem(yyvsp[0].ptnode);
             type_hash(yyvsp[0].ptnode); 
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 16:
#line 574 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 17:
#line 578 "f2jparse.y"
{ 
             yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode; 
             yyval.ptnode = yyvsp[0].ptnode; 
           ;
    break;}
case 18:
#line 585 "f2jparse.y"
{
	     yyval.ptnode = yyvsp[0].ptnode;
	   ;
    break;}
case 19:
#line 589 "f2jparse.y"
{
	     yyval.ptnode = yyvsp[0].ptnode;
	   ;
    break;}
case 20:
#line 593 "f2jparse.y"
{
	     yyval.ptnode = yyvsp[0].ptnode;
	   ;
    break;}
case 21:
#line 597 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 22:
#line 601 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 23:
#line 605 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 24:
#line 609 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 25:
#line 613 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 26:
#line 617 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 27:
#line 621 "f2jparse.y"
{
             yyval.ptnode=yyvsp[-1].ptnode;
           ;
    break;}
case 28:
#line 625 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode;
	   ;
    break;}
case 29:
#line 631 "f2jparse.y"
{
             yyval.ptnode = addnode();
             yyvsp[-1].ptnode->parent = yyval.ptnode;
             yyvsp[-1].ptnode = switchem(yyvsp[-1].ptnode);
             yyval.ptnode->nodetype = Dimension;

             yyval.ptnode->astnode.typeunit.declist = yyvsp[-1].ptnode;
           ;
    break;}
case 30:
#line 642 "f2jparse.y"
{
                yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Dimension;
              ;
    break;}
case 31:
#line 648 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Dimension;
              ;
    break;}
case 32:
#line 659 "f2jparse.y"
{
                   yyval.ptnode = addnode();
                   yyval.ptnode->nodetype = Equivalence;
                   yyval.ptnode->prevstmt = NULL;
                   yyval.ptnode->nextstmt = NULL;
                   yyval.ptnode->astnode.equiv.nlist = switchem(yyvsp[-1].ptnode);
                 ;
    break;}
case 33:
#line 669 "f2jparse.y"
{
                   AST *tmp;

                   yyval.ptnode = addnode();
                   yyval.ptnode->nodetype = Equivalence;
                   yyval.ptnode->prevstmt = NULL;
                   yyval.ptnode->nextstmt = NULL;
                   yyval.ptnode->astnode.equiv.clist = switchem(yyvsp[-1].ptnode);

                   for(tmp=yyvsp[-1].ptnode;tmp!=NULL;tmp=tmp->prevstmt)
                     tmp->parent = yyval.ptnode;

                   addEquiv(yyval.ptnode->astnode.equiv.clist);
                 ;
    break;}
case 34:
#line 684 "f2jparse.y"
{
                   AST *tmp;

                   yyval.ptnode = addnode();
                   yyval.ptnode->nodetype = Equivalence;
                   yyval.ptnode->astnode.equiv.clist = switchem(yyvsp[-1].ptnode);
                   yyval.ptnode->prevstmt = yyvsp[-4].ptnode;
                   yyval.ptnode->nextstmt = NULL;

                   for(tmp=yyvsp[-1].ptnode;tmp!=NULL;tmp=tmp->prevstmt)
                     tmp->parent = yyval.ptnode;

                   addEquiv(yyval.ptnode->astnode.equiv.clist);
                 ;
    break;}
case 35:
#line 701 "f2jparse.y"
{
                   yyval.ptnode = yyvsp[0].ptnode;
                 ;
    break;}
case 36:
#line 705 "f2jparse.y"
{
                   yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
                   yyval.ptnode = yyvsp[0].ptnode;
                 ;
    break;}
case 37:
#line 712 "f2jparse.y"
{
          yyval.ptnode = addnode();
          yyval.ptnode->nodetype = CommonList;
          yyval.ptnode->astnode.common.name = NULL;

          yyval.ptnode->astnode.common.nlist = switchem(yyvsp[-1].ptnode);
          merge_common_blocks(yyval.ptnode->astnode.common.nlist);
        ;
    break;}
case 38:
#line 723 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 39:
#line 727 "f2jparse.y"
{
              yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 40:
#line 734 "f2jparse.y"
{
              AST *temp;
              int pos;

              yyval.ptnode = addnode();
              yyval.ptnode->nodetype = Common;
              yyval.ptnode->astnode.common.name = strdup(yyvsp[-2].ptnode->astnode.ident.name);
              yyval.ptnode->astnode.common.nlist = switchem(yyvsp[0].ptnode);

              pos = 0;

              /* foreach variable in the COMMON block... */
              for(temp=yyval.ptnode->astnode.common.nlist;temp!=NULL;temp=temp->nextstmt)
              {
                temp->astnode.ident.commonBlockName = 
                  strdup(yyvsp[-2].ptnode->astnode.ident.name);

                if(omitWrappers)
                  temp->astnode.ident.position = pos++;

                /* insert this name into the common table */
                if(debug)
                  printf("@insert %s (block = %s) into common table\n",
                    temp->astnode.ident.name, yyvsp[-2].ptnode->astnode.ident.name);

                type_insert(common_table, temp, Float, temp->astnode.ident.name);
              }

              type_insert(global_common_table, yyval.ptnode, Float, yyval.ptnode->astnode.common.name);
           ;
    break;}
case 41:
#line 765 "f2jparse.y"
{
              AST *temp;

              /* This is an unnamed common block */

              yyval.ptnode = addnode();
              yyval.ptnode->nodetype = Common;
              yyval.ptnode->astnode.common.name = strdup("Blank");
              yyval.ptnode->astnode.common.nlist = switchem(yyvsp[0].ptnode);

              /* foreach variable in the COMMON block... */
              for(temp=yyvsp[0].ptnode;temp!=NULL;temp=temp->prevstmt) {
                temp->astnode.ident.commonBlockName = "Blank";

                /* insert this name into the common table */

                if(debug)
                  printf("@@insert %s (block = unnamed) into common table\n",
                    temp->astnode.ident.name);

                type_insert(common_table, temp, Float, temp->astnode.ident.name);
              }

              type_insert(global_common_table, yyval.ptnode, Float, yyval.ptnode->astnode.common.name);
           ;
    break;}
case 42:
#line 795 "f2jparse.y"
{
         /*
          * I think in this case every variable is supposed to
          * be saved, but we already emit every variable as
          * static.  do nothing here.  --Keith
          */

         yyval.ptnode = addnode();
         yyval.ptnode->nodetype = Save;
       ;
    break;}
case 43:
#line 806 "f2jparse.y"
{
             AST *temp;

             yyval.ptnode = addnode();
             yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             yyval.ptnode->nodetype = Save;

             for(temp=yyvsp[-2].ptnode;temp!=NULL;temp=temp->prevstmt) {
               if(debug)
                 printf("@@insert %s into save table\n",
                    temp->astnode.ident.name);

               type_insert(save_table, temp, Float, temp->astnode.ident.name);
             }
	   ;
    break;}
case 44:
#line 822 "f2jparse.y"
{
             AST *temp;

             yyval.ptnode = addnode();
             yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             yyval.ptnode->nodetype = Save;

             for(temp=yyvsp[-1].ptnode;temp!=NULL;temp=temp->prevstmt) {
               if(debug)
                 printf("@@insert %s into save table\n",
                    temp->astnode.ident.name);

               type_insert(save_table, temp, Float, temp->astnode.ident.name);
             }
	   ;
    break;}
case 45:
#line 839 "f2jparse.y"
{
	      yyval.ptnode=0;
	      fprintf(stderr,"Must use IMPLICIT NONE.\n");
	      exit(-1);
	    ;
    break;}
case 46:
#line 845 "f2jparse.y"
{
	      yyval.ptnode=addnode();
	      yyval.ptnode->nodetype = Specification;
	      yyval.ptnode->token = IMPLICIT;
	      yyval.ptnode = 0;
	    ;
    break;}
case 47:
#line 855 "f2jparse.y"
{
              /* $$ = $2; */
              yyval.ptnode = addnode();
              yyval.ptnode->nodetype = DataList;
              yyval.ptnode->astnode.label.stmt = yyvsp[0].ptnode;
            ;
    break;}
case 48:
#line 864 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 49:
#line 868 "f2jparse.y"
{
              yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 50:
#line 875 "f2jparse.y"
{
              AST *temp;

              yyval.ptnode = addnode();
              yyval.ptnode->astnode.data.nlist = switchem(yyvsp[-3].ptnode);
              yyval.ptnode->astnode.data.clist = switchem(yyvsp[-1].ptnode);

              yyval.ptnode->nodetype = DataStmt;
              yyval.ptnode->prevstmt = NULL;
              yyval.ptnode->nextstmt = NULL;

              for(temp=yyvsp[-3].ptnode;temp!=NULL;temp=temp->prevstmt) {
                if(debug)
                  printf("@@insert %s into data table\n",
                     temp->astnode.ident.name);
                
                temp->parent = yyval.ptnode;

                if(temp->nodetype == DataImpliedLoop)
                  type_insert(data_table, temp, Float,
                     temp->astnode.forloop.Label->astnode.ident.name);
                else
                  type_insert(data_table, temp, Float, temp->astnode.ident.name);
              }
            ;
    break;}
case 51:
#line 903 "f2jparse.y"
{
                     yyval.ptnode = yyvsp[0].ptnode;
                   ;
    break;}
case 52:
#line 907 "f2jparse.y"
{
                     yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
                     yyval.ptnode = yyvsp[0].ptnode;
                   ;
    break;}
case 53:
#line 914 "f2jparse.y"
{
                 yyval.ptnode = yyvsp[0].ptnode;
               ;
    break;}
case 54:
#line 918 "f2jparse.y"
{
                 prepend_minus(yyvsp[0].ptnode->astnode.constant.number);
                 yyval.ptnode = yyvsp[0].ptnode;
               ;
    break;}
case 55:
#line 923 "f2jparse.y"
{
                 yyval.ptnode = yyvsp[-2].ptnode;
                 yyval.ptnode=addnode();
                 yyval.ptnode->nodetype = Binaryop;
                 yyval.ptnode->token = STAR;
                 yyvsp[-2].ptnode->expr_side = left;
                 yyvsp[0].ptnode->expr_side = right;
                 yyvsp[-2].ptnode->parent = yyval.ptnode;
                 yyvsp[0].ptnode->parent = yyval.ptnode;
                 yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
                 yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
                 yyval.ptnode->astnode.expression.optype = '*';
               ;
    break;}
case 56:
#line 939 "f2jparse.y"
{
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 57:
#line 943 "f2jparse.y"
{
            yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 58:
#line 950 "f2jparse.y"
{
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 59:
#line 954 "f2jparse.y"
{
            yyvsp[-1].ptnode->astnode.forloop.counter = yyvsp[-3].ptnode;
            yyvsp[-1].ptnode->astnode.forloop.Label = yyvsp[-5].ptnode;
            yyval.ptnode = yyvsp[-1].ptnode;
            yyvsp[-5].ptnode->parent = yyval.ptnode;
            yyvsp[-3].ptnode->parent = yyval.ptnode;
          ;
    break;}
case 60:
#line 964 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyvsp[-2].ptnode->parent = yyval.ptnode;
               yyvsp[0].ptnode->parent = yyval.ptnode;
               yyval.ptnode->nodetype = DataImpliedLoop;
               yyval.ptnode->astnode.forloop.start = yyvsp[-2].ptnode;
               yyval.ptnode->astnode.forloop.stop = yyvsp[0].ptnode;
               yyval.ptnode->astnode.forloop.incr = NULL;
             ;
    break;}
case 61:
#line 974 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyvsp[-4].ptnode->parent = yyval.ptnode;
               yyvsp[-2].ptnode->parent = yyval.ptnode;
               yyvsp[0].ptnode->parent = yyval.ptnode;
               yyval.ptnode->nodetype = DataImpliedLoop;
               yyval.ptnode->astnode.forloop.start = yyvsp[-4].ptnode;
               yyval.ptnode->astnode.forloop.stop = yyvsp[-2].ptnode;
               yyval.ptnode->astnode.forloop.incr = yyvsp[0].ptnode;
             ;
    break;}
case 62:
#line 993 "f2jparse.y"
{  
                 yyval.ptnode = yyvsp[0].ptnode; 
               ;
    break;}
case 63:
#line 997 "f2jparse.y"
{ 
                 yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode; 
                 yyval.ptnode = yyvsp[0].ptnode; 
               ;
    break;}
case 64:
#line 1004 "f2jparse.y"
{
                yyval.ptnode = yyvsp[-1].ptnode;
                yyval.ptnode->nodetype = Assignment;   
              ;
    break;}
case 65:
#line 1009 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Call;
              ;
    break;}
case 66:
#line 1014 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Logicalif;
              ;
    break;}
case 67:
#line 1019 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Arithmeticif;
              ;
    break;}
case 68:
#line 1024 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Blockif;
              ;
    break;}
case 69:
#line 1029 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Forloop;
              ;
    break;}
case 70:
#line 1034 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Return;
              ;
    break;}
case 71:
#line 1039 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = ComputedGoto;
              ;
    break;}
case 72:
#line 1044 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Goto;
              ;
    break;}
case 73:
#line 1049 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Label;
              ;
    break;}
case 74:
#line 1054 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Label;
              ;
    break;}
case 75:
#line 1059 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Write;
              ;
    break;}
case 76:
#line 1064 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Read;
              ;
    break;}
case 77:
#line 1069 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Stop;
              ;
    break;}
case 78:
#line 1074 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Unimplemented;
              ;
    break;}
case 79:
#line 1079 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Comment;
              ;
    break;}
case 80:
#line 1084 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Unimplemented;
              ;
    break;}
case 81:
#line 1091 "f2jparse.y"
{
           yyval.ptnode = addnode();
           yyval.ptnode->token = COMMENT;
           yyval.ptnode->nodetype = Comment;
           yyval.ptnode->astnode.ident.len = 0;
           strcpy(yyval.ptnode->astnode.ident.name, yylval.lexeme);
         ;
    break;}
case 82:
#line 1101 "f2jparse.y"
{
          fprintf(stderr,"WArning: CLOSE not implemented.\n");
          yyval.ptnode = yyvsp[-2].ptnode;
        ;
    break;}
case 83:
#line 1108 "f2jparse.y"
{
          fprintf(stderr,"Warning: REWIND not implemented.\n");
          yyval.ptnode = yyvsp[-1].ptnode;
        ;
    break;}
case 84:
#line 1115 "f2jparse.y"
{
          yyval.ptnode = addnode();
          yyval.ptnode->token = END;
          yyval.ptnode->nodetype = End;
        ;
    break;}
case 85:
#line 1130 "f2jparse.y"
{
                  yyvsp[-1].ptnode = switchem(yyvsp[-1].ptnode);
                  init_tables();
		  arg_table_load(yyvsp[-1].ptnode);
                  yyval.ptnode = yyvsp[-1].ptnode;
                ;
    break;}
case 86:
#line 1137 "f2jparse.y"
{
                  init_tables();
                  yyval.ptnode = NULL;
                ;
    break;}
case 87:
#line 1145 "f2jparse.y"
{
              yyval.ptnode=yyvsp[0].ptnode;
            ;
    break;}
case 88:
#line 1149 "f2jparse.y"
{
              yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode; 
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 89:
#line 1163 "f2jparse.y"
{
                 AST *temp;

                 yyval.ptnode = addnode();
	         yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                 /* store_local_var($2);  */
                 yyvsp[-1].ptnode = switchem(yyvsp[-1].ptnode);
                 yyval.ptnode->nodetype = Typedec;

                 for(temp = yyvsp[-1].ptnode; temp != NULL; temp = temp->nextstmt)
                 {
                   temp->vartype = yyvsp[-2].type;
                   temp->astnode.ident.len = len;
                 }

                 yyval.ptnode->astnode.typeunit.declist = yyvsp[-1].ptnode;
                 yyval.ptnode->astnode.typeunit.returns = yyvsp[-2].type; 
	       ;
    break;}
case 90:
#line 1185 "f2jparse.y"
{
               yyval.type = yyvsp[0].type;
               len = 1;
             ;
    break;}
case 91:
#line 1190 "f2jparse.y"
{
               yyval.type = yyvsp[-2].type;
               len = atoi(yyvsp[0].ptnode->astnode.constant.number);
             ;
    break;}
case 92:
#line 1195 "f2jparse.y"
{
               yyval.type = yyvsp[-4].type;
               len = 1;
             ;
    break;}
case 93:
#line 1202 "f2jparse.y"
{ 
         yyval.type = yylval.type;
       ;
    break;}
case 94:
#line 1214 "f2jparse.y"
{
               AST *temp;

               temp = addnode();
               temp->nodetype = Typedec;
               yyvsp[0].ptnode->parent = temp;

               yyval.ptnode = yyvsp[0].ptnode;
             ;
    break;}
case 95:
#line 1224 "f2jparse.y"
{
               yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
               yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
               yyval.ptnode = yyvsp[0].ptnode;
             ;
    break;}
case 96:
#line 1232 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 97:
#line 1236 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 98:
#line 1255 "f2jparse.y"
{
           HASHNODE *hashtemp;

           lowercase(yylval.lexeme);

           /* check if the name we're looking at is defined as a parameter.
            * if so, instead of inserting an Identifier node here, we're just
            * going to insert the Constant node that corresponds to
            * the parameter.  normally the only time we'd worry about
            * such a substitution would be when the ident was the lhs
            * of some expression, but that should not happen with parameters.
            * otherwise, get a new AST node initialized with this name.
            */

           if((hashtemp = type_lookup(parameter_table,yylval.lexeme)) != NULL)
             yyval.ptnode = hashtemp->variable; 
           else
             yyval.ptnode = initialize_name(yylval.lexeme);
         ;
    break;}
case 99:
#line 1277 "f2jparse.y"
{
           yyval.ptnode=addnode();
           yyval.ptnode->token = STRING;
           yyval.ptnode->nodetype = Constant;
           strcpy(yyval.ptnode->astnode.constant.number, yylval.lexeme);

           yyval.ptnode->vartype = String;
           if(debug)
             printf("**The string value is %s\n",yyval.ptnode->astnode.constant.number);
         ;
    break;}
case 100:
#line 1288 "f2jparse.y"
{
           yyval.ptnode=addnode();
           yyval.ptnode->token = STRING;
           yyval.ptnode->nodetype = Constant;
           strcpy(yyval.ptnode->astnode.constant.number, yylval.lexeme);

           yyval.ptnode->vartype = String;
           if(debug)
             printf("**The char value is %s\n",yyval.ptnode->astnode.constant.number);
         ;
    break;}
case 101:
#line 1301 "f2jparse.y"
{
                    AST *temp;
                    int count, i;

		    /*
                     *  $$ = addnode();
                     *  $$->nodetype = Identifier;
                     *  strcpy($$->astnode.ident.name, $1->astnode.ident.name);
		     */

		    yyval.ptnode = yyvsp[-3].ptnode;
		    yyval.ptnode->astnode.ident.arraylist = switchem(yyvsp[-1].ptnode);
                  
                    count = 0;
                    for(temp = yyval.ptnode->astnode.ident.arraylist; temp != NULL; 
                        temp=temp->nextstmt)
                      count++;

                    for(temp = yyval.ptnode->astnode.ident.arraylist, i = 0;
                        temp != NULL; 
                        temp=temp->nextstmt, i++)
                    {
                      yyval.ptnode->astnode.ident.D[i] = (int) eval_const_expr(temp);
                      if(temp->nodetype == ArrayIdxRange)
                        printf("@#@# %s dim %d is a range\n",yyval.ptnode->astnode.ident.name,
                           i);
                    }
                       
                    yyval.ptnode->astnode.ident.dim = count;
                    yyval.ptnode->astnode.ident.lead_expr = NULL;
   
                    /* leaddim might be a constant, so check for that.  --keith */
                    if(yyval.ptnode->astnode.ident.arraylist->nodetype == Constant) 
                    {
		      yyval.ptnode->astnode.ident.leaddim = 
                       strdup(yyval.ptnode->astnode.ident.arraylist->astnode.constant.number);
                    }
                    else if((yyval.ptnode->astnode.ident.arraylist->nodetype == Binaryop) ||
                            (yyval.ptnode->astnode.ident.arraylist->nodetype == ArrayIdxRange)) {
		      yyval.ptnode->astnode.ident.lead_expr = yyval.ptnode->astnode.ident.arraylist;
                    } else {
		      yyval.ptnode->astnode.ident.leaddim = 
                       strdup(yyval.ptnode->astnode.ident.arraylist->astnode.ident.name);
                    }

                    if(debug)
                    {
                      printf("leaddim nodetype = %s\n",
                        print_nodetype(yyval.ptnode->astnode.ident.arraylist));

                      if(yyval.ptnode->astnode.ident.leaddim != NULL)
                        printf("setting leaddim = %s\n",yyval.ptnode->astnode.ident.leaddim);
                    }

		    store_array_var(yyval.ptnode);
                  ;
    break;}
case 102:
#line 1359 "f2jparse.y"
{
                    AST *temp;

                    temp = addnode();
                    temp->nodetype = ArrayDec;
                    yyvsp[0].ptnode->parent = temp;

                    yyval.ptnode=yyvsp[0].ptnode;
                  ;
    break;}
case 103:
#line 1369 "f2jparse.y"
{
                    yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode; 
                    yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
                    yyval.ptnode = yyvsp[0].ptnode;
                  ;
    break;}
case 104:
#line 1377 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode; 
           ;
    break;}
case 105:
#line 1381 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 106:
#line 1385 "f2jparse.y"
{
             yyval.ptnode = addnode();
             yyval.ptnode->nodetype = ArrayIdxRange;
             yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
             yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
           ;
    break;}
case 107:
#line 1398 "f2jparse.y"
{
         yyval.ptnode=addnode();
         yyval.ptnode->nodetype = Identifier;
         yyval.ptnode->astnode.ident.lead_expr = NULL;
        *yyval.ptnode->astnode.ident.name = '*';
       ;
    break;}
case 108:
#line 1414 "f2jparse.y"
{ 
                yyval.ptnode = addnode();
                yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                yyval.ptnode->nodetype = Assignment;
                yyval.ptnode->astnode.assignment.lhs = yyvsp[-2].ptnode;
                yyval.ptnode->astnode.assignment.rhs = yyvsp[0].ptnode;
             ;
    break;}
case 109:
#line 1425 "f2jparse.y"
{
           yyval.ptnode=yyvsp[0].ptnode;
           yyval.ptnode->nextstmt = NULL;
           yyval.ptnode->prevstmt = NULL;
         ;
    break;}
case 110:
#line 1431 "f2jparse.y"
{
           /*   Use the following declaration in case we 
            *   need to switch index order. 
            *
            *   HASHNODE * hashtemp;  
            */

           yyval.ptnode = addnode();
           yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
           yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
           yyval.ptnode->nodetype = Identifier;
           yyval.ptnode->astnode.ident.lead_expr = NULL;
           yyval.ptnode->prevstmt = NULL;
           yyval.ptnode->nextstmt = NULL;

           strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-3].ptnode->astnode.ident.name);

           /*  This is in case we want to switch index order later.
            *
            *  hashtemp = type_lookup(array_table, $1->astnode.ident.name);
            *  if(hashtemp)
            *    $$->astnode.ident.arraylist = $3;
            *  else
            *    $$->astnode.ident.arraylist = switchem($3);
            */

           /* We don't switch index order.  */

           yyval.ptnode->astnode.ident.arraylist = switchem(yyvsp[-1].ptnode);
         ;
    break;}
case 111:
#line 1462 "f2jparse.y"
{
           yyval.ptnode=addnode();
           yyvsp[-5].ptnode->parent = yyval.ptnode;
           yyvsp[-3].ptnode->parent = yyval.ptnode;
           yyvsp[-1].ptnode->parent = yyval.ptnode;
           strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-5].ptnode->astnode.ident.name);
           yyval.ptnode->nodetype = Substring;
           yyval.ptnode->token = NAME;
           yyval.ptnode->prevstmt = NULL;
           yyval.ptnode->nextstmt = NULL;
           yyval.ptnode->astnode.ident.arraylist = yyvsp[-3].ptnode;
           yyvsp[-3].ptnode->nextstmt = yyvsp[-1].ptnode;
         ;
    break;}
case 112:
#line 1478 "f2jparse.y"
{ 
                    AST *temp;

                    temp = addnode();
                    temp->nodetype = Identifier;
                    temp->astnode.ident.lead_expr = NULL;
                    yyvsp[0].ptnode->parent = temp;

                    yyval.ptnode = yyvsp[0].ptnode;
                  ;
    break;}
case 113:
#line 1489 "f2jparse.y"
{
                    yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
                    yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
		    yyval.ptnode = yyvsp[0].ptnode;
		  ;
    break;}
case 114:
#line 1501 "f2jparse.y"
{
            yyval.ptnode = yyvsp[0].ptnode;
            yyval.ptnode->nodetype = Forloop;
            yyval.ptnode->astnode.forloop.Label = yyvsp[-1].ptnode;
          ;
    break;}
case 115:
#line 1510 "f2jparse.y"
{ 
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 116:
#line 1515 "f2jparse.y"
{ 
            yyval.ptnode = yyvsp[-1].ptnode;
          ;
    break;}
case 117:
#line 1522 "f2jparse.y"
{
            AST *counter;

            yyval.ptnode = addnode();
	    yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	    yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
            counter = yyval.ptnode->astnode.forloop.counter = yyvsp[-3].ptnode->astnode.assignment.lhs;
            yyval.ptnode->astnode.forloop.start = yyvsp[-3].ptnode;
            yyval.ptnode->astnode.forloop.stop = yyvsp[-1].ptnode;
            yyval.ptnode->astnode.forloop.incr = NULL;
            yyval.ptnode->astnode.forloop.iter_expr = gen_iter_expr(yyvsp[-3].ptnode->astnode.assignment.rhs,yyvsp[-1].ptnode,NULL);
            yyval.ptnode->astnode.forloop.incr_expr = gen_incr_expr(counter,NULL);
          ;
    break;}
case 118:
#line 1536 "f2jparse.y"
{
           AST *counter;

           yyval.ptnode = addnode();
	   yyvsp[-5].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	   yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	   yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
           counter = yyval.ptnode->astnode.forloop.counter = yyvsp[-5].ptnode->astnode.assignment.lhs;
           yyval.ptnode->nodetype = Forloop;
           yyval.ptnode->astnode.forloop.start = yyvsp[-5].ptnode;
           yyval.ptnode->astnode.forloop.stop = yyvsp[-3].ptnode;
           yyval.ptnode->astnode.forloop.incr = yyvsp[-1].ptnode;
           yyval.ptnode->astnode.forloop.iter_expr = gen_iter_expr(yyvsp[-5].ptnode->astnode.assignment.rhs,yyvsp[-3].ptnode,yyvsp[-1].ptnode);
           yyval.ptnode->astnode.forloop.incr_expr = gen_incr_expr(counter,yyvsp[-1].ptnode);
         ;
    break;}
case 119:
#line 1558 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyvsp[-1].ptnode->parent = yyval.ptnode;
         yyvsp[0].ptnode->parent = yyval.ptnode;
         yyval.ptnode->nodetype = Label;
         yyval.ptnode->astnode.label.number = atoi(yyvsp[-1].ptnode->astnode.constant.number);
         yyval.ptnode->astnode.label.stmt = yyvsp[0].ptnode;
       ;
    break;}
case 120:
#line 1567 "f2jparse.y"
{
         HASHNODE *newnode;
         char *tmpLabel;

         tmpLabel = (char *) f2jalloc(10); /* plenty of space for a f77 label num */

         newnode = (HASHNODE *) f2jalloc(sizeof(HASHNODE));

         yyval.ptnode = addnode();
         yyvsp[-2].ptnode->parent = yyval.ptnode;
         yyvsp[-1].ptnode->parent = yyval.ptnode;
         yyval.ptnode->nodetype = Format;
         yyval.ptnode->astnode.label.number = atoi(yyvsp[-2].ptnode->astnode.constant.number);
         yyval.ptnode->astnode.label.stmt = yyvsp[-1].ptnode;
         yyvsp[-1].ptnode->astnode.label.number = yyval.ptnode->astnode.label.number;
         if(debug)
           printf("@@ inserting format line num %d\n",yyval.ptnode->astnode.label.number);

         sprintf(tmpLabel,"%d",yyvsp[-1].ptnode->astnode.label.number);

         type_insert(format_table,yyvsp[-1].ptnode,0,tmpLabel);
       ;
    break;}
case 121:
#line 1595 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->nodetype = Format;
         yyval.ptnode->astnode.label.stmt = switchem(yyvsp[-1].ptnode);
       ;
    break;}
case 122:
#line 1603 "f2jparse.y"
{
             AST *temp;

             temp = addnode();
             temp->nodetype = Format;
             yyvsp[0].ptnode->parent = temp;

             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 123:
#line 1613 "f2jparse.y"
{
             yyvsp[-1].ptnode->nextstmt = yyvsp[0].ptnode;
             yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
             yyvsp[0].ptnode->parent = yyvsp[-1].ptnode->parent;
             if((yyvsp[0].ptnode->token == REPEAT) && (yyvsp[-1].ptnode->token == INTEGER)) {
               yyvsp[0].ptnode->astnode.label.number = atoi(yyvsp[-1].ptnode->astnode.constant.number);

               if(debug)
                 printf("## setting number = %s\n", yyvsp[-1].ptnode->astnode.constant.number);
             }
             if(debug) {
               if(yyvsp[0].ptnode->token == REPEAT)
                 printf("## $2 is repeat token, $1 = %s ##\n",tok2str(yyvsp[-1].ptnode->token));
               if(yyvsp[-1].ptnode->token == REPEAT)
                 printf("## $1 is repeat token, $2 = %s ##\n",tok2str(yyvsp[0].ptnode->token));
             }
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 124:
#line 1635 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 125:
#line 1639 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 126:
#line 1643 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 127:
#line 1649 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = EDIT_DESC;
         strcpy(yyval.ptnode->astnode.ident.name, yylval.lexeme);
       ;
    break;}
case 128:
#line 1655 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 129:
#line 1659 "f2jparse.y"
{
         /* ignore the constant part for now */
         yyval.ptnode = yyvsp[-2].ptnode;
       ;
    break;}
case 130:
#line 1664 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = REPEAT;
         yyval.ptnode->astnode.label.stmt = switchem(yyvsp[-1].ptnode);
         if(debug)
           printf("## setting number = 1\n");
         yyval.ptnode->astnode.label.number = 1;
       ;
    break;}
case 131:
#line 1675 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 132:
#line 1679 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 133:
#line 1686 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = CM;
       ;
    break;}
case 134:
#line 1691 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = DIV;
       ;
    break;}
case 135:
#line 1696 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = CAT;
       ;
    break;}
case 136:
#line 1703 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 137:
#line 1707 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 138:
#line 1722 "f2jparse.y"
{
         yyval.ptnode = addnode();
	 yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	 yyval.ptnode->nodetype = Label;
	 yyval.ptnode->astnode.label.number = atoi(yyvsp[-2].ptnode->astnode.constant.number);
	 yyval.ptnode->astnode.label.stmt = NULL;
       ;
    break;}
case 139:
#line 1732 "f2jparse.y"
{
         AST *temp;

         yyval.ptnode = addnode();
         yyval.ptnode->astnode.io_stmt.io_type = Write;
         yyval.ptnode->astnode.io_stmt.fmt_list = NULL;

         /*  unimplemented
           $$->astnode.io_stmt.file_desc = ;
         */

         if(yyvsp[-3].ptnode->nodetype == Constant)
         {
           if(yyvsp[-3].ptnode->astnode.constant.number[0] == '*') 
             yyval.ptnode->astnode.io_stmt.format_num = -1;
           else if(yyvsp[-3].ptnode->token == STRING) {
             yyval.ptnode->astnode.io_stmt.format_num = -1;
             yyval.ptnode->astnode.io_stmt.fmt_list = yyvsp[-3].ptnode;
           }
           else
             yyval.ptnode->astnode.io_stmt.format_num = atoi(yyvsp[-3].ptnode->astnode.constant.number);
         }
         else
         {
           yyval.ptnode->astnode.io_stmt.format_num = -1;
           yyval.ptnode->astnode.io_stmt.fmt_list = yyvsp[-3].ptnode;
         }
 
         if(yyvsp[-1].ptnode == NULL)
           yyval.ptnode->astnode.io_stmt.arg_list = NULL;
         else 
           yyval.ptnode->astnode.io_stmt.arg_list = switchem(yyvsp[-1].ptnode);

         for(temp=yyval.ptnode->astnode.io_stmt.arg_list;temp!=NULL;temp=temp->nextstmt)
           temp->parent->nodetype = Write;
       ;
    break;}
case 140:
#line 1774 "f2jparse.y"
{
         /* do nothing for now */
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 141:
#line 1779 "f2jparse.y"
{
         /* do nothing for now */
         ;
       ;
    break;}
case 142:
#line 1787 "f2jparse.y"
{
          yyval.ptnode = yyvsp[0].ptnode;
        ;
    break;}
case 143:
#line 1791 "f2jparse.y"
{
          yyval.ptnode = yyvsp[0].ptnode;
        ;
    break;}
case 144:
#line 1795 "f2jparse.y"
{
          yyval.ptnode = addnode();
	  yyval.ptnode->token = INTEGER;
          yyval.ptnode->nodetype = Constant;
          strcpy(yyval.ptnode->astnode.constant.number,"*");
	  yyval.ptnode->vartype = Integer;
        ;
    break;}
case 145:
#line 1803 "f2jparse.y"
{
          yyval.ptnode = addnode();
	  yyval.ptnode->token = INTEGER;
          yyval.ptnode->nodetype = Constant;
          strcpy(yyval.ptnode->astnode.constant.number,"*");
	  yyval.ptnode->vartype = Integer;
        ;
    break;}
case 146:
#line 1811 "f2jparse.y"
{
          yyval.ptnode = yyvsp[0].ptnode;
        ;
    break;}
case 147:
#line 1817 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->astnode.io_stmt.io_type = Read;
         yyval.ptnode->astnode.io_stmt.fmt_list = NULL;
         yyval.ptnode->astnode.io_stmt.end_num = -1;

         if(yyvsp[-1].ptnode == NULL)
           yyval.ptnode->astnode.io_stmt.arg_list = NULL;
         else 
           yyval.ptnode->astnode.io_stmt.arg_list = switchem(yyvsp[-1].ptnode);
      ;
    break;}
case 148:
#line 1829 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->astnode.io_stmt.io_type = Read;
         yyval.ptnode->astnode.io_stmt.fmt_list = NULL;
         yyval.ptnode->astnode.io_stmt.end_num = atoi(yyvsp[-3].ptnode->astnode.constant.number);

         if(yyvsp[-1].ptnode == NULL)
           yyval.ptnode->astnode.io_stmt.arg_list = NULL;
         else 
           yyval.ptnode->astnode.io_stmt.arg_list = switchem(yyvsp[-1].ptnode);
      ;
    break;}
case 149:
#line 1843 "f2jparse.y"
{
             AST *temp;

             temp = addnode();
             temp->nodetype = IoExplist;
             yyvsp[0].ptnode->parent = temp;

             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 150:
#line 1853 "f2jparse.y"
{
             yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
             yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 151:
#line 1859 "f2jparse.y"
{
             yyval.ptnode = NULL;
           ;
    break;}
case 152:
#line 1865 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 153:
#line 1869 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->nodetype = IoImpliedLoop;
         yyval.ptnode->astnode.forloop.start = yyvsp[-3].ptnode;
         yyval.ptnode->astnode.forloop.stop = yyvsp[-1].ptnode;
         yyval.ptnode->astnode.forloop.incr = NULL;
         yyval.ptnode->astnode.forloop.counter = yyvsp[-5].ptnode;
         yyval.ptnode->astnode.forloop.Label = yyvsp[-7].ptnode;
         yyval.ptnode->astnode.forloop.iter_expr = gen_iter_expr(yyvsp[-3].ptnode,yyvsp[-1].ptnode,NULL);
         yyval.ptnode->astnode.forloop.incr_expr = gen_incr_expr(yyvsp[-5].ptnode,NULL);

         yyvsp[-7].ptnode->parent = yyval.ptnode;
         yyvsp[-5].ptnode->parent = yyval.ptnode;
         yyvsp[-3].ptnode->parent = yyval.ptnode;
         yyvsp[-1].ptnode->parent = yyval.ptnode;
       ;
    break;}
case 154:
#line 1886 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->nodetype = IoImpliedLoop;
         yyval.ptnode->astnode.forloop.start = yyvsp[-5].ptnode;
         yyval.ptnode->astnode.forloop.stop = yyvsp[-3].ptnode;
         yyval.ptnode->astnode.forloop.incr = yyvsp[-1].ptnode;
         yyval.ptnode->astnode.forloop.counter = yyvsp[-7].ptnode;
         yyval.ptnode->astnode.forloop.Label = yyvsp[-9].ptnode;
         yyval.ptnode->astnode.forloop.iter_expr = gen_iter_expr(yyvsp[-5].ptnode,yyvsp[-3].ptnode,yyvsp[-1].ptnode);
         yyval.ptnode->astnode.forloop.incr_expr = gen_incr_expr(yyvsp[-7].ptnode,yyvsp[-1].ptnode);

         yyvsp[-9].ptnode->parent = yyval.ptnode;
         yyvsp[-7].ptnode->parent = yyval.ptnode;
         yyvsp[-5].ptnode->parent = yyval.ptnode;
         yyvsp[-3].ptnode->parent = yyval.ptnode;
         yyvsp[-1].ptnode->parent = yyval.ptnode;
       ;
    break;}
case 155:
#line 1907 "f2jparse.y"
{
           yyval.ptnode = yyvsp[0].ptnode;
         ;
    break;}
case 156:
#line 1918 "f2jparse.y"
{
             yyval.ptnode = addnode();
             yyvsp[-8].ptnode->parent = yyval.ptnode;
             yyvsp[-4].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             if(yyvsp[-3].ptnode != NULL) 
               yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             if(yyvsp[-2].ptnode != NULL)
               yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             yyval.ptnode->nodetype = Blockif;
             yyval.ptnode->astnode.blockif.conds = yyvsp[-8].ptnode;
             if(yyvsp[-4].ptnode != 0) yyvsp[-4].ptnode = switchem(yyvsp[-4].ptnode);
             yyval.ptnode->astnode.blockif.stmts = yyvsp[-4].ptnode;

             /*  If there are any `else if' statements,
              *  switchem. Otherwise, NULL pointer checked
              *  in code generating functions. 
              */
             if(yyvsp[-3].ptnode != 0) yyvsp[-3].ptnode = switchem(yyvsp[-3].ptnode); 
             yyval.ptnode->astnode.blockif.elseifstmts = yyvsp[-3].ptnode; /* Might be NULL. */
             yyval.ptnode->astnode.blockif.elsestmts = yyvsp[-2].ptnode;   /* Might be NULL. */
           ;
    break;}
case 157:
#line 1942 "f2jparse.y"
{yyval.ptnode=0;;
    break;}
case 158:
#line 1944 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 159:
#line 1948 "f2jparse.y"
{
             yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
	     yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 160:
#line 1956 "f2jparse.y"
{
          yyval.ptnode=addnode();
	  yyvsp[-4].ptnode->parent = yyval.ptnode;  
	  yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	  yyval.ptnode->nodetype = Elseif;
	  yyval.ptnode->astnode.blockif.conds = yyvsp[-4].ptnode;
	  yyval.ptnode->astnode.blockif.stmts = switchem(yyvsp[0].ptnode);
        ;
    break;}
case 161:
#line 1967 "f2jparse.y"
{yyval.ptnode=0;;
    break;}
case 162:
#line 1969 "f2jparse.y"
{
             yyval.ptnode=addnode();
	     yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	     yyval.ptnode->nodetype = Else;
	     yyval.ptnode->astnode.blockif.stmts = switchem(yyvsp[0].ptnode);
          ;
    break;}
case 163:
#line 1979 "f2jparse.y"
{
             yyval.ptnode = addnode();
             yyvsp[-2].ptnode->parent = yyval.ptnode;
             yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             yyval.ptnode->astnode.logicalif.conds = yyvsp[-2].ptnode;
             yyval.ptnode->astnode.logicalif.stmts = yyvsp[0].ptnode;
           ;
    break;}
case 164:
#line 1989 "f2jparse.y"
{
                yyval.ptnode = addnode();
                yyval.ptnode->nodetype = Arithmeticif;
                yyvsp[-7].ptnode->parent = yyval.ptnode;
                yyvsp[-5].ptnode->parent = yyval.ptnode;
                yyvsp[-3].ptnode->parent = yyval.ptnode;
                yyvsp[-1].ptnode->parent = yyval.ptnode;

                yyval.ptnode->astnode.arithmeticif.cond = yyvsp[-7].ptnode;
                yyval.ptnode->astnode.arithmeticif.neg_label  = atoi(yyvsp[-5].ptnode->astnode.constant.number);
                yyval.ptnode->astnode.arithmeticif.zero_label = atoi(yyvsp[-3].ptnode->astnode.constant.number);
                yyval.ptnode->astnode.arithmeticif.pos_label  = atoi(yyvsp[-1].ptnode->astnode.constant.number);
              ;
    break;}
case 165:
#line 2016 "f2jparse.y"
{
                    /* Use the following declarations in case we 
                     * need to switch index order.
                     * 
                     * HASHNODE * hashtemp;  
                     * HASHNODE * ht;
                     */

                    yyval.ptnode = addnode();
                    yyvsp[-3].ptnode->parent = yyval.ptnode;  /* 9-4-97 - Keith */

                    /*  $3->parent = $$;  9-4-97 - Keith */

                    if(yyvsp[-1].ptnode != NULL)
                      strcpy(yyvsp[-1].ptnode->parent->astnode.ident.name, 
                        yyvsp[-3].ptnode->astnode.ident.name);

                    /*
                     *  Here we could look up the name in the array table and set 
                     *  the nodetype to ArrayAccess if it is found.  Then the code 
                     *  generator could easily distinguish between array accesses 
                     *  and function calls.  I'll have to implement the rest of 
                     *  this soon.  -- Keith
                     *
                     *     if(type_lookup(array_table, $1->astnode.ident.name))
                     *       $$->nodetype = ArrayAccess;
                     *     else
                     *       $$->nodetype = Identifier;
                     */

                    yyval.ptnode->nodetype = Identifier;

                    yyval.ptnode->astnode.ident.lead_expr = NULL;
                    strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-3].ptnode->astnode.ident.name);

                    /*  This is in case we want to switch index order later.
                     *
                     *  hashtemp = type_lookup(array_table, $1->astnode.ident.name);
                     *  if(hashtemp != NULL)
                     *    $$->astnode.ident.arraylist = $3;
                     *  else
                     */

                    /* We don't switch index order.  */
                    if(yyvsp[-1].ptnode == NULL) {
                      yyval.ptnode->astnode.ident.arraylist = addnode();
                      yyval.ptnode->astnode.ident.arraylist->nodetype = EmptyArgList;
                    }
                    else
                      yyval.ptnode->astnode.ident.arraylist = switchem(yyvsp[-1].ptnode);
                  ;
    break;}
case 166:
#line 2070 "f2jparse.y"
{
              if(debug)
                printf("SubString!\n");
              yyval.ptnode = addnode();
              yyvsp[-5].ptnode->parent = yyval.ptnode;
              yyvsp[-3].ptnode->parent = yyval.ptnode;
              yyvsp[-1].ptnode->parent = yyval.ptnode;
              strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-5].ptnode->astnode.ident.name);
              yyval.ptnode->nodetype = Substring;
              yyval.ptnode->token = NAME;
              yyval.ptnode->astnode.ident.arraylist = yyvsp[-3].ptnode;
              yyvsp[-3].ptnode->nextstmt = yyvsp[-1].ptnode;
           ;
    break;}
case 167:
#line 2096 "f2jparse.y"
{
             AST *temp;

             temp = addnode();
             temp->nodetype = Call;
             yyvsp[0].ptnode->parent = temp;

             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 168:
#line 2106 "f2jparse.y"
{
             yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
             yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 169:
#line 2112 "f2jparse.y"
{
             yyval.ptnode = NULL;
           ;
    break;}
case 170:
#line 2121 "f2jparse.y"
{
             yyval.ptnode = yyvsp[-1].ptnode;
	     yyval.ptnode->nodetype = Call;
          ;
    break;}
case 171:
#line 2126 "f2jparse.y"
{
            yyval.ptnode = addnode();
            yyvsp[-1].ptnode->parent = yyval.ptnode;
            yyval.ptnode->nodetype = Identifier;
            yyval.ptnode->astnode.ident.lead_expr = NULL;
            strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-1].ptnode->astnode.ident.name);
            yyval.ptnode->astnode.ident.arraylist = addnode();
            yyval.ptnode->astnode.ident.arraylist->nodetype = EmptyArgList;
          ;
    break;}
case 172:
#line 2142 "f2jparse.y"
{
       yyval.ptnode = yyvsp[0].ptnode;
     ;
    break;}
case 173:
#line 2146 "f2jparse.y"
{
       yyval.ptnode=addnode();
       yyvsp[-2].ptnode->expr_side = left;
       yyvsp[0].ptnode->expr_side = right;
       yyvsp[-2].ptnode->parent = yyval.ptnode;
       yyvsp[0].ptnode->parent = yyval.ptnode;
       yyval.ptnode->token = EQV;
       yyval.ptnode->nodetype = Logicalop;
       yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
       yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
     ;
    break;}
case 174:
#line 2158 "f2jparse.y"
{
       yyval.ptnode=addnode();
       yyvsp[-2].ptnode->expr_side = left;
       yyvsp[0].ptnode->expr_side = right;
       yyvsp[-2].ptnode->parent = yyval.ptnode;
       yyvsp[0].ptnode->parent = yyval.ptnode;
       yyval.ptnode->token = NEQV;
       yyval.ptnode->nodetype = Logicalop;
       yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
       yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
     ;
    break;}
case 175:
#line 2172 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
              ;
    break;}
case 176:
#line 2176 "f2jparse.y"
{
                yyval.ptnode=addnode();
		yyvsp[-2].ptnode->expr_side = left;
		yyvsp[0].ptnode->expr_side = right;
		yyvsp[-2].ptnode->parent = yyval.ptnode;
		yyvsp[0].ptnode->parent = yyval.ptnode;
		yyval.ptnode->token = OR;
		yyval.ptnode->nodetype = Logicalop;
		yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
		yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
              ;
    break;}
case 177:
#line 2190 "f2jparse.y"
{
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 178:
#line 2194 "f2jparse.y"
{
            yyval.ptnode=addnode();
            yyvsp[-2].ptnode->expr_side = left;
            yyvsp[0].ptnode->expr_side = right;
            yyvsp[-2].ptnode->parent = yyval.ptnode;
            yyvsp[0].ptnode->parent = yyval.ptnode;
            yyval.ptnode->token = AND;
            yyval.ptnode->nodetype = Logicalop;
            yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
            yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
          ;
    break;}
case 179:
#line 2208 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 180:
#line 2212 "f2jparse.y"
{
              yyval.ptnode=addnode();
              yyvsp[0].ptnode->parent = yyval.ptnode;  /* 9-4-97 - Keith */
              yyval.ptnode->token = NOT;
              yyval.ptnode->nodetype = Logicalop;
              yyval.ptnode->astnode.expression.lhs = 0;
              yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
            ;
    break;}
case 181:
#line 2223 "f2jparse.y"
{
               yyval.ptnode = yyvsp[0].ptnode;
             ;
    break;}
case 182:
#line 2226 "f2jparse.y"
{temptok = yylval.tok;;
    break;}
case 183:
#line 2227 "f2jparse.y"
{
               yyval.ptnode=addnode();
               yyvsp[-3].ptnode->expr_side = left;
               yyvsp[0].ptnode->expr_side = right;
               yyvsp[-3].ptnode->parent = yyval.ptnode;
               yyvsp[0].ptnode->parent = yyval.ptnode;
               yyval.ptnode->nodetype = Relationalop;
               yyval.ptnode->token = temptok;
               yyval.ptnode->astnode.expression.lhs = yyvsp[-3].ptnode;
               yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
             ;
    break;}
case 184:
#line 2241 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 185:
#line 2245 "f2jparse.y"
{
              if(yyvsp[0].ptnode->nodetype == Constant) {
                prepend_minus(yyvsp[0].ptnode->astnode.constant.number);
                yyval.ptnode = yyvsp[0].ptnode;
              }
              else {
                yyval.ptnode = addnode();
                yyvsp[0].ptnode->parent = yyval.ptnode;
                yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
                yyval.ptnode->astnode.expression.lhs = 0;
                yyval.ptnode->astnode.expression.minus = '-';   
                yyval.ptnode->nodetype = Unaryop;
              }
            ;
    break;}
case 186:
#line 2260 "f2jparse.y"
{
              if(yyvsp[0].ptnode->nodetype == Constant) {
                yyval.ptnode = yyvsp[0].ptnode;
              }
              else {
                yyval.ptnode = addnode();
                yyvsp[0].ptnode->parent = yyval.ptnode;
                yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
                yyval.ptnode->astnode.expression.lhs = 0;
                yyval.ptnode->astnode.expression.minus = '+';
                yyval.ptnode->nodetype = Unaryop;
              }
            ;
    break;}
case 187:
#line 2274 "f2jparse.y"
{
              yyval.ptnode=addnode();
              yyvsp[-2].ptnode->expr_side = left;
              yyvsp[0].ptnode->expr_side = right;
              yyval.ptnode->token = PLUS;
              yyvsp[-2].ptnode->parent = yyval.ptnode;
              yyvsp[0].ptnode->parent = yyval.ptnode;
              yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
              yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
              yyval.ptnode->nodetype = Binaryop;
              yyval.ptnode->astnode.expression.optype = '+';
            ;
    break;}
case 188:
#line 2287 "f2jparse.y"
{
              yyval.ptnode=addnode();
              yyval.ptnode->token = MINUS;
              yyvsp[-2].ptnode->expr_side = left;
              yyvsp[0].ptnode->expr_side = right;
              yyvsp[-2].ptnode->parent = yyval.ptnode;
              yyvsp[0].ptnode->parent = yyval.ptnode;
              yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
              yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
              yyval.ptnode->nodetype = Binaryop;
              yyval.ptnode->astnode.expression.optype = '-';
            ;
    break;}
case 189:
#line 2302 "f2jparse.y"
{
        yyval.ptnode = yyvsp[0].ptnode;
      ;
    break;}
case 190:
#line 2306 "f2jparse.y"
{
        yyval.ptnode=addnode();
        yyvsp[-2].ptnode->expr_side = left;
        yyvsp[0].ptnode->expr_side = right;
        yyval.ptnode->token = DIV;
        yyvsp[-2].ptnode->parent = yyval.ptnode;
        yyvsp[0].ptnode->parent = yyval.ptnode;
        yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
        yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
        yyval.ptnode->nodetype = Binaryop;
        yyval.ptnode->astnode.expression.optype = '/';
      ;
    break;}
case 191:
#line 2319 "f2jparse.y"
{
        yyval.ptnode=addnode();
        yyval.ptnode->token = STAR;
        yyvsp[-2].ptnode->expr_side = left;
        yyvsp[0].ptnode->expr_side = right;
        yyvsp[-2].ptnode->parent = yyval.ptnode;
        yyvsp[0].ptnode->parent = yyval.ptnode;
        yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
        yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
        yyval.ptnode->nodetype = Binaryop;
        yyval.ptnode->astnode.expression.optype = '*';
      ;
    break;}
case 192:
#line 2334 "f2jparse.y"
{
          yyval.ptnode = yyvsp[0].ptnode;
        ;
    break;}
case 193:
#line 2338 "f2jparse.y"
{
          yyval.ptnode=addnode();
          yyvsp[-2].ptnode->parent = yyval.ptnode;
          yyvsp[0].ptnode->parent = yyval.ptnode;
	  yyval.ptnode->nodetype = Power;
	  yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
	  yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
        ;
    break;}
case 194:
#line 2349 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 195:
#line 2353 "f2jparse.y"
{
             yyval.ptnode=addnode();
             yyval.ptnode->token = CAT;
             yyvsp[-2].ptnode->expr_side = left;
             yyvsp[0].ptnode->expr_side = right;
             yyvsp[-2].ptnode->parent = yyval.ptnode;
             yyvsp[0].ptnode->parent = yyval.ptnode;
             yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
             yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
             yyval.ptnode->nodetype = Binaryop;
             yyval.ptnode->astnode.expression.optype = '+';
           ;
    break;}
case 196:
#line 2367 "f2jparse.y"
{yyval.ptnode=yyvsp[0].ptnode;;
    break;}
case 197:
#line 2369 "f2jparse.y"
{
	       yyval.ptnode = yyvsp[0].ptnode;
	     ;
    break;}
case 198:
#line 2373 "f2jparse.y"
{yyval.ptnode=yyvsp[0].ptnode;;
    break;}
case 199:
#line 2374 "f2jparse.y"
{yyval.ptnode=yyvsp[0].ptnode;;
    break;}
case 200:
#line 2376 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyvsp[-1].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
               yyval.ptnode->nodetype = Expression;
               yyval.ptnode->astnode.expression.parens = TRUE;
               yyval.ptnode->astnode.expression.rhs = yyvsp[-1].ptnode;
               yyval.ptnode->astnode.expression.lhs = 0;
             ;
    break;}
case 201:
#line 2395 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyval.ptnode->token = TrUE;
               yyval.ptnode->nodetype = Constant;
               strcpy(yyval.ptnode->astnode.constant.number, "true");
               yyval.ptnode->vartype = Logical;
             ;
    break;}
case 202:
#line 2403 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyval.ptnode->token = FaLSE;
               yyval.ptnode->nodetype = Constant;
               strcpy(yyval.ptnode->astnode.constant.number, "false");
               yyval.ptnode->vartype = Logical;
             ;
    break;}
case 203:
#line 2415 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 204:
#line 2419 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 205:
#line 2423 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 206:
#line 2427 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 207:
#line 2431 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 208:
#line 2437 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyval.ptnode->token = INTEGER;
               yyval.ptnode->nodetype = Constant;
               strcpy(yyval.ptnode->astnode.constant.number, yylval.lexeme);
               yyval.ptnode->vartype = Integer;
             ;
    break;}
case 209:
#line 2447 "f2jparse.y"
{
               yyval.ptnode = addnode();
	       yyval.ptnode->token = DOUBLE;
               yyval.ptnode->nodetype = Constant;
               strcpy(yyval.ptnode->astnode.constant.number, yylval.lexeme);
               yyval.ptnode->vartype = Double;
             ;
    break;}
case 210:
#line 2473 "f2jparse.y"
{
               yyval.ptnode = addnode();
	       yyval.ptnode->token = EXPONENTIAL;
               yyval.ptnode->nodetype = Constant;
	       exp_to_double(yylval.lexeme, tempname);
               strcpy(yyval.ptnode->astnode.constant.number, tempname);
               yyval.ptnode->vartype = Double;
             ;
    break;}
case 211:
#line 2486 "f2jparse.y"
{
                yyval.ptnode= addnode();
             ;
    break;}
case 212:
#line 2492 "f2jparse.y"
{
          yyval.ptnode = addnode();
          yyval.ptnode->nodetype = Stop;
        ;
    break;}
case 213:
#line 2499 "f2jparse.y"
{
          yyval.ptnode = addnode();
          yyvsp[-1].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
          yyval.ptnode->nodetype = Goto;
	  if(debug)
            printf("goto label: %d\n", atoi(yylval.lexeme)); 
          yyval.ptnode->astnode.go_to.label = atoi(yylval.lexeme);
        ;
    break;}
case 214:
#line 2510 "f2jparse.y"
{
                  yyval.ptnode = addnode();
                  yyvsp[-3].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
                  yyvsp[-1].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
                  yyval.ptnode->nodetype = ComputedGoto;
                  yyval.ptnode->astnode.computed_goto.name = yyvsp[-1].ptnode;
                  yyval.ptnode->astnode.computed_goto.intlist = switchem(yyvsp[-3].ptnode);
        	  if(debug)
        	    printf("Computed go to,\n");
                ;
    break;}
case 215:
#line 2521 "f2jparse.y"
{
                  yyval.ptnode = addnode();
                  yyvsp[-4].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
                  yyvsp[-1].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
                  yyval.ptnode->nodetype = ComputedGoto;
                  yyval.ptnode->astnode.computed_goto.name = yyvsp[-1].ptnode;
                  yyval.ptnode->astnode.computed_goto.intlist = switchem(yyvsp[-4].ptnode);
        	  if(debug)
        	    printf("Computed go to,\n");
                ;
    break;}
case 216:
#line 2534 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 217:
#line 2538 "f2jparse.y"
{
              yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 218:
#line 2545 "f2jparse.y"
{
	       yyval.ptnode = addnode();
               yyvsp[-2].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
	       yyval.ptnode->nodetype = Specification;
	       yyval.ptnode->astnode.typeunit.specification = Parameter;
               yyval.ptnode->astnode.typeunit.declist = switchem(yyvsp[-2].ptnode); 
             ;
    break;}
case 219:
#line 2555 "f2jparse.y"
{ 
            yyval.ptnode=yyvsp[0].ptnode;
          ;
    break;}
case 220:
#line 2559 "f2jparse.y"
{
            yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode; 
            yyval.ptnode=yyvsp[0].ptnode;
          ;
    break;}
case 221:
#line 2566 "f2jparse.y"
{
            double constant_eval;
            AST *temp;

            if(debug)
              printf("Parameter...\n");

            yyval.ptnode = yyvsp[0].ptnode;
            yyval.ptnode->nodetype = Assignment;
                                                                                                      
            constant_eval = eval_const_expr(yyval.ptnode->astnode.assignment.rhs);
            
            temp = addnode();
            temp->nodetype = Constant;
            temp->vartype = yyval.ptnode->astnode.assignment.rhs->vartype;
            
            switch(yyval.ptnode->astnode.assignment.rhs->vartype) {
              case String:
              case Character:
                temp->token = STRING;
                strcpy(temp->astnode.constant.number, 
                       yyval.ptnode->astnode.assignment.rhs->astnode.constant.number);
                break;
              case Complex:
                fprintf(stderr,"Pdec: Complex not yet supported.\n");
                break;
              case Logical:
                temp->token = yyval.ptnode->astnode.assignment.rhs->token;
                strcpy(temp->astnode.constant.number, 
                       temp->token == TrUE ? "true" : "false");
                break;
              case Float:
              case Double:
                temp->token = DOUBLE;
                sprintf(temp->astnode.constant.number,"%f",constant_eval);
                break;
              case Integer:
                temp->token = INTEGER;
                sprintf(temp->astnode.constant.number,"%d",(int)constant_eval);
                break;
              default:
                fprintf(stderr,"Pdec: bad vartype!\n");
            }

            yyval.ptnode->astnode.assignment.rhs = temp;
                                                      
            type_insert(parameter_table, temp, 0,
               yyval.ptnode->astnode.assignment.lhs->astnode.ident.name);

            /*
             *  $$->astnode.typeunit.specification = Parameter; 
             *
             * Attach the Assignment node to a list... Hack.
             *  $$->astnode.typeunit.declist = $1;  
             */
          ;
    break;}
case 222:
#line 2625 "f2jparse.y"
{
             yyval.ptnode=addnode(); 
             yyvsp[-1].ptnode->parent = yyval.ptnode;  /* 9-3-97 - Keith */
             yyval.ptnode->nodetype = Specification;
             yyval.ptnode->token = EXTERNAL;
             yyval.ptnode->astnode.typeunit.declist = switchem(yyvsp[-1].ptnode);
             yyval.ptnode->astnode.typeunit.specification = External;
           ;
    break;}
case 223:
#line 2636 "f2jparse.y"
{
             yyval.ptnode=addnode(); 
             yyvsp[-1].ptnode->parent = yyval.ptnode;  /* 9-3-97 - Keith */
             yyval.ptnode->nodetype = Specification;
	     yyval.ptnode->token = INTRINSIC;
             yyval.ptnode->astnode.typeunit.declist = switchem(yyvsp[-1].ptnode);
             yyval.ptnode->astnode.typeunit.specification = Intrinsic;
           ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 2647 "f2jparse.y"



/*****************************************************************************
 *                                                                           *
 * yyerror                                                                   *
 *                                                                           *
 * The standard error routine, which is not currently implemented.           *
 *                                                                           *
 *****************************************************************************/

void 
yyerror(char *s)
{
  printf("%d: %s\n", lineno, s);
}


/*****************************************************************************
 *                                                                           *
 * addnode                                                                   *
 *                                                                           *
 * To keep things simple, there is only one type of parse tree               *
 * node.  If there is any way to ensure that all the pointers                *
 * in this are NULL, it would be a good idea to do that.  I am               *
 * not sure what the default behavior is.                                    *
 *                                                                           *
 *****************************************************************************/

AST * 
addnode() 
{
  return (AST*)f2jcalloc(1,sizeof(AST));
}


/*****************************************************************************
 *                                                                           *
 * switchem                                                                  *
 *                                                                           *
 * Need to turn the linked list around,                                      *
 * so that it can traverse forward instead of in reverse.                    *
 * What I do here is create a doubly linked list.                            *
 * Note that there is no `sentinel' or `head' node                           *
 * in this list.  It is acyclic and terminates in                            *
 * NULL pointers.                                                            *
 *                                                                           *
 *****************************************************************************/

AST * 
switchem(AST * root) 
{

  if (root->prevstmt == NULL) 
    return root;

  while (root->prevstmt != 0) 
  {
    root->prevstmt->nextstmt = root;
    root = root->prevstmt;
  }

  return root;
}

/*****************************************************************************
 *                                                                           *
 * type_hash                                                                 *
 *                                                                           *
 * For now, type_hash takes a tree (linked list) of type                     *
 * declarations from the Decblock rule.  It will need to                     *
 * get those from Intrinsic, External, Parameter, etc.                       *
 *                                                                           *
 *****************************************************************************/

void 
type_hash(AST * types)
{
  HASHNODE *hash_entry;
  AST * temptypes, * tempnames;
  int return_type;
  extern SYMTABLE * type_table, * intrinsic_table, * external_table; 
   
   /* Outer for loop traverses typestmts, inner for()
    * loop traverses declists. Code for stuffing symbol table is
    * is in inner for() loop.   
    */
  for (temptypes = types; temptypes; temptypes = temptypes->nextstmt)
  {
      /* Long assignment, set up the for() loop here instead of
         the expression list.  */
    tempnames = temptypes->astnode.typeunit.declist;

      /* Need to set the return value here before entering
         the next for() loop.  */
    return_type = temptypes->astnode.typeunit.returns;

printf("looking at node type %s\n",print_nodetype(temptypes));

    for (; tempnames; tempnames = tempnames->nextstmt)
    {
      /* Stuff names and return types into the symbol table. */
      if(debug)printf("Type hash: %s\n", tempnames->astnode.ident.name);
      printf("Type hash: %s\n", tempnames->astnode.ident.name);

      if(temptypes->nodetype == Dimension) {
        /* looking at a Dimension spec.  check whether the ident is already
         * in the hash table.  if so, we want to assign the array dimensions
         * to that node.  if not, we will create a new node and assign the
         * dimensions to it.
         */
        extern enum returntype default_implicit_table[];
        AST *node;

printf("DIMENSION stmt.  looking for '%s' in hash table.\n",
 tempnames->astnode.ident.name);
 
        hash_entry = type_lookup(type_table, tempnames->astnode.ident.name);
        if(hash_entry)
          node = hash_entry->variable;
        else {
printf("not found... inserting new node w/default type.\n");
          node = initialize_name(tempnames->astnode.ident.name );
          type_insert(type_table, node, 
             default_implicit_table[tempnames->astnode.ident.name[0] - 'a'],
             tempnames->astnode.ident.name);
        }

if(node == NULL)
  printf("NULL node!!\n");
  
        node->astnode.ident.arraylist = tempnames->astnode.ident.arraylist;
        node->astnode.ident.dim = tempnames->astnode.ident.dim;
        node->astnode.ident.leaddim = tempnames->astnode.ident.leaddim;
        node->astnode.ident.lead_expr = tempnames->astnode.ident.lead_expr;
        node->astnode.ident.D[0] = tempnames->astnode.ident.D[0];
        node->astnode.ident.D[1] = tempnames->astnode.ident.D[1];
        node->astnode.ident.D[2] = tempnames->astnode.ident.D[2];
      }
      else {
        /* check whether there is already an array declaration for this ident.
         * this would be true in case of a normal type declaration with array
         * declarator, in which case we'll do a little extra work here.  but
         * for idents that were previously dimensioned, we need to get this
         * info out of the table.
         */
printf("looking for DIMENSION for '%s'\n",tempnames->astnode.ident.name);

        hash_entry = type_lookup(array_table,tempnames->astnode.ident.name);
        if(hash_entry) {
          AST *var = hash_entry->variable;
  
printf("found.\n");
          tempnames->astnode.ident.arraylist = var->astnode.ident.arraylist;
          tempnames->astnode.ident.dim = var->astnode.ident.dim;
          tempnames->astnode.ident.leaddim = var->astnode.ident.leaddim;
          tempnames->astnode.ident.lead_expr = var->astnode.ident.lead_expr;
          tempnames->astnode.ident.D[0] = var->astnode.ident.D[0];
          tempnames->astnode.ident.D[1] = var->astnode.ident.D[1];
          tempnames->astnode.ident.D[2] = var->astnode.ident.D[2];
        }

        hash_entry = type_lookup(type_table,tempnames->astnode.ident.name);

        if(hash_entry == NULL) {
          tempnames->vartype = return_type;

          type_insert(type_table, tempnames, return_type, tempnames->astnode.ident.name);
        }
        else {
          if(debug)
            printf("Duplicate entry.\n");  
  
          tempnames->vartype = hash_entry->variable->vartype;
        }
      }

      /* Now separate out the EXTERNAL from the INTRINSIC on the
         fortran side.  */

      if(temptypes != NULL)
        switch (temptypes->token)
        {
          case INTRINSIC:
            type_insert(intrinsic_table, 
                    tempnames, return_type, tempnames->astnode.ident.name);
            break;
          case EXTERNAL:
            type_insert(external_table,
                    tempnames, return_type, tempnames->astnode.ident.name);
            break;
        } /* Close switch().  */
    }  /* Close inner for() loop.  */
  }    /* Close outer for() loop.  */
}      /* Close type_hash().       */


/*****************************************************************************
 *                                                                           *
 * exp_to_double                                                             *
 *                                                                           *
 *  Since jasmin doesn't have any EXPONENTIAL data types, these              *
 * have to be turned into floats.  exp_to_double really just                 *
 * replaces instances of 'd' and 'D' in the exponential number               *
 * with 'e' so that c can convert it on a string scan and                    *
 * string print.  Java does recognize numbers of the                         *
 * form 1.0e+1, so the `d' and `d' need to be replaced with                  *
 * `e'.  For now, leave as double for uniformity with jasmin.                *
 *                                                                           *
 *****************************************************************************/

void 
exp_to_double (char *lexeme, char *temp)
{
  char *cp = lexeme;

  while (*cp)           /* While *cp != '\0'...  */
  {
    if (*cp == 'd' ||   /*  sscanf can recognize 'E'. */
        *cp == 'D')
    {
       *cp = 'e';       /* Replace the 'd' or 'D' with 'e'. */
       break;           /* Should be only one 'd', 'D', etc. */
    }
    cp++;               /* Examine the next character. */
  }

  /* Java should be able to handle exponential notation as part
   * of the float or double constant. 
   */

 strcpy(temp,lexeme);
}  /*  Close exp_to_double().  */


/*****************************************************************************
 *                                                                           *
 * arg_table_load                                                            *
 *                                                                           *
 * Initialize and fill a table with the names of the                         *
 * variables passed in as arguments to the function or                       *
 * subroutine.  This table is later checked when variable                    *
 * types are declared so that variables are not declared                     *
 * twice.                                                                    *  
 *                                                                           *
 *****************************************************************************/

void
arg_table_load(AST * arglist)
{
  AST * temp;
  extern SYMTABLE * args_table;

  /* We traverse down `prevstmt' because the arglist is
   * built with right recursion, i.e. in reverse.  This
   * procedure, 'arg_table_load()' is called when the non-
   * terminal `functionargs' is reduced, before the
   * argument list is reversed. Note that a NULL pointer
   * at either end of the list terminates the for() loop. 
   */

   for(temp = arglist; temp; temp = temp->nextstmt)
   {
     type_insert(args_table, temp, 0, temp->astnode.ident.name);
     if(debug)printf("Arglist var. name: %s\n", temp->astnode.ident.name);
   }
}


/*****************************************************************************
 *                                                                           *
 * lowercase                                                                 *
 *                                                                           *
 * This function takes a string and converts all characters to               *
 * lowercase.                                                                *
 *                                                                           *
 *****************************************************************************/

char * lowercase(char * name)
{
  char *ptr = name;

  while (*name)
  {
    *name = tolower(*name);
     name++;
  }

  return ptr;
}

/*****************************************************************************
 *                                                                           *
 * store_array_var                                                           *
 *                                                                           *
 * We need to make a table of array variables, because                       *
 * fortran accesses arrays by columns instead of rows                        *
 * as C and java does.  During code generation, the array                    *
 * variables are emitted in reverse to get row order.                        *
 *                                                                           *
 *****************************************************************************/

void
store_array_var(AST * var)
{
  extern SYMTABLE * array_table;

  if(type_lookup(array_table, var->astnode.ident.name) != NULL)
    fprintf(stderr,"Error: more than one array declarator for array '%s'\n",
       var->astnode.ident.name);
  else
    type_insert(array_table, var, 0, var->astnode.ident.name);

  if(debug)
    printf("Array name: %s\n", var->astnode.ident.name);
}

/*****************************************************************************
 *                                                                           *
 * mypow                                                                     *
 *                                                                           *
 * Double power function.  writing this here so that we                      *
 * dont have to link in the math library.                                    *
 *                                                                           *
 *****************************************************************************/

double
mypow(double x, double y)
{
  int i;

  if(y < 0)
  {
    fprintf(stderr,"Warning: got negative exponent in mypow!\n");
    return 0;
  }

  if(y == 0)
    return 1;

  if(y == 1)
    return x;
  
  for(i=0;i<y-1;i++)
    x *= x;
  
  return x;
}

/*****************************************************************************
 *                                                                           *
 * init_tables                                                               *
 *                                                                           *
 * This function initializes all the symbol tables we'll need during         *
 * parsing and code generation.                                              *
 *                                                                           *
 *****************************************************************************/

void
init_tables()
{
  if(debug)
    printf("Initializing tables.\n");

  array_table     = (SYMTABLE *) new_symtable(211);
  format_table    = (SYMTABLE *) new_symtable(211);
  data_table      = (SYMTABLE *) new_symtable(211);
  save_table      = (SYMTABLE *) new_symtable(211);
  common_table    = (SYMTABLE *) new_symtable(211);
  parameter_table = (SYMTABLE *) new_symtable(211);
  type_table      = (SYMTABLE *) new_symtable(211);
  intrinsic_table = (SYMTABLE *) new_symtable(211);
  external_table  = (SYMTABLE *) new_symtable(211);
  args_table      = (SYMTABLE *) new_symtable(211);
  constants_table = make_dl();
  equivList       = NULL;
}

/*****************************************************************************
 *                                                                           *
 * merge_common_blocks                                                       *
 *                                                                           *
 * In Fortran, different declarations of the same COMMON block may use       *
 * differently named variables.  Since f2j is going to generate only one     *
 * class file to represent the COMMON block, we can only use one of these    *
 * variable names.  What we attempt to do here is take the different names   *
 * and merge them into one name, which we use wherever that common variable  *
 * is used.                                                                  *
 *                                                                           *
 *****************************************************************************/

void
merge_common_blocks(AST *root)
{
  HASHNODE *ht;
  AST *Clist, *temp;
  int count;
  char ** name_array;
  char *comvar = NULL, *var = NULL, und_var[80], 
       var_und[80], und_var_und[80], *t;

  for(Clist = root; Clist != NULL; Clist = Clist->nextstmt)
  {
    /* 
     * First check whether this common block is already in
     * the table.
     */

    ht=type_lookup(common_block_table,Clist->astnode.common.name);

    for(temp=Clist->astnode.common.nlist, count = 0; 
              temp!=NULL; temp=temp->nextstmt) 
      count++;

    name_array = (char **) f2jalloc( count * sizeof(name_array) );

    for(temp=Clist->astnode.common.nlist, count = 0;
              temp!=NULL; temp=temp->nextstmt, count++)
    {
      name_array[count] = (char *) f2jalloc( 80 );
    }

    /* foreach COMMON variable */

    for(temp=Clist->astnode.common.nlist, count = 0; 
               temp!=NULL; temp=temp->nextstmt, count++) 
    {
      var = temp->astnode.ident.name;

      /* to merge two names we concatenate the second name
       * to the first name, separated by an underscore.
       */

      if(ht != NULL) {
        comvar = ((char **)ht->variable)[count];
        und_var[0] = '_';
        und_var[1] = 0;
        strcat(und_var,var);
        strcpy(var_und,var);
        strcat(var_und,"_");
        strcpy(und_var_und,und_var);
        strcat(und_var_und,"_");
      }

      if(ht == NULL)
        name_array[count] = strdup(var);
      else {
        if(!strcmp(var,comvar) || 
             strstr(comvar,und_var_und) ||
             (((t=strstr(comvar,var_und)) != NULL) && t == comvar) ||
             (((t=strstr(comvar,und_var)) != NULL) && 
               (t+strlen(t) == comvar+strlen(comvar))))
        {
          name_array[count] = strdup(comvar);
        }
        else {
          name_array[count] = (char *) f2jalloc(strlen(temp->astnode.ident.name) 
             + strlen(((char **)ht->variable)[count]) + 2);
  
          strcpy(name_array[count],temp->astnode.ident.name);
          strcat(name_array[count],"_");
          strcat(name_array[count],((char **)ht->variable)[count]);
        }
      }
    }

    type_insert(common_block_table, (AST *)name_array, Float,
         Clist->astnode.common.name);
  }
}

/*****************************************************************************
 *                                                                           *
 * addEquiv                                                                  *
 *                                                                           *
 * Insert the given node (which is itself a list of variables) into a list   *
 * of equivalences.  We end up with a list of lists.                         *
 *                                                                           *
 *****************************************************************************/

void
addEquiv(AST *node)
{
  static int id = 1;

  /* if the list is NULL, create one */

  if(equivList == NULL) {
    equivList = addnode(); 
    equivList->nodetype = Equivalence;
    equivList->token = id++;
    equivList->nextstmt = NULL;
    equivList->prevstmt = NULL;
    equivList->astnode.equiv.clist = node;
  }
  else {
    AST *temp = addnode();

    temp->nodetype = Equivalence;
    temp->token = id++;
    temp->astnode.equiv.clist = node;

    temp->nextstmt = equivList; 
    temp->prevstmt = NULL;

    equivList = temp;
  }
}

/*****************************************************************************
 *                                                                           *
 * eval_const_expr                                                           *
 *                                                                           *
 * This function evaluates a floating-point expression which should consist  *
 * of only parameters and constants.  The floating-point result is returned. *
 *                                                                           *
 *****************************************************************************/

double
eval_const_expr(AST *root)
{
  HASHNODE *p;
  double result1, result2;

  if(root == NULL)
    return 0.0;

  switch (root->nodetype)
  {
    case Identifier:
      if(!strcmp(root->astnode.ident.name,"*"))
        return 0;

      p = type_lookup(parameter_table, root->astnode.ident.name);

      if(p == NULL)
      {
        /* The array size is specified with a variable, but we
         * cant find it in the parameter table.  it is probably
         * an argument to the function.  do nothing here, just
         * fall through and hit the 'return 0' below.  --keith
         */
      }
      else
      {
         if(p->variable->nodetype == Constant) {
           root->vartype = p->variable->vartype;
           return ( atof(p->variable->astnode.constant.number) );
         }
      }
      return 0;
      break;
    case Expression:
      if (root->astnode.expression.lhs != NULL)
        result1 = eval_const_expr (root->astnode.expression.lhs);

      result2 = eval_const_expr (root->astnode.expression.rhs);
      root->token = root->astnode.expression.rhs->token;
      root->nodetype = root->astnode.expression.rhs->nodetype;
      root->vartype = root->astnode.expression.rhs->vartype;
      strcpy(root->astnode.constant.number,
          root->astnode.expression.rhs->astnode.constant.number);
      return (result2);
      break;
    case Power:
      result1 = eval_const_expr (root->astnode.expression.lhs);
      result2 = eval_const_expr (root->astnode.expression.rhs);
      root->vartype = MIN(root->astnode.expression.lhs->vartype,
                          root->astnode.expression.rhs->vartype);
      return( mypow(result1,result2) );
      break;
    case Binaryop:
      result1 = eval_const_expr (root->astnode.expression.lhs);
      result2 = eval_const_expr (root->astnode.expression.rhs);
      root->vartype = MIN(root->astnode.expression.lhs->vartype,
                          root->astnode.expression.rhs->vartype);
      if(root->astnode.expression.optype == '-')
        return (result1 - result2);
      else if(root->astnode.expression.optype == '+')
        return (result1 + result2);
      else if(root->astnode.expression.optype == '*')
        return (result1 * result2);
      else if(root->astnode.expression.optype == '/')
        return (result1 / result2);
      else
        fprintf(stderr,"eval_const_expr: Bad optype!\n");
      return 0;
      break;
    case Unaryop:
      root->vartype = root->astnode.expression.rhs->vartype;
     /*
      result1 = eval_const_expr (root->astnode.expression.rhs);
      if(root->astnode.expression.minus == '-')
        return -result1;
     */
      break;
    case Constant:
      if(root->token == STRING)
        fprintf (stderr, "String in array dec!\n");
      else
        return( atof(root->astnode.constant.number) );
      break;
    case ArrayIdxRange:
      /* I dont think it really matters what the type of this node is. --kgs */
      root->vartype = MIN(root->astnode.expression.lhs->vartype,
                          root->astnode.expression.rhs->vartype);
      return(  eval_const_expr(root->astnode.expression.rhs) - 
               eval_const_expr(root->astnode.expression.lhs) );
      break;
    case Logicalop:
      {
        int left=0, right=0;

        root->nodetype = Constant;
        root->vartype = Logical;

        eval_const_expr(root->astnode.expression.lhs);
        eval_const_expr(root->astnode.expression.rhs);

        if(root->token != NOT)
          left = root->astnode.expression.lhs->token == TrUE;
        right = root->astnode.expression.rhs->token == TrUE;

        switch (root->token) {
          case EQV:
            root->token = left == right ? TrUE : FaLSE;
            break;
          case NEQV:
            root->token = left != right ? TrUE : FaLSE;
            break;
          case AND:
            root->token = left && right ? TrUE : FaLSE;
            break;
          case OR:
            root->token = left || right ? TrUE : FaLSE;
            break;
          case NOT:
            root->token = ! right ? TrUE : FaLSE;
            break;
        }
        strcpy(root->astnode.constant.number,root->token == TrUE ? "true" : "false");
      }
      break;
    default:
      fprintf(stderr,"eval_const_expr(): bad nodetype!\n");
      return 0;
  }
  return 0;
}

void
printbits(char *header, void *var, int len)
{
  int i;

  printf("%s: ", header);
  for(i=0;i<len;i++) {
      printf("%1x", ((unsigned char *)var)[i] >> 7 );
      printf("%1x", ((unsigned char *)var)[i] >> 6 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 5 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 4 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 3 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 2 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 1 & 1 );
      printf("%1x", ((unsigned char *)var)[i] & 1 );
  }
  printf("\n");
}

/*****************************************************************************
 *                                                                           *
 * prepend_minus                                                             *
 *                                                                           *
 * This function accepts a string and prepends a '-' in front of it.         *
 * We assume that the string pointer passed in has enough storage space.     *
 *                                                                           *
 *****************************************************************************/

void
prepend_minus(char *num) {
  char * tempstr;

  /* allocate enough for the number, minus sign, and null char */
  tempstr = (char *)f2jalloc(strlen(num) + 2);

  strcpy(tempstr,"-");
  strcat(tempstr,num);
  strcpy(num,tempstr);

  free(tempstr);
}

/*****************************************************************************
 *                                                                           *
 * gen_incr_expr                                                             *
 *                                                                           *
 * this function creates an AST sub-tree representing a calculation of the   *
 * increment for this loop.  for null increments, add one.  for non-null     *
 * increments, add the appropriate value.
 *                                                                           *
 *****************************************************************************/

AST *
gen_incr_expr(AST *counter, AST *incr)
{
  AST *plus_node, *const_node, *assign_node, *lhs_copy, *rhs_copy, *incr_copy;

  lhs_copy = addnode();
  memcpy(lhs_copy, counter, sizeof(AST));
  rhs_copy = addnode();
  memcpy(rhs_copy, counter, sizeof(AST));

  if(incr == NULL) {
    const_node = addnode();
    const_node->token = INTEGER;
    const_node->nodetype = Constant;
    strcpy(const_node->astnode.constant.number, "1");
    const_node->vartype = Integer;

    plus_node = addnode();
    plus_node->token = PLUS;
    rhs_copy->parent = plus_node;
    const_node->parent = plus_node;
    plus_node->astnode.expression.lhs = rhs_copy;
    plus_node->astnode.expression.rhs = const_node;
    plus_node->nodetype = Binaryop;
    plus_node->astnode.expression.optype = '+';
  }
  else {
    incr_copy = addnode();
    memcpy(incr_copy, incr, sizeof(AST));

    plus_node = addnode();
    plus_node->token = PLUS;
    rhs_copy->parent = plus_node;
    incr_copy->parent = plus_node;
    plus_node->astnode.expression.lhs = rhs_copy;
    plus_node->astnode.expression.rhs = incr_copy;
    plus_node->nodetype = Binaryop;
    plus_node->astnode.expression.optype = '+';
  }

  assign_node = addnode();
  assign_node->nodetype = Assignment;
  lhs_copy->parent = assign_node;
  plus_node->parent = assign_node;
  assign_node->astnode.assignment.lhs = lhs_copy;
  assign_node->astnode.assignment.rhs = plus_node;

  return assign_node;
}

/*****************************************************************************
 *                                                                           *
 * gen_iter_expr                                                             *
 *                                                                           *
 * this function creates an AST sub-tree representing a calculation of the   *
 * number of iterations of a DO loop:                                        *
 *     (stop-start+incr)/incr                                                *
 * the full expression is MAX(INT((stop-start+incr)/incr),0) but we will     *
 * worry about the rest of it at code generation time.                       *
 *                                                                           *
 *****************************************************************************/

AST *
gen_iter_expr(AST *start, AST *stop, AST *incr)
{
  AST *minus_node, *plus_node, *div_node, *expr_node, *incr_node;
  
  minus_node = addnode();
  minus_node->token = MINUS;
  minus_node->astnode.expression.lhs = stop;
  minus_node->astnode.expression.rhs = start;
  minus_node->nodetype = Binaryop;
  minus_node->astnode.expression.optype = '-';
  
  if(incr == NULL) {
    incr_node = addnode();
    incr_node->token = INTEGER;
    incr_node->nodetype = Constant;
    strcpy(incr_node->astnode.constant.number, "1");
    incr_node->vartype = Integer;
  }
  else 
    incr_node = incr;
  
  plus_node = addnode();
  plus_node->token = PLUS;
  plus_node->astnode.expression.lhs = minus_node;
  plus_node->astnode.expression.rhs = incr_node;
  plus_node->nodetype = Binaryop;
  plus_node->astnode.expression.optype = '+';

  if(incr == NULL)
    return plus_node;
    
  expr_node = addnode();
  expr_node->nodetype = Expression;
  expr_node->astnode.expression.parens = TRUE;
  expr_node->astnode.expression.rhs = plus_node;
  expr_node->astnode.expression.lhs = NULL;

  div_node = addnode();
  div_node->token = DIV;
  div_node->astnode.expression.lhs = expr_node;
  div_node->astnode.expression.rhs = incr_node;
  div_node->nodetype = Binaryop;
  div_node->astnode.expression.optype = '/';

  return div_node;
}

/*****************************************************************************
 *                                                                           *
 * initialize_name                                                           *
 *                                                                           *
 * this function initializes an Identifier node with the given name.         *
 *                                                                           *
 *****************************************************************************/

AST *
initialize_name(char *id)
{
/*
  extern enum returntype default_implicit_table[];
  extern char * returnstring[];
*/
  HASHNODE *hashtemp;
  AST *tmp;

  tmp=addnode();
  tmp->token = NAME;
  tmp->nodetype = Identifier;

  tmp->astnode.ident.needs_declaration = FALSE;
  tmp->astnode.ident.lead_expr = NULL;

  if(omitWrappers)
    tmp->astnode.ident.passByRef = FALSE;

  if(type_lookup(java_keyword_table,id) ||
     type_lookup(jasmin_keyword_table,id))
        id[0] = toupper(id[0]);

  strcpy(tmp->astnode.ident.name, id);

  hashtemp = type_lookup(type_table, tmp->astnode.ident.name);
  if(hashtemp)
  {
    tmp->vartype = hashtemp->variable->vartype;
    tmp->astnode.ident.len = hashtemp->variable->astnode.ident.len;
  }
  else
  {
  /*
    unfinished code to implement implicit typing.  when finishing
    this up, remember to remove any calls to type_insert() which
    are found after calls to this function.

    enum returntype ret;

    printf("cannot find name %s in hash table..",id);
    
    ret = default_implicit_table[tolower(id[0]) - 'a'];

    printf("going to insert with default implicit type %s\n",
      returnstring[ret]);

    type_insert(type_table, tmp, ret, tmp->astnode.ident.name);
   */
  }

  return tmp;
}
