import java.*;
import java.io.*;
import java.util.zip.*;

class GZTest {
	public static void main(String args[])
	{
		InputStream fis;
		DataInputStream dis;
		BufferedReader d;
		String c;
		byte bb[] = new byte[4];
		int first_four;

		String filename = args[0];

		try {
			fis = new FileInputStream(new File(args[0]));

			dis = new DataInputStream( fis );

			if( filename.substring( filename.length()-2, filename.length() ).compareTo("gz" ) == 0 ) {
				System.out.println( args[0] + " is a compressed file.");
				fis = new GZIPInputStream( fis );
			}
			else {
				System.out.println( args[0] + " is not a compressed file.");
			}

			d = new BufferedReader( new InputStreamReader( fis ) );
		} 
		catch(IOException e) { 
			System.out.println( e.getMessage() );
			return;
		}

		try {
			String ss = d.readLine();
			System.out.println( ss );
		} 
		catch(IOException e) { 
			System.out.println( e.getMessage() );
			return;
		}


	}
}
