sfrac = repmat( linspace(0, 1, 20), [20 1]);
lfrac = 1 - sfrac;

st2 = 15;
lt2 = 70;

te = 10:10:320;

data = zeros(nrows(sfrac),ncols(sfrac),length(te));

for tei = 1:length(te)
	data(:,:,tei) = 1000 * ...
	           (sfrac .* exp( -te(tei)./st2 ) + ... 
				lfrac .* exp(-te(tei) ./lt2) );
end

unix('/usr/local/bin/makeheader4 cpmg.hdr 20 20 1   1 1 1   32 16 3000 0 3000 0 4');
fp = fopen('cpmg.img', 'wb', 'b')
fwrite(fp, data, 'int16');
fclose(fp);
