import cj.volume.*;
import cj.mri.relax.t2map.T2MapMonoExp;
import cj.mri.relax.t2map.T2MapBiExp;
import cj.mri.relax.t2map.T2MapNNLS;

class Test
{
	BFF b = null;

	public static void main(String[] args)
	{
		Test tt = new Test();

//		tt.domono();
//		tt.dobi();
		tt.donnls();
	}

	public Test()
	{
		b = new BFF("/home/craig/data/MRI/19970515_uhlondon_anne/ag43531_002.bff.gz");
	}

	public void domono()
	{
		t2mono(b.getMCVolume());
	}

	public void t2mono(final MCVolume vol)
	{
		T2MapMonoExp mono = new T2MapMonoExp();

		mono.setTE(b.getTE());
		mono.map(vol,  120, 130, 120, 130, 0, 0);
	}

	public void dobi()
	{
		t2bi(b.getMCVolume());
	}

	public void t2bi(final MCVolume vol)
	{
		T2MapBiExp bi = new T2MapBiExp();

		bi.setTE(b.getTE());
		bi.map(vol,  120, 130, 120, 130, 0, 0);
	}

	public void donnls()
	{
		t2nnls(b.getMCVolume());
	}

	public void t2nnls(final MCVolume vol)
	{
		T2MapNNLS nnls = new T2MapNNLS();

		nnls.setNorm(1.02, 1.025);
		nnls.setTE(b.getTE());
		MCVolume xout = nnls.map(vol,  120, 130, 120, 130, 0, 0);
	}
}
