
/*  A Bison parser, made from f2jparse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	PLUS	257
#define	MINUS	258
#define	OP	259
#define	CP	260
#define	STAR	261
#define	POW	262
#define	DIV	263
#define	CAT	264
#define	CM	265
#define	EQ	266
#define	COLON	267
#define	NL	268
#define	NOT	269
#define	AND	270
#define	OR	271
#define	RELOP	272
#define	EQV	273
#define	NEQV	274
#define	NAME	275
#define	DOUBLE	276
#define	INTEGER	277
#define	EXPONENTIAL	278
#define	CONST	279
#define	TrUE	280
#define	FaLSE	281
#define	ICON	282
#define	RCON	283
#define	LCON	284
#define	CCON	285
#define	FLOAT	286
#define	CHARACTER	287
#define	LOGICAL	288
#define	COMPLEX	289
#define	NONE	290
#define	IF	291
#define	THEN	292
#define	ELSE	293
#define	ELSEIF	294
#define	ENDIF	295
#define	DO	296
#define	GOTO	297
#define	ASSIGN	298
#define	TO	299
#define	CONTINUE	300
#define	STOP	301
#define	RDWR	302
#define	END	303
#define	STRING	304
#define	CHAR	305
#define	OPEN	306
#define	CLOSE	307
#define	BACKSPACE	308
#define	REWIND	309
#define	ENDFILE	310
#define	FORMAT	311
#define	PROGRAM	312
#define	FUNCTION	313
#define	SUBROUTINE	314
#define	ENTRY	315
#define	CALL	316
#define	RETURN	317
#define	TYPE	318
#define	DIMENSION	319
#define	COMMON	320
#define	EQUIVALENCE	321
#define	EXTERNAL	322
#define	PARAMETER	323
#define	INTRINSIC	324
#define	IMPLICIT	325
#define	SAVE	326
#define	DATA	327
#define	COMMENT	328
#define	READ	329
#define	WRITE	330
#define	FMT	331
#define	EDIT_DESC	332
#define	REPEAT	333
#define	LOWER_THAN_COMMENT	334

#line 8 "f2jparse.y"


/*****************************************************************************
 * f2jparse                                                                  *
 *                                                                           *
 * This is a yacc parser for a subset of Fortran 77.  It builds an AST       *
 * which is used by codegen() to generate Java code.                         *
 *                                                                           *
 *****************************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<string.h>
#include"f2j.h"
#include"class.h"
#include"constant_pool.h"

/*****************************************************************************
 * Define YYDEBUG as 1 to get debugging output from yacc.                    *
 *****************************************************************************/

#define YYDEBUG 0

/*****************************************************************************
 * Global variables.                                                         *
 *****************************************************************************/

int 
  debug = FALSE,                  /* set to TRUE for debugging output        */
  emittem = 1,                    /* set to 1 to emit Java, 0 to just parse  */
  len = 1,                        /* keeps track of the size of a data type  */
  temptok;                        /* temporary token for an inline expr      */

char
  tempname[60];                   /* temporary string                        */

AST 
  * equivList = NULL;             /* list to keep track of equivalences      */

CPNODE
  * lastConstant;                 /* last constant inserted into the c.pool  */

/*****************************************************************************
 * Function prototypes:                                                      *
 *****************************************************************************/

int 
  yylex();

double
  eval_const_expr(AST *);

char 
  * strdup(const char *),
  * strcat(char *, const char*),
  * lowercase(char * ),
  * print_nodetype (AST *),
  * tok2str(int );

void 
  yyerror(char *),
  start_vcg(),
  emit(),
  jas_emit(),
  init_tables(),
  addEquiv(AST *),
  assign(AST *),
  typecheck(AST *),
  optScalar(AST *),
  type_insert (SYMTABLE * , AST * , int , char *),
  type_hash(AST *),
  merge_common_blocks(AST *),
  arg_table_load(AST *),
  exp_to_double (char *, char *),
  prepend_minus(char *);

AST 
  * dl_astnode_examine(Dlist l),
  * addnode(),
  * switchem(),
  * gen_incr_expr(AST *, AST *),
  * gen_iter_expr(AST *, AST *, AST *);

SYMTABLE 
  * new_symtable (int );


#line 97 "f2jparse.y"
typedef union {
   struct ast_node *ptnode;
   int tok;
   enum returntype type;
   char lexeme[80];
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		424
#define	YYFLAG		-32768
#define	YYNTBASE	82

#define YYTRANSLATE(x) ((unsigned)(x) <= 334 ? yytranslate[x] : 187)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    81,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     7,     9,    11,    13,    15,    20,    25,
    30,    34,    39,    43,    49,    51,    53,    56,    58,    60,
    62,    64,    66,    68,    70,    72,    74,    77,    79,    83,
    87,    93,    95,    99,   103,   105,   108,   113,   116,   119,
   125,   129,   131,   135,   138,   140,   144,   149,   151,   155,
   157,   160,   164,   166,   170,   172,   180,   184,   190,   192,
   195,   198,   200,   202,   204,   206,   208,   210,   212,   214,
   216,   218,   220,   222,   224,   226,   228,   230,   233,   239,
   243,   246,   250,   253,   255,   259,   263,   265,   269,   275,
   277,   279,   283,   285,   287,   289,   291,   293,   298,   300,
   304,   306,   308,   312,   314,   318,   320,   325,   332,   334,
   338,   341,   344,   348,   353,   360,   363,   367,   372,   374,
   377,   379,   381,   383,   385,   387,   391,   395,   397,   399,
   401,   403,   405,   407,   410,   414,   423,   425,   427,   431,
   433,   437,   439,   443,   452,   463,   465,   469,   470,   472,
   482,   494,   498,   510,   511,   513,   516,   524,   525,   529,
   535,   546,   551,   558,   560,   564,   565,   569,   573,   575,
   579,   583,   585,   589,   591,   595,   597,   600,   602,   603,
   608,   610,   613,   616,   620,   624,   626,   630,   634,   636,
   640,   642,   646,   648,   650,   652,   654,   658,   660,   662,
   664,   666,   668,   670,   672,   674,   676,   678,   681,   684,
   688,   695,   703,   705,   709,   715,   717,   721,   723,   727
};

static const short yyrhs[] = {    83,
     0,    84,     0,    83,    84,     0,    85,     0,    86,     0,
    87,     0,   112,     0,    88,    91,   110,   115,     0,    89,
    91,   110,   115,     0,    90,    91,   110,   115,     0,    58,
   123,    14,     0,    60,   123,   116,    14,     0,    60,   123,
    14,     0,   120,    59,   123,   116,    14,     0,    92,     0,
    93,     0,    92,    93,     0,    65,     0,    94,     0,    97,
     0,   100,     0,   186,     0,   118,     0,   185,     0,   182,
     0,   101,     0,   102,    14,     0,   112,     0,    67,    95,
    14,     0,     5,    96,     6,     0,    95,    11,     5,    96,
     6,     0,   130,     0,    96,    11,   130,     0,    66,    98,
    14,     0,    99,     0,    98,    99,     0,     9,   123,     9,
   117,     0,    10,   117,     0,    72,    14,     0,    72,     9,
   117,     9,    14,     0,    72,   117,    14,     0,    71,     0,
    71,    36,    14,     0,    73,   103,     0,   104,     0,   103,
    11,   104,     0,   107,     9,   105,     9,     0,   106,     0,
   105,    11,   106,     0,   173,     0,     4,   173,     0,   173,
     7,   173,     0,   108,     0,   108,    11,   107,     0,   130,
     0,     5,   130,    11,   123,    12,   109,     6,     0,   174,
    11,   174,     0,   174,    11,   174,    11,   174,     0,   111,
     0,   110,   111,     0,   129,    14,     0,   160,     0,   155,
     0,   156,     0,   151,     0,   132,     0,   177,     0,   180,
     0,   179,     0,   135,     0,   143,     0,   144,     0,   147,
     0,   178,     0,   113,     0,   112,     0,   114,     0,    74,
    14,     0,    53,     5,   123,     6,    14,     0,    55,   123,
    14,     0,    49,    14,     0,     5,   117,     6,     0,     5,
     6,     0,   123,     0,   117,    11,   123,     0,   119,   121,
    14,     0,   120,     0,   120,   128,   174,     0,   120,   128,
     5,   128,     6,     0,    64,     0,   122,     0,   121,    11,
   122,     0,   123,     0,   125,     0,    21,     0,    50,     0,
    51,     0,   123,     5,   126,     6,     0,   127,     0,   126,
    11,   127,     0,   161,     0,   128,     0,   161,    13,   161,
     0,     7,     0,   130,    12,   161,     0,   123,     0,   123,
     5,   131,     6,     0,   123,     5,   161,    13,   161,     6,
     0,   161,     0,   131,    11,   161,     0,   133,   134,     0,
    42,   174,     0,    42,   174,    11,     0,   129,    11,   161,
    14,     0,   129,    11,   161,    11,   161,    14,     0,   174,
   111,     0,   174,   136,    14,     0,    57,     5,   137,     6,
     0,   138,     0,   137,   138,     0,   139,     0,   140,     0,
   141,     0,    78,     0,   123,     0,   123,    81,   173,     0,
     5,   137,     6,     0,   124,     0,   142,     0,    11,     0,
     9,     0,    10,     0,   174,     0,     3,   174,     0,   174,
    46,    14,     0,    76,     5,   145,    11,   146,     6,   148,
    14,     0,   161,     0,     7,     0,    77,    12,   174,     0,
   174,     0,    77,    12,     7,     0,     7,     0,    77,    12,
   124,     0,    75,     5,   145,    11,   146,     6,   148,    14,
     0,    75,     5,   145,    11,   146,    11,   150,     6,   148,
    14,     0,   149,     0,   148,    11,   149,     0,     0,   161,
     0,     5,   161,    11,   123,    12,   161,    11,   161,     6,
     0,     5,   161,    11,   123,    12,   161,    11,   161,    11,
   161,     6,     0,    49,    12,   174,     0,    37,     5,   161,
     6,    38,    14,   110,   152,   154,    41,    14,     0,     0,
   153,     0,   152,   153,     0,    40,     5,   161,     6,    38,
    14,   110,     0,     0,    39,    14,   110,     0,    37,     5,
   161,     6,   111,     0,    37,     5,   161,     6,   174,    11,
   174,    11,   174,    14,     0,   123,     5,   159,     6,     0,
   123,     5,   161,    13,   161,     6,     0,   161,     0,   159,
    11,   161,     0,     0,    62,   157,    14,     0,    62,   123,
    14,     0,   162,     0,   161,    19,   162,     0,   161,    20,
   162,     0,   163,     0,   162,    17,   163,     0,   164,     0,
   163,    16,   164,     0,   165,     0,    15,   165,     0,   167,
     0,     0,   165,    18,   166,   165,     0,   168,     0,     4,
   168,     0,     3,   168,     0,   167,     3,   168,     0,   167,
     4,   168,     0,   169,     0,   168,     9,   169,     0,   168,
     7,   169,     0,   170,     0,   170,     8,   169,     0,   171,
     0,   170,    10,   171,     0,   123,     0,   173,     0,   157,
     0,   158,     0,     5,   161,     6,     0,    26,     0,    27,
     0,   174,     0,   175,     0,   176,     0,   172,     0,   124,
     0,    23,     0,    22,     0,    24,     0,    63,    14,     0,
    47,    14,     0,    43,   174,    14,     0,    43,     5,   181,
     6,   161,    14,     0,    43,     5,   181,     6,    11,   161,
    14,     0,   174,     0,   181,    11,   174,     0,    69,     5,
   183,     6,    14,     0,   184,     0,   183,    11,   184,     0,
   129,     0,    68,   117,    14,     0,    70,   117,    14,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   168,   213,   232,   254,   260,   266,   272,   280,   332,   398,
   464,   483,   506,   525,   564,   572,   576,   583,   589,   593,
   597,   601,   605,   609,   613,   617,   621,   625,   635,   645,
   660,   677,   681,   688,   699,   703,   710,   741,   771,   782,
   798,   815,   821,   831,   840,   844,   851,   879,   883,   890,
   894,   899,   915,   919,   926,   930,   940,   950,   969,   973,
   980,   985,   990,   995,  1000,  1005,  1010,  1015,  1020,  1025,
  1030,  1035,  1040,  1045,  1050,  1055,  1060,  1067,  1077,  1084,
  1091,  1106,  1113,  1121,  1125,  1139,  1161,  1166,  1171,  1178,
  1190,  1200,  1208,  1212,  1231,  1275,  1286,  1299,  1357,  1367,
  1375,  1379,  1383,  1396,  1410,  1423,  1429,  1460,  1476,  1487,
  1499,  1508,  1513,  1520,  1534,  1556,  1565,  1593,  1601,  1611,
  1632,  1637,  1641,  1647,  1653,  1657,  1662,  1673,  1677,  1683,
  1689,  1694,  1701,  1705,  1720,  1730,  1771,  1777,  1784,  1789,
  1793,  1801,  1809,  1815,  1827,  1841,  1851,  1857,  1863,  1867,
  1884,  1905,  1916,  1941,  1942,  1946,  1954,  1966,  1967,  1977,
  1987,  2014,  2068,  2094,  2104,  2110,  2119,  2124,  2140,  2144,
  2156,  2170,  2174,  2188,  2192,  2206,  2210,  2221,  2225,  2226,
  2239,  2243,  2258,  2272,  2285,  2300,  2304,  2317,  2332,  2336,
  2347,  2351,  2366,  2367,  2372,  2373,  2374,  2393,  2401,  2412,
  2417,  2421,  2425,  2429,  2435,  2445,  2471,  2484,  2490,  2497,
  2508,  2519,  2532,  2536,  2543,  2553,  2557,  2564,  2623,  2634
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PLUS","MINUS",
"OP","CP","STAR","POW","DIV","CAT","CM","EQ","COLON","NL","NOT","AND","OR","RELOP",
"EQV","NEQV","NAME","DOUBLE","INTEGER","EXPONENTIAL","CONST","TrUE","FaLSE",
"ICON","RCON","LCON","CCON","FLOAT","CHARACTER","LOGICAL","COMPLEX","NONE","IF",
"THEN","ELSE","ELSEIF","ENDIF","DO","GOTO","ASSIGN","TO","CONTINUE","STOP","RDWR",
"END","STRING","CHAR","OPEN","CLOSE","BACKSPACE","REWIND","ENDFILE","FORMAT",
"PROGRAM","FUNCTION","SUBROUTINE","ENTRY","CALL","RETURN","TYPE","DIMENSION",
"COMMON","EQUIVALENCE","EXTERNAL","PARAMETER","INTRINSIC","IMPLICIT","SAVE",
"DATA","COMMENT","READ","WRITE","FMT","EDIT_DESC","REPEAT","LOWER_THAN_COMMENT",
"'.'","F2java","Sourcecodes","Sourcecode","Fprogram","Fsubroutine","Ffunction",
"Program","Subroutine","Function","Specstmts","SpecStmtList","Specstmt","EquivalenceStmt",
"EquivalenceList","EquivalenceItem","Common","CommonList","CommonSpec","Save",
"Implicit","Data","DataList","DataItem","DataConstantList","DataConstant","LhsList",
"DataLhs","LoopBounds","Statements","Statement","Comment","Close","Rewind","End",
"Functionargs","Namelist","Typestmt","Types","Type","Typevarlist","Typevar",
"Name","String","Arraydeclaration","Arraynamelist","Arrayname","Star","Assignment",
"Lhs","Arrayindexlist","Doloop","Do_incr","Do_vals","Label","Format","FormatExplist",
"FormatExp","RepeatableItem","UnRepeatableItem","FormatSeparator","RepeatSpec",
"Continue","Write","WriteFileDesc","FormatSpec","Read","IoExplist","IoExp","EndSpec",
"Blockif","Elseifs","Elseif","Else","Logicalif","Arithmeticif","Subroutinecall",
"SubstringOp","Explist","Call","Exp","log_disjunct","log_term","log_factor",
"log_primary","@1","arith_expr","term","factor","char_expr","primary","Boolean",
"Constant","Integer","Double","Exponential","Return","Stop","Goto","ComputedGoto",
"Intlist","Parameter","Pdecs","Pdec","External","Intrinsic", NULL
};
#endif

static const short yyr1[] = {     0,
    82,    83,    83,    84,    84,    84,    84,    85,    86,    87,
    88,    89,    89,    90,    91,    92,    92,    93,    93,    93,
    93,    93,    93,    93,    93,    93,    93,    93,    94,    95,
    95,    96,    96,    97,    98,    98,    99,    99,   100,   100,
   100,   101,   101,   102,   103,   103,   104,   105,   105,   106,
   106,   106,   107,   107,   108,   108,   109,   109,   110,   110,
   111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
   111,   111,   111,   111,   111,   111,   111,   112,   113,   114,
   115,   116,   116,   117,   117,   118,   119,   119,   119,   120,
   121,   121,   122,   122,   123,   124,   124,   125,   126,   126,
   127,   127,   127,   128,   129,   130,   130,   130,   131,   131,
   132,   133,   133,   134,   134,   135,   135,   136,   137,   137,
   138,   138,   138,   139,   139,   139,   139,   140,   140,   141,
   141,   141,   142,   142,   143,   144,   145,   145,   146,   146,
   146,   146,   146,   147,   147,   148,   148,   148,   149,   149,
   149,   150,   151,   152,   152,   152,   153,   154,   154,   155,
   156,   157,   158,   159,   159,   159,   160,   160,   161,   161,
   161,   162,   162,   163,   163,   164,   164,   165,   166,   165,
   167,   167,   167,   167,   167,   168,   168,   168,   169,   169,
   170,   170,   171,   171,   171,   171,   171,   172,   172,   173,
   173,   173,   173,   173,   174,   175,   176,   177,   178,   179,
   180,   180,   181,   181,   182,   183,   183,   184,   185,   186
};

static const short yyr2[] = {     0,
     1,     1,     2,     1,     1,     1,     1,     4,     4,     4,
     3,     4,     3,     5,     1,     1,     2,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     2,     1,     3,     3,
     5,     1,     3,     3,     1,     2,     4,     2,     2,     5,
     3,     1,     3,     2,     1,     3,     4,     1,     3,     1,
     2,     3,     1,     3,     1,     7,     3,     5,     1,     2,
     2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     2,     5,     3,
     2,     3,     2,     1,     3,     3,     1,     3,     5,     1,
     1,     3,     1,     1,     1,     1,     1,     4,     1,     3,
     1,     1,     3,     1,     3,     1,     4,     6,     1,     3,
     2,     2,     3,     4,     6,     2,     3,     4,     1,     2,
     1,     1,     1,     1,     1,     3,     3,     1,     1,     1,
     1,     1,     1,     2,     3,     8,     1,     1,     3,     1,
     3,     1,     3,     8,    10,     1,     3,     0,     1,     9,
    11,     3,    11,     0,     1,     2,     7,     0,     3,     5,
    10,     4,     6,     1,     3,     0,     3,     3,     1,     3,
     3,     1,     3,     1,     3,     1,     2,     1,     0,     4,
     1,     2,     2,     3,     3,     1,     3,     3,     1,     3,
     1,     3,     1,     1,     1,     1,     3,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     2,     2,     3,
     6,     7,     1,     3,     5,     1,     3,     1,     3,     3
};

static const short yydefact[] = {     0,
     0,     0,    90,     0,     1,     2,     4,     5,     6,     0,
     0,     0,     7,     0,    95,     0,     0,    78,     3,    18,
     0,     0,     0,     0,     0,    42,     0,     0,     0,    15,
    16,    19,    20,    21,    26,     0,    28,    23,     0,    87,
    25,    24,    22,     0,     0,     0,    11,     0,    13,     0,
     0,     0,     0,    35,     0,     0,     0,    84,     0,     0,
     0,     0,    39,     0,     0,    44,    45,     0,    53,   106,
    55,   205,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    59,    76,    75,    77,     0,     0,    66,
     0,    70,    71,    72,    73,    65,    63,    64,    62,     0,
    67,    74,    69,    68,    17,    27,     0,    91,    93,    94,
   104,     0,     0,     0,     0,    83,     0,    12,     0,    38,
    34,    36,     0,    32,     0,    29,     0,   219,   218,     0,
   216,   220,    43,     0,    41,     0,     0,     0,     0,     0,
     0,   112,     0,     0,   209,     0,     0,     0,     0,   208,
     0,     0,     0,    60,     8,    61,     0,     0,   111,     0,
     0,   116,     0,     0,    86,     0,     0,    88,     9,    10,
     0,    82,     0,    30,     0,     0,    85,     0,     0,     0,
     0,    46,     0,   206,   207,   198,   199,    96,    97,     0,
    48,   204,   203,    50,   200,   201,   202,    54,     0,     0,
     0,     0,   193,     0,   195,   196,   109,   169,   172,   174,
   176,   178,   181,   186,   189,   191,   194,     0,   113,   213,
     0,   210,     0,    80,   166,   168,   167,   138,     0,   137,
     0,    81,   105,     0,   135,     0,   117,    92,     0,    99,
   102,   101,     0,    14,    37,    33,     0,   215,   217,    40,
     0,    51,    47,     0,     0,   183,   182,     0,   177,   166,
   107,     0,     0,     0,     0,     0,     0,   179,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   164,
     0,     0,     0,     0,     0,   131,   132,   130,   124,   125,
   128,     0,   119,   121,   122,   123,   129,   133,    98,     0,
     0,    89,    31,     0,    49,    52,   197,   164,   110,     0,
   170,   171,   173,   175,     0,   184,   185,   188,   187,   190,
   192,     0,   160,     0,     0,     0,   214,    79,   162,     0,
   142,     0,     0,   140,     0,     0,   114,   134,     0,     0,
   118,   120,   100,   103,     0,     0,     0,   108,   180,     0,
     0,     0,   211,   165,     0,   148,     0,   148,     0,   127,
   126,    56,     0,     0,   154,     0,   212,   141,   143,   139,
     0,     0,   146,   149,     0,     0,     0,   115,    57,   163,
     0,   158,   155,     0,     0,     0,   144,     0,   148,   136,
     0,     0,     0,   156,     0,     0,     0,   147,   152,     0,
    58,     0,     0,     0,   161,     0,   145,     0,   159,   153,
     0,     0,     0,     0,     0,   157,     0,   150,     0,     0,
   151,     0,     0,     0
};

static const short yydefgoto[] = {   422,
     5,     6,     7,     8,     9,    10,    11,    12,    29,    30,
    31,    32,    56,   123,    33,    53,    54,    34,    35,    36,
    66,    67,   190,   191,    68,    69,   345,    83,    84,    85,
    86,    87,   155,    50,    57,    38,    39,    40,   107,   108,
   203,   192,   110,   239,   240,   241,    88,    89,   204,    90,
    91,   159,    92,   163,   292,   293,   294,   295,   296,   297,
    93,    94,   229,   333,    95,   372,   373,   376,    96,   382,
   383,   395,    97,    98,   205,   206,   279,    99,   374,   208,
   209,   210,   211,   315,   212,   213,   214,   215,   216,   193,
   217,   195,   196,   197,   101,   102,   103,   104,   221,    41,
   130,   131,    42,    43
};

static const short yypact[] = {    15,
    18,    18,-32768,    80,    15,-32768,-32768,-32768,-32768,   598,
   598,   598,-32768,    64,-32768,   117,    16,-32768,-32768,-32768,
   194,   144,    18,   168,    18,   176,   155,    12,   507,   598,
-32768,-32768,-32768,-32768,-32768,   205,-32768,-32768,    18,   218,
-32768,-32768,-32768,   507,   507,    18,-32768,    94,-32768,   227,
    18,    18,   191,-32768,    18,     9,   229,-32768,    18,   308,
   236,    18,-32768,   316,    18,   246,-32768,   264,   277,   287,
-32768,-32768,   295,   303,     2,   321,   301,    18,    18,   353,
   338,   373,   426,-32768,-32768,-32768,-32768,   375,   379,-32768,
    18,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   240,
-32768,-32768,-32768,-32768,-32768,-32768,   317,-32768,   382,-32768,
-32768,    11,   426,   426,   388,-32768,    65,-32768,   386,   389,
-32768,-32768,    87,-32768,   392,-32768,    18,-32768,-32768,    90,
-32768,-32768,-32768,   105,-32768,   390,    12,   167,    12,   596,
   596,   394,   303,   393,-32768,    18,   395,    58,   396,-32768,
   329,   329,   397,-32768,-32768,-32768,   596,   401,-32768,   400,
   398,-32768,   403,    18,-32768,   552,   218,-32768,-32768,-32768,
   404,-32768,    18,-32768,    18,    18,-32768,   405,    18,   407,
    18,-32768,    84,-32768,-32768,-32768,-32768,-32768,-32768,   309,
-32768,-32768,-32768,   415,-32768,-32768,-32768,-32768,   515,   515,
   596,   634,   418,   241,-32768,-32768,   179,   410,   408,-32768,
   413,   344,    60,-32768,   374,-32768,-32768,   131,-32768,-32768,
   254,-32768,   422,-32768,   596,-32768,-32768,-32768,   421,   292,
   423,-32768,   292,   596,-32768,   221,-32768,-32768,   258,-32768,
-32768,   201,   427,-32768,   389,-32768,   279,-32768,-32768,-32768,
   430,-32768,-32768,   167,    84,    60,    60,   135,   413,   596,
-32768,   596,   596,   596,   596,   596,   596,-32768,   515,   515,
   515,   515,   515,   515,   429,   583,   303,   425,   283,   292,
     8,     8,   234,   303,   221,-32768,-32768,-32768,-32768,   354,
-32768,   137,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   552,
   596,-32768,-32768,   303,-32768,-32768,-32768,   209,   292,   162,
   410,   410,   408,-32768,   634,    60,    60,-32768,-32768,-32768,
-32768,   434,-32768,   383,   596,   219,-32768,-32768,-32768,   596,
-32768,   431,   290,-32768,   435,   596,-32768,-32768,   156,    84,
-32768,-32768,-32768,   292,   438,   440,   596,-32768,   436,   507,
   303,   248,-32768,   292,    30,   627,   406,   627,   261,-32768,
-32768,-32768,   303,   164,   472,   442,-32768,-32768,-32768,-32768,
   596,   343,-32768,   292,   449,   456,   355,-32768,   454,-32768,
   465,   320,-32768,   303,   113,   627,-32768,   303,   627,-32768,
   303,   596,   460,-32768,   437,   463,    18,-32768,-32768,   362,
-32768,   189,   507,   466,-32768,   471,-32768,   447,   507,-32768,
   596,   473,    21,   507,   596,   507,   133,-32768,   596,   217,
-32768,   486,   490,-32768
};

static const short yypgoto[] = {-32768,
-32768,   489,-32768,-32768,-32768,-32768,-32768,-32768,   360,-32768,
   467,-32768,-32768,   322,-32768,-32768,   443,-32768,-32768,-32768,
-32768,   369,-32768,   245,   368,-32768,-32768,   -40,   -48,    92,
-32768,-32768,   272,   402,    43,-32768,-32768,   304,-32768,   346,
    -1,  -230,-32768,-32768,   208,   -38,   -49,   -19,-32768,-32768,
-32768,-32768,-32768,-32768,   226,  -280,-32768,-32768,-32768,-32768,
-32768,-32768,   361,   239,-32768,  -329,   130,-32768,-32768,-32768,
   136,-32768,-32768,-32768,   444,-32768,-32768,-32768,    45,   134,
   256,   257,  -194,-32768,-32768,  -186,    69,-32768,   252,-32768,
  -127,   -26,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   350,-32768,-32768
};


#define	YYLAST		685


static const short yytable[] = {    16,
    17,   112,   100,   113,   114,   291,   143,   259,    71,   129,
   194,   342,   256,   257,   331,   167,    65,   100,   100,   125,
    48,    58,   126,    58,    72,    58,    70,    70,   377,    49,
    72,   415,    15,    72,   154,   124,   368,   109,    15,   264,
   265,   158,    70,    70,   115,   136,    58,   142,   144,   119,
    58,   162,    72,    70,   291,   252,   100,    70,   342,   400,
    58,   291,   225,    70,   154,   154,   271,    60,   272,    64,
   172,   226,     1,   100,     2,   127,   147,   148,     3,   188,
   189,    70,   316,   317,   332,   168,   100,   100,     4,    70,
   117,    13,   174,    18,   120,   178,    13,   175,    70,   116,
   179,    37,    37,    37,   134,   184,    72,   185,   291,   186,
   187,    70,    70,   180,    15,   127,   220,    71,   307,    71,
   349,    37,    46,   397,   369,   177,   194,   306,   243,   129,
    47,   264,   265,   188,   189,    70,   275,    70,   418,   284,
   307,   285,   341,   419,   223,   286,   287,   288,    55,   264,
   265,   264,   265,   264,   265,   246,   124,    15,   284,    72,
   285,   360,   109,    62,   286,   287,   288,   348,    63,   380,
   183,    58,    59,    70,    70,    15,    15,    70,    72,   251,
   264,   265,   264,   265,   207,   218,   188,   189,   184,    72,
   185,   263,   186,   187,   408,   230,   230,   264,   265,    51,
    52,   233,    51,    52,   121,   188,   189,   264,   265,   298,
   242,    61,   361,   301,   289,   245,   188,   189,   106,   264,
   265,   347,   421,   284,   111,   285,   323,   264,   265,   286,
   287,   288,   353,   289,   290,   264,   265,   264,   265,   127,
   118,    15,   128,    72,   336,   258,   261,   337,   324,   133,
   327,   262,   264,   265,   334,   334,   137,   338,   298,   276,
    15,   367,    72,   299,   277,   298,   264,   265,   300,   280,
   188,   189,   138,    70,   378,   162,    73,   346,   283,   264,
   265,    74,    75,   290,   303,   160,    76,   139,   329,   175,
   290,   140,    77,   330,    78,   356,   161,   100,   289,   141,
   357,    79,    80,    14,   308,   146,   309,   310,    14,   365,
   264,   265,   298,     4,    81,    82,   154,   253,   127,   254,
   326,   132,    70,   100,   366,    72,   127,   164,   370,   135,
   165,   199,   200,   201,   145,   228,   379,   290,   100,   318,
   319,   320,   151,   202,   242,   344,   269,   270,    70,    15,
   184,    72,   185,   386,   186,   187,   387,   396,   393,   381,
   154,   399,   409,    70,   401,   386,   150,   154,   390,   352,
    44,    45,   386,   416,   354,   407,   100,   152,   188,   189,
   359,   273,   100,   274,   169,   170,   166,   100,   156,   100,
   157,   364,    48,   351,   173,   406,   176,   311,   312,   127,
   181,    70,   236,    15,   219,    72,   222,    70,   224,   227,
   232,   234,    70,   235,    70,   385,   237,   244,   248,    73,
   250,   255,   260,   267,    74,    75,   266,   278,   160,    76,
   268,   281,   302,   282,   340,    77,   402,    78,   328,   161,
   358,   304,   355,   362,    79,    80,    15,   350,    72,    15,
   363,    72,   384,-32768,   375,   413,     4,    81,    82,   417,
   388,   389,    73,   420,   391,    73,   322,    74,    75,   392,
    74,    75,    76,   403,   153,    76,   405,   404,    77,   410,
    78,    77,   411,    78,   412,   423,   414,    79,    80,   424,
    79,    80,    15,    19,    72,   122,   105,   247,   305,     4,
    81,    82,     4,    81,    82,   182,   198,   343,    73,   238,
   339,   381,   231,    74,    75,   398,   171,   394,    76,   201,
   335,   313,   149,   314,    77,   321,    78,    15,   249,    72,
     0,     0,     0,    79,    80,    15,   184,    72,   185,     0,
   186,   187,     0,    73,     0,     4,    81,    82,    74,    75,
     0,     0,     0,    76,   199,   200,   201,     0,   111,    77,
     0,    78,     0,     0,   188,   189,   202,     0,    79,    80,
     0,     0,    15,   184,    72,   185,     0,   186,   187,     0,
     4,    81,    82,     0,     0,   199,   200,   201,     0,     0,
     0,     0,     0,   325,     0,     0,     0,   202,   199,   200,
   201,   188,   189,    15,   184,    72,   185,     0,   186,   187,
   202,     0,     0,     0,     0,     0,    15,   184,    72,   185,
     0,   186,   187,     0,     0,     0,     0,     0,     0,   199,
   200,   371,   188,   189,     0,     0,   199,   200,   201,     0,
     0,   202,     0,     0,     0,   188,   189,    15,   184,    72,
   185,     0,   186,   187,    15,   184,    72,   185,     0,   186,
   187,     3,    20,    21,    22,    23,    24,    25,    26,    27,
    28,     4,     0,     0,     0,     0,   188,   189,     0,     0,
     0,     0,     0,   188,   189
};

static const short yycheck[] = {     1,
     2,    40,    29,    44,    45,   236,     5,   202,    28,    59,
   138,   292,   199,   200,     7,     5,     5,    44,    45,    11,
     5,    23,    14,    25,    23,    27,    28,    29,   358,    14,
    23,    11,    21,    23,    83,    55,     7,    39,    21,    19,
    20,    91,    44,    45,    46,    65,    48,    74,    75,    51,
    52,   100,    23,    55,   285,   183,    83,    59,   339,   389,
    62,   292,     5,    65,   113,   114,     7,    25,     9,    27,
     6,    14,    58,   100,    60,    11,    78,    79,    64,    50,
    51,    83,   269,   270,    77,   112,   113,   114,    74,    91,
    48,     0,     6,    14,    52,     6,     5,    11,   100,     6,
    11,    10,    11,    12,    62,    22,    23,    24,   339,    26,
    27,   113,   114,     9,    21,    11,   143,   137,     6,   139,
   315,    30,    59,    11,   355,   127,   254,   255,   167,   179,
    14,    19,    20,    50,    51,   137,     6,   139,     6,     3,
     6,     5,     6,    11,   146,     9,    10,    11,     5,    19,
    20,    19,    20,    19,    20,   175,   176,    21,     3,    23,
     5,     6,   164,     9,     9,    10,    11,     6,    14,     6,
     4,   173,     5,   175,   176,    21,    21,   179,    23,   181,
    19,    20,    19,    20,   140,   141,    50,    51,    22,    23,
    24,    13,    26,    27,     6,   151,   152,    19,    20,     9,
    10,   157,     9,    10,    14,    50,    51,    19,    20,   236,
   166,    36,   340,    13,    78,   173,    50,    51,    14,    19,
    20,    13,     6,     3,     7,     5,   275,    19,    20,     9,
    10,    11,    14,    78,   236,    19,    20,    19,    20,    11,
    14,    21,    14,    23,    11,   201,     6,    14,   275,    14,
   277,    11,    19,    20,   281,   282,    11,   284,   285,     6,
    21,    14,    23,     6,    11,   292,    19,    20,    11,   225,
    50,    51,     9,   275,    14,   324,    37,   304,   234,    19,
    20,    42,    43,   285,     6,    46,    47,    11,     6,    11,
   292,     5,    53,    11,    55,     6,    57,   324,    78,     5,
    11,    62,    63,     0,   260,     5,   262,   263,     5,   350,
    19,    20,   339,    74,    75,    76,   365,     9,    11,    11,
   276,    14,   324,   350,   351,    23,    11,    11,   355,    14,
    14,     3,     4,     5,    14,     7,   363,   339,   365,   271,
   272,   273,     5,    15,   300,   301,     3,     4,   350,    21,
    22,    23,    24,    11,    26,    27,    14,   384,    39,    40,
   409,   388,   403,   365,   391,    11,    14,   416,    14,   325,
    11,    12,    11,   414,   330,    14,   403,     5,    50,    51,
   336,     8,   409,    10,   113,   114,     5,   414,    14,   416,
    12,   347,     5,    11,     9,   397,     5,   264,   265,    11,
    11,   403,     5,    21,    11,    23,    14,   409,    14,    14,
    14,    11,   414,    14,   416,   371,    14,    14,    14,    37,
    14,     7,     5,    16,    42,    43,    17,     6,    46,    47,
    18,    11,     6,    11,    81,    53,   392,    55,    14,    57,
     6,    12,    12,     6,    62,    63,    21,    14,    23,    21,
    11,    23,    11,    18,    49,   411,    74,    75,    76,   415,
    12,     6,    37,   419,    11,    37,    38,    42,    43,     5,
    42,    43,    47,    14,    49,    47,    14,    41,    53,    14,
    55,    53,    12,    55,    38,     0,    14,    62,    63,     0,
    62,    63,    21,     5,    23,    53,    30,   176,   254,    74,
    75,    76,    74,    75,    76,   137,   139,   300,    37,   164,
   285,    40,   152,    42,    43,   386,   115,   382,    47,     5,
   282,   266,    79,   267,    53,   274,    55,    21,   179,    23,
    -1,    -1,    -1,    62,    63,    21,    22,    23,    24,    -1,
    26,    27,    -1,    37,    -1,    74,    75,    76,    42,    43,
    -1,    -1,    -1,    47,     3,     4,     5,    -1,     7,    53,
    -1,    55,    -1,    -1,    50,    51,    15,    -1,    62,    63,
    -1,    -1,    21,    22,    23,    24,    -1,    26,    27,    -1,
    74,    75,    76,    -1,    -1,     3,     4,     5,    -1,    -1,
    -1,    -1,    -1,    11,    -1,    -1,    -1,    15,     3,     4,
     5,    50,    51,    21,    22,    23,    24,    -1,    26,    27,
    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,
    -1,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,     3,
     4,     5,    50,    51,    -1,    -1,     3,     4,     5,    -1,
    -1,    15,    -1,    -1,    -1,    50,    51,    21,    22,    23,
    24,    -1,    26,    27,    21,    22,    23,    24,    -1,    26,
    27,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    -1,    -1,    -1,    -1,    50,    51,    -1,    -1,
    -1,    -1,    -1,    50,    51
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 169 "f2jparse.y"
{
            AST *temp, *prev, *commentList = NULL;

            if(debug)
              printf("F2java -> Sourcecodes\n");
	    yyval.ptnode = addnode();
	    yyval.ptnode = switchem(yyvsp[0].ptnode);

#if VCG
            if(emittem) start_vcg(yyval.ptnode);
#endif
            prev = NULL;
            for(temp=yyval.ptnode;temp!=NULL;temp=temp->nextstmt)
            {
              if(emittem) {

                if(temp->nodetype == Comment)
                {
                  if((prev == NULL) ||
                     ((prev != NULL) && (prev->nodetype != Comment)))
                    commentList = temp;
                }
                else
                {
                  /* commentList may be NULL here so we must check
                   * for that in codegen.
                   */
                  temp->astnode.source.prologComments = commentList;

                  typecheck(temp);

                  if(omitWrappers)
                    optScalar(temp);

                  emit(temp);

                  commentList = NULL;
                }
              }
              prev = temp;
            }
          ;
    break;}
case 2:
#line 214 "f2jparse.y"
{
                 AST *temp;

                 if(debug)
                   printf("Sourcecodes -> Sourcecode\n"); 
                 yyval.ptnode=yyvsp[0].ptnode;

                 /* insert the name of the program unit into the
                  * global function table.  this will allow optScalar()
                  * to easily get a pointer to a function. 
                  */

                 if(omitWrappers && (yyvsp[0].ptnode->nodetype != Comment)) {
                   temp = yyvsp[0].ptnode->astnode.source.progtype->astnode.source.name;

                   type_insert(global_func_table, yyvsp[0].ptnode, 0, temp->astnode.ident.name);
                 }
               ;
    break;}
case 3:
#line 233 "f2jparse.y"
{
                 AST *temp;

                 if(debug)
                   printf("Sourcecodes -> Sourcecodes Sourcecode\n");
                 yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode; 
                 yyval.ptnode=yyvsp[0].ptnode;

                 /* insert the name of the program unit into the
                  * global function table.  this will allow optScalar()
                  * to easily get a pointer to a function. 
                  */

                 if(omitWrappers && (yyvsp[0].ptnode->nodetype != Comment)) {
                   temp = yyvsp[0].ptnode->astnode.source.progtype->astnode.source.name;

                   type_insert(global_func_table, yyvsp[0].ptnode, 0, temp->astnode.ident.name);
                 }
               ;
    break;}
case 4:
#line 255 "f2jparse.y"
{ 
                  if(debug)
                    printf("Sourcecode -> Fprogram\n"); 
                  yyval.ptnode=yyvsp[0].ptnode;
                ;
    break;}
case 5:
#line 261 "f2jparse.y"
{ 
                  if(debug)
                    printf("Sourcecode -> Fsubroutine\n"); 
                  yyval.ptnode=yyvsp[0].ptnode;
                ;
    break;}
case 6:
#line 267 "f2jparse.y"
{ 
                  if(debug)
                    printf("Sourcecode -> Ffunction\n"); 
                  yyval.ptnode=yyvsp[0].ptnode;
                ;
    break;}
case 7:
#line 273 "f2jparse.y"
{ 
                  if(debug)
                    printf("Sourcecode -> Comment\n"); 
                  yyval.ptnode=yyvsp[0].ptnode;
                ;
    break;}
case 8:
#line 281 "f2jparse.y"
{
                if(debug)
                  printf("Fprogram -> Program  Specstmts  Statements End\n");

                yyval.ptnode = addnode();

                /* store the tables built during parsing into the
                 * AST node for access during code generation.
                 */

                yyval.ptnode->astnode.source.type_table = type_table;
                yyval.ptnode->astnode.source.external_table = external_table;
                yyval.ptnode->astnode.source.intrinsic_table = intrinsic_table;
                yyval.ptnode->astnode.source.args_table = args_table;
                yyval.ptnode->astnode.source.array_table = array_table; 
                yyval.ptnode->astnode.source.format_table = format_table; 
                yyval.ptnode->astnode.source.data_table = data_table; 
                yyval.ptnode->astnode.source.save_table = save_table; 
                yyval.ptnode->astnode.source.common_table = common_table; 
                yyval.ptnode->astnode.source.parameter_table = parameter_table; 
                yyval.ptnode->astnode.source.constants_table = constants_table;
                yyval.ptnode->astnode.source.equivalences = equivList; 

                yyval.ptnode->astnode.source.javadocComments = NULL; 

                /* initialize some values in this node */

                yyval.ptnode->astnode.source.needs_input = FALSE;
                yyval.ptnode->astnode.source.needs_reflection = FALSE;
                yyval.ptnode->astnode.source.needs_blas = FALSE;

                if(omitWrappers)
                  yyval.ptnode->astnode.source.scalarOptStatus = NOT_VISITED;

	        yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                yyval.ptnode->nodetype = Progunit;
                yyval.ptnode->astnode.source.progtype = yyvsp[-3].ptnode;
                yyval.ptnode->astnode.source.typedecs = yyvsp[-2].ptnode;
                yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
                yyval.ptnode->astnode.source.statements = switchem(yyvsp[0].ptnode);

                /* a PROGRAM has no args, so set the symbol table
                   to NULL */
                args_table = NULL;  
              ;
    break;}
case 9:
#line 333 "f2jparse.y"
{
                HASHNODE *ht;
                AST *temp;

                if(debug)
                  printf("Fsubroutine -> Subroutine Specstmts Statements End\n");
                yyval.ptnode = addnode();
	        yyvsp[-3].ptnode->parent = yyval.ptnode; 
	        yyvsp[-2].ptnode->parent = yyval.ptnode;
	        yyvsp[-1].ptnode->parent = yyval.ptnode;
	        yyvsp[0].ptnode->parent = yyval.ptnode;
                yyval.ptnode->nodetype = Progunit;
                yyval.ptnode->astnode.source.progtype = yyvsp[-3].ptnode;

                /* store the tables built during parsing into the
                 * AST node for access during code generation.
                 */

                yyval.ptnode->astnode.source.type_table = type_table;
                yyval.ptnode->astnode.source.external_table = external_table;
                yyval.ptnode->astnode.source.intrinsic_table = intrinsic_table;
                yyval.ptnode->astnode.source.args_table = args_table;
                yyval.ptnode->astnode.source.array_table = array_table; 
                yyval.ptnode->astnode.source.format_table = format_table; 
                yyval.ptnode->astnode.source.data_table = data_table; 
                yyval.ptnode->astnode.source.save_table = save_table; 
                yyval.ptnode->astnode.source.common_table = common_table; 
                yyval.ptnode->astnode.source.parameter_table = parameter_table; 
                yyval.ptnode->astnode.source.constants_table = constants_table;
                yyval.ptnode->astnode.source.equivalences = equivList; 

                yyval.ptnode->astnode.source.javadocComments = NULL; 

                /* initialize some values in this node */

                yyval.ptnode->astnode.source.needs_input = FALSE;
                yyval.ptnode->astnode.source.needs_reflection = FALSE;
                yyval.ptnode->astnode.source.needs_blas = FALSE;

                if(omitWrappers)
                  yyval.ptnode->astnode.source.scalarOptStatus = NOT_VISITED;

                yyval.ptnode->astnode.source.typedecs = yyvsp[-2].ptnode;
                yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
                yyval.ptnode->astnode.source.statements = switchem(yyvsp[0].ptnode);

                /* foreach arg to this program unit, store the array 
                 * size, if applicable, from the hash table into the
                 * node itself.
                 */

                for(temp=yyvsp[-3].ptnode->astnode.source.args;temp!=NULL;temp=temp->nextstmt)
                {
                  if((ht=type_lookup(type_table,temp->astnode.ident.name)) != NULL)
                  {
                    temp->vartype=ht->variable->vartype;
                    temp->astnode.ident.arraylist=ht->variable->astnode.ident.arraylist;
                  }
                }

                type_insert(function_table, yyvsp[-3].ptnode, 0,
                   yyvsp[-3].ptnode->astnode.source.name->astnode.ident.name);
              ;
    break;}
case 10:
#line 399 "f2jparse.y"
{
                HASHNODE *ht;
                AST *temp;

                if(debug)
                  printf("Ffunction ->   Function Specstmts Statements  End\n");

                yyval.ptnode = addnode();

                /* store the tables built during parsing into the
                 * AST node for access during code generation.
                 */

                yyval.ptnode->astnode.source.type_table = type_table;
                yyval.ptnode->astnode.source.external_table = external_table;
                yyval.ptnode->astnode.source.intrinsic_table = intrinsic_table;
                yyval.ptnode->astnode.source.args_table = args_table;
                yyval.ptnode->astnode.source.array_table = array_table; 
                yyval.ptnode->astnode.source.format_table = format_table; 
                yyval.ptnode->astnode.source.data_table = data_table; 
                yyval.ptnode->astnode.source.save_table = save_table; 
                yyval.ptnode->astnode.source.common_table = common_table; 
                yyval.ptnode->astnode.source.parameter_table = parameter_table; 
                yyval.ptnode->astnode.source.constants_table = constants_table;
                yyval.ptnode->astnode.source.equivalences = equivList; 

                yyval.ptnode->astnode.source.javadocComments = NULL; 

                /* initialize some values in this node */

                yyval.ptnode->astnode.source.needs_input = FALSE;
                yyval.ptnode->astnode.source.needs_reflection = FALSE;
                yyval.ptnode->astnode.source.needs_blas = FALSE;
                if(omitWrappers)
                  yyval.ptnode->astnode.source.scalarOptStatus = NOT_VISITED;

	        yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	        yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                yyval.ptnode->nodetype = Progunit;
                yyval.ptnode->astnode.source.progtype = yyvsp[-3].ptnode;
                yyval.ptnode->astnode.source.typedecs = yyvsp[-2].ptnode;
		yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
                yyval.ptnode->astnode.source.statements = switchem(yyvsp[0].ptnode);

                /* foreach arg to this program unit, store the array 
                 * size, if applicable, from the hash table into the
                 * node itself.
                 */

                for(temp=yyvsp[-3].ptnode->astnode.source.args;temp!=NULL;temp=temp->nextstmt)
                {
                  if((ht=type_lookup(type_table,temp->astnode.ident.name)) != NULL)
                  {
                    temp->vartype=ht->variable->vartype;
                    temp->astnode.ident.arraylist=ht->variable->astnode.ident.arraylist;
                  }
                }

                type_insert(function_table, yyvsp[-3].ptnode, 0,
                  yyvsp[-3].ptnode->astnode.source.name->astnode.ident.name);
              ;
    break;}
case 11:
#line 465 "f2jparse.y"
{
                 if(debug)
                   printf("Program ->  PROGRAM Name\n");

                 yyval.ptnode = addnode();
	         yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
		 lowercase(yyvsp[-1].ptnode->astnode.ident.name);
		 yyval.ptnode->astnode.source.name = yyvsp[-1].ptnode;
                 yyval.ptnode->nodetype = Program;
                 yyval.ptnode->token = PROGRAM;
                 yyval.ptnode->astnode.source.args = NULL;

                 init_tables();

                 fprintf(stderr," MAIN %s:\n",yyvsp[-1].ptnode->astnode.ident.name);
              ;
    break;}
case 12:
#line 484 "f2jparse.y"
{
                 if(debug)
                   printf("Subroutine ->  SUBROUTINE Name Functionargs NL\n");

                 yyval.ptnode = addnode();
                 yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                 if(yyvsp[-1].ptnode != NULL)
                   yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */

        /*         lowercase($2->astnode.ident.name);
                      commented out 11-7-97 - Keith */

                 yyval.ptnode->astnode.source.name = yyvsp[-2].ptnode; 
                 yyval.ptnode->nodetype = Subroutine;
                 yyval.ptnode->token = SUBROUTINE;
                 if(yyvsp[-1].ptnode == NULL)
                   yyval.ptnode->astnode.source.args = NULL;
                 else
                   yyval.ptnode->astnode.source.args = switchem(yyvsp[-1].ptnode);

                 fprintf(stderr,"\t%s:\n",yyvsp[-2].ptnode->astnode.ident.name);
              ;
    break;}
case 13:
#line 507 "f2jparse.y"
{
                 if(debug)
                   printf("Subroutine ->  SUBROUTINE Name NL\n");

                 init_tables();
                 yyval.ptnode = addnode();
                 yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */

        /*         lowercase($2->astnode.ident.name);  
                       commented out 11-7-97 - Keith */
                 yyval.ptnode->astnode.source.name = yyvsp[-1].ptnode; 
                 yyval.ptnode->nodetype = Subroutine;
                 yyval.ptnode->token = SUBROUTINE;
                 yyval.ptnode->astnode.source.args = NULL;
                 fprintf(stderr,"\t%s:\n",yyvsp[-1].ptnode->astnode.ident.name);
              ;
    break;}
case 14:
#line 526 "f2jparse.y"
{
             HASHNODE *hash_entry;

             if(debug)
               printf("Function ->  Type FUNCTION Name Functionargs NL\n");
             yyval.ptnode = addnode();

  	     yyvsp[-2].ptnode->parent = yyval.ptnode;  /* 9-4-97 - Keith */
             if(yyvsp[-1].ptnode != NULL)
               yyvsp[-1].ptnode->parent = yyval.ptnode;  /* 9-4-97 - Keith */
             yyval.ptnode->astnode.source.name = yyvsp[-2].ptnode;
             yyval.ptnode->nodetype = Function;
             yyval.ptnode->token = FUNCTION;
             yyval.ptnode->astnode.source.returns = yyvsp[-4].type;
             yyval.ptnode->vartype = yyvsp[-4].type;
             if(yyvsp[-1].ptnode == NULL)
               yyval.ptnode->astnode.source.args = NULL;
             else 
               yyval.ptnode->astnode.source.args = switchem(yyvsp[-1].ptnode);

             /* since the function name is the implicit return value
              * and it can be treated as a variable, we insert it into
              * the hash table for lookup later.
              */

             hash_entry = type_lookup(type_table,yyvsp[-2].ptnode->astnode.ident.name);

             if(hash_entry == NULL)
               yyvsp[-2].ptnode->vartype = yyvsp[-4].type;
             else
               yyvsp[-2].ptnode->vartype = hash_entry->variable->vartype;

             type_insert(type_table, yyvsp[-2].ptnode, yyvsp[-2].ptnode->vartype, yyvsp[-2].ptnode->astnode.ident.name);

             fprintf(stderr,"\t%s:\n",yyvsp[-2].ptnode->astnode.ident.name);
           ;
    break;}
case 15:
#line 565 "f2jparse.y"
{
             yyvsp[0].ptnode = switchem(yyvsp[0].ptnode);
             type_hash(yyvsp[0].ptnode); 
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 16:
#line 573 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 17:
#line 577 "f2jparse.y"
{ 
             yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode; 
             yyval.ptnode = yyvsp[0].ptnode; 
           ;
    break;}
case 18:
#line 584 "f2jparse.y"
{
	     yyval.ptnode = 0;
	     fprintf(stderr,"DIMENSION is not implemented.\n");
	     exit(-1);
	   ;
    break;}
case 19:
#line 590 "f2jparse.y"
{
	     yyval.ptnode = yyvsp[0].ptnode;
	   ;
    break;}
case 20:
#line 594 "f2jparse.y"
{
	     yyval.ptnode = yyvsp[0].ptnode;
	   ;
    break;}
case 21:
#line 598 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 22:
#line 602 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 23:
#line 606 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 24:
#line 610 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 25:
#line 614 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 26:
#line 618 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 27:
#line 622 "f2jparse.y"
{
             yyval.ptnode=yyvsp[-1].ptnode;
           ;
    break;}
case 28:
#line 626 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode;
	   ;
    break;}
case 29:
#line 636 "f2jparse.y"
{
                   yyval.ptnode = addnode();
                   yyval.ptnode->nodetype = Equivalence;
                   yyval.ptnode->prevstmt = NULL;
                   yyval.ptnode->nextstmt = NULL;
                   yyval.ptnode->astnode.equiv.nlist = switchem(yyvsp[-1].ptnode);
                 ;
    break;}
case 30:
#line 646 "f2jparse.y"
{
                   AST *tmp;

                   yyval.ptnode = addnode();
                   yyval.ptnode->nodetype = Equivalence;
                   yyval.ptnode->prevstmt = NULL;
                   yyval.ptnode->nextstmt = NULL;
                   yyval.ptnode->astnode.equiv.clist = switchem(yyvsp[-1].ptnode);

                   for(tmp=yyvsp[-1].ptnode;tmp!=NULL;tmp=tmp->prevstmt)
                     tmp->parent = yyval.ptnode;

                   addEquiv(yyval.ptnode->astnode.equiv.clist);
                 ;
    break;}
case 31:
#line 661 "f2jparse.y"
{
                   AST *tmp;

                   yyval.ptnode = addnode();
                   yyval.ptnode->nodetype = Equivalence;
                   yyval.ptnode->astnode.equiv.clist = switchem(yyvsp[-1].ptnode);
                   yyval.ptnode->prevstmt = yyvsp[-4].ptnode;
                   yyval.ptnode->nextstmt = NULL;

                   for(tmp=yyvsp[-1].ptnode;tmp!=NULL;tmp=tmp->prevstmt)
                     tmp->parent = yyval.ptnode;

                   addEquiv(yyval.ptnode->astnode.equiv.clist);
                 ;
    break;}
case 32:
#line 678 "f2jparse.y"
{
                   yyval.ptnode = yyvsp[0].ptnode;
                 ;
    break;}
case 33:
#line 682 "f2jparse.y"
{
                   yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
                   yyval.ptnode = yyvsp[0].ptnode;
                 ;
    break;}
case 34:
#line 689 "f2jparse.y"
{
          yyval.ptnode = addnode();
          yyval.ptnode->nodetype = CommonList;
          yyval.ptnode->astnode.common.name = NULL;

          yyval.ptnode->astnode.common.nlist = switchem(yyvsp[-1].ptnode);
          merge_common_blocks(yyval.ptnode->astnode.common.nlist);
        ;
    break;}
case 35:
#line 700 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 36:
#line 704 "f2jparse.y"
{
              yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 37:
#line 711 "f2jparse.y"
{
              AST *temp;
              int pos;

              yyval.ptnode = addnode();
              yyval.ptnode->nodetype = Common;
              yyval.ptnode->astnode.common.name = strdup(yyvsp[-2].ptnode->astnode.ident.name);
              yyval.ptnode->astnode.common.nlist = switchem(yyvsp[0].ptnode);

              pos = 0;

              /* foreach variable in the COMMON block... */
              for(temp=yyval.ptnode->astnode.common.nlist;temp!=NULL;temp=temp->nextstmt)
              {
                temp->astnode.ident.commonBlockName = 
                  strdup(yyvsp[-2].ptnode->astnode.ident.name);

                if(omitWrappers)
                  temp->astnode.ident.position = pos++;

                /* insert this name into the common table */
                if(debug)
                  printf("@insert %s (block = %s) into common table\n",
                    temp->astnode.ident.name, yyvsp[-2].ptnode->astnode.ident.name);

                type_insert(common_table, temp, Float, temp->astnode.ident.name);
              }

              type_insert(global_common_table, yyval.ptnode, Float, yyval.ptnode->astnode.common.name);
           ;
    break;}
case 38:
#line 742 "f2jparse.y"
{
              AST *temp;

              /* This is an unnamed common block */

              yyval.ptnode = addnode();
              yyval.ptnode->nodetype = Common;
              yyval.ptnode->astnode.common.name = strdup("Blank");
              yyval.ptnode->astnode.common.nlist = switchem(yyvsp[0].ptnode);

              /* foreach variable in the COMMON block... */
              for(temp=yyvsp[0].ptnode;temp!=NULL;temp=temp->prevstmt) {
                temp->astnode.ident.commonBlockName = "Blank";

                /* insert this name into the common table */

                if(debug)
                  printf("@@insert %s (block = unnamed) into common table\n",
                    temp->astnode.ident.name);

                type_insert(common_table, temp, Float, temp->astnode.ident.name);
              }

              type_insert(global_common_table, yyval.ptnode, Float, yyval.ptnode->astnode.common.name);
           ;
    break;}
case 39:
#line 772 "f2jparse.y"
{
         /*
          * I think in this case every variable is supposed to
          * be saved, but we already emit every variable as
          * static.  do nothing here.  --Keith
          */

         yyval.ptnode = addnode();
         yyval.ptnode->nodetype = Save;
       ;
    break;}
case 40:
#line 783 "f2jparse.y"
{
             AST *temp;

             yyval.ptnode = addnode();
             yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             yyval.ptnode->nodetype = Save;

             for(temp=yyvsp[-2].ptnode;temp!=NULL;temp=temp->prevstmt) {
               if(debug)
                 printf("@@insert %s into save table\n",
                    temp->astnode.ident.name);

               type_insert(save_table, temp, Float, temp->astnode.ident.name);
             }
	   ;
    break;}
case 41:
#line 799 "f2jparse.y"
{
             AST *temp;

             yyval.ptnode = addnode();
             yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             yyval.ptnode->nodetype = Save;

             for(temp=yyvsp[-1].ptnode;temp!=NULL;temp=temp->prevstmt) {
               if(debug)
                 printf("@@insert %s into save table\n",
                    temp->astnode.ident.name);

               type_insert(save_table, temp, Float, temp->astnode.ident.name);
             }
	   ;
    break;}
case 42:
#line 816 "f2jparse.y"
{
	      yyval.ptnode=0;
	      fprintf(stderr,"Must use IMPLICIT NONE.\n");
	      exit(-1);
	    ;
    break;}
case 43:
#line 822 "f2jparse.y"
{
	      yyval.ptnode=addnode();
	      yyval.ptnode->nodetype = Specification;
	      yyval.ptnode->token = IMPLICIT;
	      yyval.ptnode = 0;
	    ;
    break;}
case 44:
#line 832 "f2jparse.y"
{
              /* $$ = $2; */
              yyval.ptnode = addnode();
              yyval.ptnode->nodetype = DataList;
              yyval.ptnode->astnode.label.stmt = yyvsp[0].ptnode;
            ;
    break;}
case 45:
#line 841 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 46:
#line 845 "f2jparse.y"
{
              yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 47:
#line 852 "f2jparse.y"
{
              AST *temp;

              yyval.ptnode = addnode();
              yyval.ptnode->astnode.data.nlist = switchem(yyvsp[-3].ptnode);
              yyval.ptnode->astnode.data.clist = switchem(yyvsp[-1].ptnode);

              yyval.ptnode->nodetype = DataStmt;
              yyval.ptnode->prevstmt = NULL;
              yyval.ptnode->nextstmt = NULL;

              for(temp=yyvsp[-3].ptnode;temp!=NULL;temp=temp->prevstmt) {
                if(debug)
                  printf("@@insert %s into data table\n",
                     temp->astnode.ident.name);
                
                temp->parent = yyval.ptnode;

                if(temp->nodetype == DataImpliedLoop)
                  type_insert(data_table, temp, Float,
                     temp->astnode.forloop.Label->astnode.ident.name);
                else
                  type_insert(data_table, temp, Float, temp->astnode.ident.name);
              }
            ;
    break;}
case 48:
#line 880 "f2jparse.y"
{
                     yyval.ptnode = yyvsp[0].ptnode;
                   ;
    break;}
case 49:
#line 884 "f2jparse.y"
{
                     yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
                     yyval.ptnode = yyvsp[0].ptnode;
                   ;
    break;}
case 50:
#line 891 "f2jparse.y"
{
                 yyval.ptnode = yyvsp[0].ptnode;
               ;
    break;}
case 51:
#line 895 "f2jparse.y"
{
                 prepend_minus(yyvsp[0].ptnode->astnode.constant.number);
                 yyval.ptnode = yyvsp[0].ptnode;
               ;
    break;}
case 52:
#line 900 "f2jparse.y"
{
                 yyval.ptnode = yyvsp[-2].ptnode;
                 yyval.ptnode=addnode();
                 yyval.ptnode->nodetype = Binaryop;
                 yyval.ptnode->token = STAR;
                 yyvsp[-2].ptnode->expr_side = left;
                 yyvsp[0].ptnode->expr_side = right;
                 yyvsp[-2].ptnode->parent = yyval.ptnode;
                 yyvsp[0].ptnode->parent = yyval.ptnode;
                 yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
                 yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
                 yyval.ptnode->astnode.expression.optype = '*';
               ;
    break;}
case 53:
#line 916 "f2jparse.y"
{
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 54:
#line 920 "f2jparse.y"
{
            yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 55:
#line 927 "f2jparse.y"
{
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 56:
#line 931 "f2jparse.y"
{
            yyvsp[-1].ptnode->astnode.forloop.counter = yyvsp[-3].ptnode;
            yyvsp[-1].ptnode->astnode.forloop.Label = yyvsp[-5].ptnode;
            yyval.ptnode = yyvsp[-1].ptnode;
            yyvsp[-5].ptnode->parent = yyval.ptnode;
            yyvsp[-3].ptnode->parent = yyval.ptnode;
          ;
    break;}
case 57:
#line 941 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyvsp[-2].ptnode->parent = yyval.ptnode;
               yyvsp[0].ptnode->parent = yyval.ptnode;
               yyval.ptnode->nodetype = DataImpliedLoop;
               yyval.ptnode->astnode.forloop.start = yyvsp[-2].ptnode;
               yyval.ptnode->astnode.forloop.stop = yyvsp[0].ptnode;
               yyval.ptnode->astnode.forloop.incr = NULL;
             ;
    break;}
case 58:
#line 951 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyvsp[-4].ptnode->parent = yyval.ptnode;
               yyvsp[-2].ptnode->parent = yyval.ptnode;
               yyvsp[0].ptnode->parent = yyval.ptnode;
               yyval.ptnode->nodetype = DataImpliedLoop;
               yyval.ptnode->astnode.forloop.start = yyvsp[-4].ptnode;
               yyval.ptnode->astnode.forloop.stop = yyvsp[-2].ptnode;
               yyval.ptnode->astnode.forloop.incr = yyvsp[0].ptnode;
             ;
    break;}
case 59:
#line 970 "f2jparse.y"
{  
                 yyval.ptnode = yyvsp[0].ptnode; 
               ;
    break;}
case 60:
#line 974 "f2jparse.y"
{ 
                 yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode; 
                 yyval.ptnode = yyvsp[0].ptnode; 
               ;
    break;}
case 61:
#line 981 "f2jparse.y"
{
                yyval.ptnode = yyvsp[-1].ptnode;
                yyval.ptnode->nodetype = Assignment;   
              ;
    break;}
case 62:
#line 986 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Call;
              ;
    break;}
case 63:
#line 991 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Logicalif;
              ;
    break;}
case 64:
#line 996 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Arithmeticif;
              ;
    break;}
case 65:
#line 1001 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Blockif;
              ;
    break;}
case 66:
#line 1006 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Forloop;
              ;
    break;}
case 67:
#line 1011 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Return;
              ;
    break;}
case 68:
#line 1016 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = ComputedGoto;
              ;
    break;}
case 69:
#line 1021 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Goto;
              ;
    break;}
case 70:
#line 1026 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Label;
              ;
    break;}
case 71:
#line 1031 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Label;
              ;
    break;}
case 72:
#line 1036 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Write;
              ;
    break;}
case 73:
#line 1041 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Read;
              ;
    break;}
case 74:
#line 1046 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Stop;
              ;
    break;}
case 75:
#line 1051 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Unimplemented;
              ;
    break;}
case 76:
#line 1056 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Comment;
              ;
    break;}
case 77:
#line 1061 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
                yyval.ptnode->nodetype = Unimplemented;
              ;
    break;}
case 78:
#line 1068 "f2jparse.y"
{
           yyval.ptnode = addnode();
           yyval.ptnode->token = COMMENT;
           yyval.ptnode->nodetype = Comment;
           yyval.ptnode->astnode.ident.len = 0;
           strcpy(yyval.ptnode->astnode.ident.name, yylval.lexeme);
         ;
    break;}
case 79:
#line 1078 "f2jparse.y"
{
          fprintf(stderr,"WArning: CLOSE not implemented.\n");
          yyval.ptnode = yyvsp[-2].ptnode;
        ;
    break;}
case 80:
#line 1085 "f2jparse.y"
{
          fprintf(stderr,"Warning: REWIND not implemented.\n");
          yyval.ptnode = yyvsp[-1].ptnode;
        ;
    break;}
case 81:
#line 1092 "f2jparse.y"
{
          yyval.ptnode = addnode();
          yyval.ptnode->token = END;
          yyval.ptnode->nodetype = End;
        ;
    break;}
case 82:
#line 1107 "f2jparse.y"
{
                  yyvsp[-1].ptnode = switchem(yyvsp[-1].ptnode);
                  init_tables();
		  arg_table_load(yyvsp[-1].ptnode);
                  yyval.ptnode = yyvsp[-1].ptnode;
                ;
    break;}
case 83:
#line 1114 "f2jparse.y"
{
                  init_tables();
                  yyval.ptnode = NULL;
                ;
    break;}
case 84:
#line 1122 "f2jparse.y"
{
              yyval.ptnode=yyvsp[0].ptnode;
            ;
    break;}
case 85:
#line 1126 "f2jparse.y"
{
              yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode; 
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 86:
#line 1140 "f2jparse.y"
{
                 AST *temp;

                 yyval.ptnode = addnode();
	         yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                 /* store_local_var($2);  */
                 yyvsp[-1].ptnode = switchem(yyvsp[-1].ptnode);
                 yyval.ptnode->nodetype = Typedec;

                 for(temp = yyvsp[-1].ptnode; temp != NULL; temp = temp->nextstmt)
                 {
                   temp->vartype = yyvsp[-2].type;
                   temp->astnode.ident.len = len;
                 }

                 yyval.ptnode->astnode.typeunit.declist = yyvsp[-1].ptnode;
                 yyval.ptnode->astnode.typeunit.returns = yyvsp[-2].type; 
	       ;
    break;}
case 87:
#line 1162 "f2jparse.y"
{
               yyval.type = yyvsp[0].type;
               len = 1;
             ;
    break;}
case 88:
#line 1167 "f2jparse.y"
{
               yyval.type = yyvsp[-2].type;
               len = atoi(yyvsp[0].ptnode->astnode.constant.number);
             ;
    break;}
case 89:
#line 1172 "f2jparse.y"
{
               yyval.type = yyvsp[-4].type;
               len = 1;
             ;
    break;}
case 90:
#line 1179 "f2jparse.y"
{ 
         yyval.type = yylval.type;
       ;
    break;}
case 91:
#line 1191 "f2jparse.y"
{
               AST *temp;

               temp = addnode();
               temp->nodetype = Typedec;
               yyvsp[0].ptnode->parent = temp;

               yyval.ptnode = yyvsp[0].ptnode;
             ;
    break;}
case 92:
#line 1201 "f2jparse.y"
{
               yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
               yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
               yyval.ptnode = yyvsp[0].ptnode;
             ;
    break;}
case 93:
#line 1209 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 94:
#line 1213 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 95:
#line 1232 "f2jparse.y"
{
           HASHNODE *hashtemp;

           lowercase(yylval.lexeme);

           if((hashtemp = type_lookup(parameter_table,yylval.lexeme)) != NULL) {
             /* the name we're looking at is defined as a parameter.
              * instead of inserting an Identifier node here, we're just
              * going to insert the Constant node that corresponds to
              * the parameter.  normally the only time we'd worry about
              * such a substitution would be when the ident was the lhs
              * of some expression, but that should not happen with parameters.
              */

             yyval.ptnode = hashtemp->variable; 

           } else {
             yyval.ptnode=addnode();
             yyval.ptnode->token = NAME;
             yyval.ptnode->nodetype = Identifier;

             yyval.ptnode->astnode.ident.needs_declaration = FALSE;
             yyval.ptnode->astnode.ident.lead_expr = NULL;

             if(omitWrappers)
               yyval.ptnode->astnode.ident.passByRef = FALSE;

             if(type_lookup(java_keyword_table,yylval.lexeme) ||
                type_lookup(jasmin_keyword_table,yylval.lexeme))
                   yylval.lexeme[0] = toupper(yylval.lexeme[0]);

             strcpy(yyval.ptnode->astnode.ident.name, yylval.lexeme);

             hashtemp = type_lookup(type_table, yyval.ptnode->astnode.ident.name);
             if(hashtemp)
             {
               yyval.ptnode->vartype = hashtemp->variable->vartype;
               yyval.ptnode->astnode.ident.len = hashtemp->variable->astnode.ident.len;
             }
           }
         ;
    break;}
case 96:
#line 1276 "f2jparse.y"
{
           yyval.ptnode=addnode();
           yyval.ptnode->token = STRING;
           yyval.ptnode->nodetype = Constant;
           strcpy(yyval.ptnode->astnode.constant.number, yylval.lexeme);

           yyval.ptnode->vartype = String;
           if(debug)
             printf("**The string value is %s\n",yyval.ptnode->astnode.constant.number);
         ;
    break;}
case 97:
#line 1287 "f2jparse.y"
{
           yyval.ptnode=addnode();
           yyval.ptnode->token = STRING;
           yyval.ptnode->nodetype = Constant;
           strcpy(yyval.ptnode->astnode.constant.number, yylval.lexeme);

           yyval.ptnode->vartype = String;
           if(debug)
             printf("**The char value is %s\n",yyval.ptnode->astnode.constant.number);
         ;
    break;}
case 98:
#line 1300 "f2jparse.y"
{
                    AST *temp;
                    int count, i;

		    /*
                     *  $$ = addnode();
                     *  $$->nodetype = Identifier;
                     *  strcpy($$->astnode.ident.name, $1->astnode.ident.name);
		     */

		    yyval.ptnode = yyvsp[-3].ptnode;
		    yyval.ptnode->astnode.ident.arraylist = switchem(yyvsp[-1].ptnode);
                  
                    count = 0;
                    for(temp = yyval.ptnode->astnode.ident.arraylist; temp != NULL; 
                        temp=temp->nextstmt)
                      count++;

                    for(temp = yyval.ptnode->astnode.ident.arraylist, i = 0;
                        temp != NULL; 
                        temp=temp->nextstmt, i++)
                    {
                      yyval.ptnode->astnode.ident.D[i] = (int) eval_const_expr(temp);
                      if(temp->nodetype == ArrayIdxRange)
                        printf("@#@# %s dim %d is a range\n",yyval.ptnode->astnode.ident.name,
                           i);
                    }
                       
                    yyval.ptnode->astnode.ident.dim = count;
                    yyval.ptnode->astnode.ident.lead_expr = NULL;
   
                    /* leaddim might be a constant, so check for that.  --keith */
                    if(yyval.ptnode->astnode.ident.arraylist->nodetype == Constant) 
                    {
		      yyval.ptnode->astnode.ident.leaddim = 
                       strdup(yyval.ptnode->astnode.ident.arraylist->astnode.constant.number);
                    }
                    else if((yyval.ptnode->astnode.ident.arraylist->nodetype == Binaryop) ||
                            (yyval.ptnode->astnode.ident.arraylist->nodetype == ArrayIdxRange)) {
		      yyval.ptnode->astnode.ident.lead_expr = yyval.ptnode->astnode.ident.arraylist;
                    } else {
		      yyval.ptnode->astnode.ident.leaddim = 
                       strdup(yyval.ptnode->astnode.ident.arraylist->astnode.ident.name);
                    }

                    if(debug)
                    {
                      printf("leaddim nodetype = %s\n",
                        print_nodetype(yyval.ptnode->astnode.ident.arraylist));

                      if(yyval.ptnode->astnode.ident.leaddim != NULL)
                        printf("setting leaddim = %s\n",yyval.ptnode->astnode.ident.leaddim);
                    }

		    store_array_var(yyval.ptnode);
                  ;
    break;}
case 99:
#line 1358 "f2jparse.y"
{
                    AST *temp;

                    temp = addnode();
                    temp->nodetype = ArrayDec;
                    yyvsp[0].ptnode->parent = temp;

                    yyval.ptnode=yyvsp[0].ptnode;
                  ;
    break;}
case 100:
#line 1368 "f2jparse.y"
{
                    yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode; 
                    yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
                    yyval.ptnode = yyvsp[0].ptnode;
                  ;
    break;}
case 101:
#line 1376 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode; 
           ;
    break;}
case 102:
#line 1380 "f2jparse.y"
{
             yyval.ptnode=yyvsp[0].ptnode;
           ;
    break;}
case 103:
#line 1384 "f2jparse.y"
{
             yyval.ptnode = addnode();
             yyval.ptnode->nodetype = ArrayIdxRange;
             yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
             yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
           ;
    break;}
case 104:
#line 1397 "f2jparse.y"
{
         yyval.ptnode=addnode();
         yyval.ptnode->nodetype = Identifier;
         yyval.ptnode->astnode.ident.lead_expr = NULL;
        *yyval.ptnode->astnode.ident.name = '*';
       ;
    break;}
case 105:
#line 1413 "f2jparse.y"
{ 
                yyval.ptnode = addnode();
                yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
                yyval.ptnode->nodetype = Assignment;
                yyval.ptnode->astnode.assignment.lhs = yyvsp[-2].ptnode;
                yyval.ptnode->astnode.assignment.rhs = yyvsp[0].ptnode;
             ;
    break;}
case 106:
#line 1424 "f2jparse.y"
{
           yyval.ptnode=yyvsp[0].ptnode;
           yyval.ptnode->nextstmt = NULL;
           yyval.ptnode->prevstmt = NULL;
         ;
    break;}
case 107:
#line 1430 "f2jparse.y"
{
           /*   Use the following declaration in case we 
            *   need to switch index order. 
            *
            *   HASHNODE * hashtemp;  
            */

           yyval.ptnode = addnode();
           yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
           yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
           yyval.ptnode->nodetype = Identifier;
           yyval.ptnode->astnode.ident.lead_expr = NULL;
           yyval.ptnode->prevstmt = NULL;
           yyval.ptnode->nextstmt = NULL;

           strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-3].ptnode->astnode.ident.name);

           /*  This is in case we want to switch index order later.
            *
            *  hashtemp = type_lookup(array_table, $1->astnode.ident.name);
            *  if(hashtemp)
            *    $$->astnode.ident.arraylist = $3;
            *  else
            *    $$->astnode.ident.arraylist = switchem($3);
            */

           /* We don't switch index order.  */

           yyval.ptnode->astnode.ident.arraylist = switchem(yyvsp[-1].ptnode);
         ;
    break;}
case 108:
#line 1461 "f2jparse.y"
{
           yyval.ptnode=addnode();
           yyvsp[-5].ptnode->parent = yyval.ptnode;
           yyvsp[-3].ptnode->parent = yyval.ptnode;
           yyvsp[-1].ptnode->parent = yyval.ptnode;
           strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-5].ptnode->astnode.ident.name);
           yyval.ptnode->nodetype = Substring;
           yyval.ptnode->token = NAME;
           yyval.ptnode->prevstmt = NULL;
           yyval.ptnode->nextstmt = NULL;
           yyval.ptnode->astnode.ident.arraylist = yyvsp[-3].ptnode;
           yyvsp[-3].ptnode->nextstmt = yyvsp[-1].ptnode;
         ;
    break;}
case 109:
#line 1477 "f2jparse.y"
{ 
                    AST *temp;

                    temp = addnode();
                    temp->nodetype = Identifier;
                    temp->astnode.ident.lead_expr = NULL;
                    yyvsp[0].ptnode->parent = temp;

                    yyval.ptnode = yyvsp[0].ptnode;
                  ;
    break;}
case 110:
#line 1488 "f2jparse.y"
{
                    yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
                    yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
		    yyval.ptnode = yyvsp[0].ptnode;
		  ;
    break;}
case 111:
#line 1500 "f2jparse.y"
{
            yyval.ptnode = yyvsp[0].ptnode;
            yyval.ptnode->nodetype = Forloop;
            yyval.ptnode->astnode.forloop.Label = yyvsp[-1].ptnode;
          ;
    break;}
case 112:
#line 1509 "f2jparse.y"
{ 
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 113:
#line 1514 "f2jparse.y"
{ 
            yyval.ptnode = yyvsp[-1].ptnode;
          ;
    break;}
case 114:
#line 1521 "f2jparse.y"
{
            AST *counter;

            yyval.ptnode = addnode();
	    yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	    yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
            counter = yyval.ptnode->astnode.forloop.counter = yyvsp[-3].ptnode->astnode.assignment.lhs;
            yyval.ptnode->astnode.forloop.start = yyvsp[-3].ptnode;
            yyval.ptnode->astnode.forloop.stop = yyvsp[-1].ptnode;
            yyval.ptnode->astnode.forloop.incr = NULL;
            yyval.ptnode->astnode.forloop.iter_expr = gen_iter_expr(yyvsp[-3].ptnode->astnode.assignment.rhs,yyvsp[-1].ptnode,NULL);
            yyval.ptnode->astnode.forloop.incr_expr = gen_incr_expr(counter,NULL);
          ;
    break;}
case 115:
#line 1535 "f2jparse.y"
{
           AST *counter;

           yyval.ptnode = addnode();
	   yyvsp[-5].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	   yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	   yyvsp[-1].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
           counter = yyval.ptnode->astnode.forloop.counter = yyvsp[-5].ptnode->astnode.assignment.lhs;
           yyval.ptnode->nodetype = Forloop;
           yyval.ptnode->astnode.forloop.start = yyvsp[-5].ptnode;
           yyval.ptnode->astnode.forloop.stop = yyvsp[-3].ptnode;
           yyval.ptnode->astnode.forloop.incr = yyvsp[-1].ptnode;
           yyval.ptnode->astnode.forloop.iter_expr = gen_iter_expr(yyvsp[-5].ptnode->astnode.assignment.rhs,yyvsp[-3].ptnode,yyvsp[-1].ptnode);
           yyval.ptnode->astnode.forloop.incr_expr = gen_incr_expr(counter,yyvsp[-1].ptnode);
         ;
    break;}
case 116:
#line 1557 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyvsp[-1].ptnode->parent = yyval.ptnode;
         yyvsp[0].ptnode->parent = yyval.ptnode;
         yyval.ptnode->nodetype = Label;
         yyval.ptnode->astnode.label.number = atoi(yyvsp[-1].ptnode->astnode.constant.number);
         yyval.ptnode->astnode.label.stmt = yyvsp[0].ptnode;
       ;
    break;}
case 117:
#line 1566 "f2jparse.y"
{
         HASHNODE *newnode;
         char *tmpLabel;

         tmpLabel = (char *) f2jalloc(10); /* plenty of space for a f77 label num */

         newnode = (HASHNODE *) f2jalloc(sizeof(HASHNODE));

         yyval.ptnode = addnode();
         yyvsp[-2].ptnode->parent = yyval.ptnode;
         yyvsp[-1].ptnode->parent = yyval.ptnode;
         yyval.ptnode->nodetype = Format;
         yyval.ptnode->astnode.label.number = atoi(yyvsp[-2].ptnode->astnode.constant.number);
         yyval.ptnode->astnode.label.stmt = yyvsp[-1].ptnode;
         yyvsp[-1].ptnode->astnode.label.number = yyval.ptnode->astnode.label.number;
         if(debug)
           printf("@@ inserting format line num %d\n",yyval.ptnode->astnode.label.number);

         sprintf(tmpLabel,"%d",yyvsp[-1].ptnode->astnode.label.number);

         type_insert(format_table,yyvsp[-1].ptnode,0,tmpLabel);
       ;
    break;}
case 118:
#line 1594 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->nodetype = Format;
         yyval.ptnode->astnode.label.stmt = switchem(yyvsp[-1].ptnode);
       ;
    break;}
case 119:
#line 1602 "f2jparse.y"
{
             AST *temp;

             temp = addnode();
             temp->nodetype = Format;
             yyvsp[0].ptnode->parent = temp;

             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 120:
#line 1612 "f2jparse.y"
{
             yyvsp[-1].ptnode->nextstmt = yyvsp[0].ptnode;
             yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
             yyvsp[0].ptnode->parent = yyvsp[-1].ptnode->parent;
             if((yyvsp[0].ptnode->token == REPEAT) && (yyvsp[-1].ptnode->token == INTEGER)) {
               yyvsp[0].ptnode->astnode.label.number = atoi(yyvsp[-1].ptnode->astnode.constant.number);

               if(debug)
                 printf("## setting number = %s\n", yyvsp[-1].ptnode->astnode.constant.number);
             }
             if(debug) {
               if(yyvsp[0].ptnode->token == REPEAT)
                 printf("## $2 is repeat token, $1 = %s ##\n",tok2str(yyvsp[-1].ptnode->token));
               if(yyvsp[-1].ptnode->token == REPEAT)
                 printf("## $1 is repeat token, $2 = %s ##\n",tok2str(yyvsp[0].ptnode->token));
             }
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 121:
#line 1634 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 122:
#line 1638 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 123:
#line 1642 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 124:
#line 1648 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = EDIT_DESC;
         strcpy(yyval.ptnode->astnode.ident.name, yylval.lexeme);
       ;
    break;}
case 125:
#line 1654 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 126:
#line 1658 "f2jparse.y"
{
         /* ignore the constant part for now */
         yyval.ptnode = yyvsp[-2].ptnode;
       ;
    break;}
case 127:
#line 1663 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = REPEAT;
         yyval.ptnode->astnode.label.stmt = switchem(yyvsp[-1].ptnode);
         if(debug)
           printf("## setting number = 1\n");
         yyval.ptnode->astnode.label.number = 1;
       ;
    break;}
case 128:
#line 1674 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 129:
#line 1678 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 130:
#line 1685 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = CM;
       ;
    break;}
case 131:
#line 1690 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = DIV;
       ;
    break;}
case 132:
#line 1695 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->token = CAT;
       ;
    break;}
case 133:
#line 1702 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 134:
#line 1706 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 135:
#line 1721 "f2jparse.y"
{
         yyval.ptnode = addnode();
	 yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	 yyval.ptnode->nodetype = Label;
	 yyval.ptnode->astnode.label.number = atoi(yyvsp[-2].ptnode->astnode.constant.number);
	 yyval.ptnode->astnode.label.stmt = NULL;
       ;
    break;}
case 136:
#line 1731 "f2jparse.y"
{
         AST *temp;

         yyval.ptnode = addnode();
         yyval.ptnode->astnode.io_stmt.io_type = Write;
         yyval.ptnode->astnode.io_stmt.fmt_list = NULL;

         /*  unimplemented
           $$->astnode.io_stmt.file_desc = ;
         */

         if(yyvsp[-3].ptnode->nodetype == Constant)
         {
           if(yyvsp[-3].ptnode->astnode.constant.number[0] == '*') 
             yyval.ptnode->astnode.io_stmt.format_num = -1;
           else if(yyvsp[-3].ptnode->token == STRING) {
             yyval.ptnode->astnode.io_stmt.format_num = -1;
             yyval.ptnode->astnode.io_stmt.fmt_list = yyvsp[-3].ptnode;
           }
           else
             yyval.ptnode->astnode.io_stmt.format_num = atoi(yyvsp[-3].ptnode->astnode.constant.number);
         }
         else
         {
           yyval.ptnode->astnode.io_stmt.format_num = -1;
           yyval.ptnode->astnode.io_stmt.fmt_list = yyvsp[-3].ptnode;
         }
 
         if(yyvsp[-1].ptnode == NULL)
           yyval.ptnode->astnode.io_stmt.arg_list = NULL;
         else 
           yyval.ptnode->astnode.io_stmt.arg_list = switchem(yyvsp[-1].ptnode);

         for(temp=yyval.ptnode->astnode.io_stmt.arg_list;temp!=NULL;temp=temp->nextstmt)
           temp->parent->nodetype = Write;
       ;
    break;}
case 137:
#line 1773 "f2jparse.y"
{
         /* do nothing for now */
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 138:
#line 1778 "f2jparse.y"
{
         /* do nothing for now */
         ;
       ;
    break;}
case 139:
#line 1786 "f2jparse.y"
{
          yyval.ptnode = yyvsp[0].ptnode;
        ;
    break;}
case 140:
#line 1790 "f2jparse.y"
{
          yyval.ptnode = yyvsp[0].ptnode;
        ;
    break;}
case 141:
#line 1794 "f2jparse.y"
{
          yyval.ptnode = addnode();
	  yyval.ptnode->token = INTEGER;
          yyval.ptnode->nodetype = Constant;
          strcpy(yyval.ptnode->astnode.constant.number,"*");
	  yyval.ptnode->vartype = Integer;
        ;
    break;}
case 142:
#line 1802 "f2jparse.y"
{
          yyval.ptnode = addnode();
	  yyval.ptnode->token = INTEGER;
          yyval.ptnode->nodetype = Constant;
          strcpy(yyval.ptnode->astnode.constant.number,"*");
	  yyval.ptnode->vartype = Integer;
        ;
    break;}
case 143:
#line 1810 "f2jparse.y"
{
          yyval.ptnode = yyvsp[0].ptnode;
        ;
    break;}
case 144:
#line 1816 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->astnode.io_stmt.io_type = Read;
         yyval.ptnode->astnode.io_stmt.fmt_list = NULL;
         yyval.ptnode->astnode.io_stmt.end_num = -1;

         if(yyvsp[-1].ptnode == NULL)
           yyval.ptnode->astnode.io_stmt.arg_list = NULL;
         else 
           yyval.ptnode->astnode.io_stmt.arg_list = switchem(yyvsp[-1].ptnode);
      ;
    break;}
case 145:
#line 1828 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->astnode.io_stmt.io_type = Read;
         yyval.ptnode->astnode.io_stmt.fmt_list = NULL;
         yyval.ptnode->astnode.io_stmt.end_num = atoi(yyvsp[-3].ptnode->astnode.constant.number);

         if(yyvsp[-1].ptnode == NULL)
           yyval.ptnode->astnode.io_stmt.arg_list = NULL;
         else 
           yyval.ptnode->astnode.io_stmt.arg_list = switchem(yyvsp[-1].ptnode);
      ;
    break;}
case 146:
#line 1842 "f2jparse.y"
{
             AST *temp;

             temp = addnode();
             temp->nodetype = IoExplist;
             yyvsp[0].ptnode->parent = temp;

             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 147:
#line 1852 "f2jparse.y"
{
             yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
             yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 148:
#line 1858 "f2jparse.y"
{
             yyval.ptnode = NULL;
           ;
    break;}
case 149:
#line 1864 "f2jparse.y"
{
         yyval.ptnode = yyvsp[0].ptnode;
       ;
    break;}
case 150:
#line 1868 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->nodetype = IoImpliedLoop;
         yyval.ptnode->astnode.forloop.start = yyvsp[-3].ptnode;
         yyval.ptnode->astnode.forloop.stop = yyvsp[-1].ptnode;
         yyval.ptnode->astnode.forloop.incr = NULL;
         yyval.ptnode->astnode.forloop.counter = yyvsp[-5].ptnode;
         yyval.ptnode->astnode.forloop.Label = yyvsp[-7].ptnode;
         yyval.ptnode->astnode.forloop.iter_expr = gen_iter_expr(yyvsp[-3].ptnode,yyvsp[-1].ptnode,NULL);
         yyval.ptnode->astnode.forloop.incr_expr = gen_incr_expr(yyvsp[-5].ptnode,NULL);

         yyvsp[-7].ptnode->parent = yyval.ptnode;
         yyvsp[-5].ptnode->parent = yyval.ptnode;
         yyvsp[-3].ptnode->parent = yyval.ptnode;
         yyvsp[-1].ptnode->parent = yyval.ptnode;
       ;
    break;}
case 151:
#line 1885 "f2jparse.y"
{
         yyval.ptnode = addnode();
         yyval.ptnode->nodetype = IoImpliedLoop;
         yyval.ptnode->astnode.forloop.start = yyvsp[-5].ptnode;
         yyval.ptnode->astnode.forloop.stop = yyvsp[-3].ptnode;
         yyval.ptnode->astnode.forloop.incr = yyvsp[-1].ptnode;
         yyval.ptnode->astnode.forloop.counter = yyvsp[-7].ptnode;
         yyval.ptnode->astnode.forloop.Label = yyvsp[-9].ptnode;
         yyval.ptnode->astnode.forloop.iter_expr = gen_iter_expr(yyvsp[-5].ptnode,yyvsp[-3].ptnode,yyvsp[-1].ptnode);
         yyval.ptnode->astnode.forloop.incr_expr = gen_incr_expr(yyvsp[-7].ptnode,yyvsp[-1].ptnode);

         yyvsp[-9].ptnode->parent = yyval.ptnode;
         yyvsp[-7].ptnode->parent = yyval.ptnode;
         yyvsp[-5].ptnode->parent = yyval.ptnode;
         yyvsp[-3].ptnode->parent = yyval.ptnode;
         yyvsp[-1].ptnode->parent = yyval.ptnode;
       ;
    break;}
case 152:
#line 1906 "f2jparse.y"
{
           yyval.ptnode = yyvsp[0].ptnode;
         ;
    break;}
case 153:
#line 1917 "f2jparse.y"
{
             yyval.ptnode = addnode();
             yyvsp[-8].ptnode->parent = yyval.ptnode;
             yyvsp[-4].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             if(yyvsp[-3].ptnode != NULL) 
               yyvsp[-3].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             if(yyvsp[-2].ptnode != NULL)
               yyvsp[-2].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             yyval.ptnode->nodetype = Blockif;
             yyval.ptnode->astnode.blockif.conds = yyvsp[-8].ptnode;
             if(yyvsp[-4].ptnode != 0) yyvsp[-4].ptnode = switchem(yyvsp[-4].ptnode);
             yyval.ptnode->astnode.blockif.stmts = yyvsp[-4].ptnode;

             /*  If there are any `else if' statements,
              *  switchem. Otherwise, NULL pointer checked
              *  in code generating functions. 
              */
             if(yyvsp[-3].ptnode != 0) yyvsp[-3].ptnode = switchem(yyvsp[-3].ptnode); 
             yyval.ptnode->astnode.blockif.elseifstmts = yyvsp[-3].ptnode; /* Might be NULL. */
             yyval.ptnode->astnode.blockif.elsestmts = yyvsp[-2].ptnode;   /* Might be NULL. */
           ;
    break;}
case 154:
#line 1941 "f2jparse.y"
{yyval.ptnode=0;;
    break;}
case 155:
#line 1943 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 156:
#line 1947 "f2jparse.y"
{
             yyvsp[0].ptnode->prevstmt = yyvsp[-1].ptnode;
	     yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 157:
#line 1955 "f2jparse.y"
{
          yyval.ptnode=addnode();
	  yyvsp[-4].ptnode->parent = yyval.ptnode;  
	  yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	  yyval.ptnode->nodetype = Elseif;
	  yyval.ptnode->astnode.blockif.conds = yyvsp[-4].ptnode;
	  yyval.ptnode->astnode.blockif.stmts = switchem(yyvsp[0].ptnode);
        ;
    break;}
case 158:
#line 1966 "f2jparse.y"
{yyval.ptnode=0;;
    break;}
case 159:
#line 1968 "f2jparse.y"
{
             yyval.ptnode=addnode();
	     yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
	     yyval.ptnode->nodetype = Else;
	     yyval.ptnode->astnode.blockif.stmts = switchem(yyvsp[0].ptnode);
          ;
    break;}
case 160:
#line 1978 "f2jparse.y"
{
             yyval.ptnode = addnode();
             yyvsp[-2].ptnode->parent = yyval.ptnode;
             yyvsp[0].ptnode->parent = yyval.ptnode; /* 9-4-97 - Keith */
             yyval.ptnode->astnode.logicalif.conds = yyvsp[-2].ptnode;
             yyval.ptnode->astnode.logicalif.stmts = yyvsp[0].ptnode;
           ;
    break;}
case 161:
#line 1988 "f2jparse.y"
{
                yyval.ptnode = addnode();
                yyval.ptnode->nodetype = Arithmeticif;
                yyvsp[-7].ptnode->parent = yyval.ptnode;
                yyvsp[-5].ptnode->parent = yyval.ptnode;
                yyvsp[-3].ptnode->parent = yyval.ptnode;
                yyvsp[-1].ptnode->parent = yyval.ptnode;

                yyval.ptnode->astnode.arithmeticif.cond = yyvsp[-7].ptnode;
                yyval.ptnode->astnode.arithmeticif.neg_label  = atoi(yyvsp[-5].ptnode->astnode.constant.number);
                yyval.ptnode->astnode.arithmeticif.zero_label = atoi(yyvsp[-3].ptnode->astnode.constant.number);
                yyval.ptnode->astnode.arithmeticif.pos_label  = atoi(yyvsp[-1].ptnode->astnode.constant.number);
              ;
    break;}
case 162:
#line 2015 "f2jparse.y"
{
                    /* Use the following declarations in case we 
                     * need to switch index order.
                     * 
                     * HASHNODE * hashtemp;  
                     * HASHNODE * ht;
                     */

                    yyval.ptnode = addnode();
                    yyvsp[-3].ptnode->parent = yyval.ptnode;  /* 9-4-97 - Keith */

                    /*  $3->parent = $$;  9-4-97 - Keith */

                    if(yyvsp[-1].ptnode != NULL)
                      strcpy(yyvsp[-1].ptnode->parent->astnode.ident.name, 
                        yyvsp[-3].ptnode->astnode.ident.name);

                    /*
                     *  Here we could look up the name in the array table and set 
                     *  the nodetype to ArrayAccess if it is found.  Then the code 
                     *  generator could easily distinguish between array accesses 
                     *  and function calls.  I'll have to implement the rest of 
                     *  this soon.  -- Keith
                     *
                     *     if(type_lookup(array_table, $1->astnode.ident.name))
                     *       $$->nodetype = ArrayAccess;
                     *     else
                     *       $$->nodetype = Identifier;
                     */

                    yyval.ptnode->nodetype = Identifier;

                    yyval.ptnode->astnode.ident.lead_expr = NULL;
                    strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-3].ptnode->astnode.ident.name);

                    /*  This is in case we want to switch index order later.
                     *
                     *  hashtemp = type_lookup(array_table, $1->astnode.ident.name);
                     *  if(hashtemp != NULL)
                     *    $$->astnode.ident.arraylist = $3;
                     *  else
                     */

                    /* We don't switch index order.  */
                    if(yyvsp[-1].ptnode == NULL) {
                      yyval.ptnode->astnode.ident.arraylist = addnode();
                      yyval.ptnode->astnode.ident.arraylist->nodetype = EmptyArgList;
                    }
                    else
                      yyval.ptnode->astnode.ident.arraylist = switchem(yyvsp[-1].ptnode);
                  ;
    break;}
case 163:
#line 2069 "f2jparse.y"
{
              if(debug)
                printf("SubString!\n");
              yyval.ptnode = addnode();
              yyvsp[-5].ptnode->parent = yyval.ptnode;
              yyvsp[-3].ptnode->parent = yyval.ptnode;
              yyvsp[-1].ptnode->parent = yyval.ptnode;
              strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-5].ptnode->astnode.ident.name);
              yyval.ptnode->nodetype = Substring;
              yyval.ptnode->token = NAME;
              yyval.ptnode->astnode.ident.arraylist = yyvsp[-3].ptnode;
              yyvsp[-3].ptnode->nextstmt = yyvsp[-1].ptnode;
           ;
    break;}
case 164:
#line 2095 "f2jparse.y"
{
             AST *temp;

             temp = addnode();
             temp->nodetype = Call;
             yyvsp[0].ptnode->parent = temp;

             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 165:
#line 2105 "f2jparse.y"
{
             yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
             yyvsp[0].ptnode->parent = yyvsp[-2].ptnode->parent;
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 166:
#line 2111 "f2jparse.y"
{
             yyval.ptnode = NULL;
           ;
    break;}
case 167:
#line 2120 "f2jparse.y"
{
             yyval.ptnode = yyvsp[-1].ptnode;
	     yyval.ptnode->nodetype = Call;
          ;
    break;}
case 168:
#line 2125 "f2jparse.y"
{
            yyval.ptnode = addnode();
            yyvsp[-1].ptnode->parent = yyval.ptnode;
            yyval.ptnode->nodetype = Identifier;
            yyval.ptnode->astnode.ident.lead_expr = NULL;
            strcpy(yyval.ptnode->astnode.ident.name, yyvsp[-1].ptnode->astnode.ident.name);
            yyval.ptnode->astnode.ident.arraylist = addnode();
            yyval.ptnode->astnode.ident.arraylist->nodetype = EmptyArgList;
          ;
    break;}
case 169:
#line 2141 "f2jparse.y"
{
       yyval.ptnode = yyvsp[0].ptnode;
     ;
    break;}
case 170:
#line 2145 "f2jparse.y"
{
       yyval.ptnode=addnode();
       yyvsp[-2].ptnode->expr_side = left;
       yyvsp[0].ptnode->expr_side = right;
       yyvsp[-2].ptnode->parent = yyval.ptnode;
       yyvsp[0].ptnode->parent = yyval.ptnode;
       yyval.ptnode->token = EQV;
       yyval.ptnode->nodetype = Logicalop;
       yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
       yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
     ;
    break;}
case 171:
#line 2157 "f2jparse.y"
{
       yyval.ptnode=addnode();
       yyvsp[-2].ptnode->expr_side = left;
       yyvsp[0].ptnode->expr_side = right;
       yyvsp[-2].ptnode->parent = yyval.ptnode;
       yyvsp[0].ptnode->parent = yyval.ptnode;
       yyval.ptnode->token = NEQV;
       yyval.ptnode->nodetype = Logicalop;
       yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
       yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
     ;
    break;}
case 172:
#line 2171 "f2jparse.y"
{
                yyval.ptnode = yyvsp[0].ptnode;
              ;
    break;}
case 173:
#line 2175 "f2jparse.y"
{
                yyval.ptnode=addnode();
		yyvsp[-2].ptnode->expr_side = left;
		yyvsp[0].ptnode->expr_side = right;
		yyvsp[-2].ptnode->parent = yyval.ptnode;
		yyvsp[0].ptnode->parent = yyval.ptnode;
		yyval.ptnode->token = OR;
		yyval.ptnode->nodetype = Logicalop;
		yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
		yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
              ;
    break;}
case 174:
#line 2189 "f2jparse.y"
{
            yyval.ptnode = yyvsp[0].ptnode;
          ;
    break;}
case 175:
#line 2193 "f2jparse.y"
{
            yyval.ptnode=addnode();
            yyvsp[-2].ptnode->expr_side = left;
            yyvsp[0].ptnode->expr_side = right;
            yyvsp[-2].ptnode->parent = yyval.ptnode;
            yyvsp[0].ptnode->parent = yyval.ptnode;
            yyval.ptnode->token = AND;
            yyval.ptnode->nodetype = Logicalop;
            yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
            yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
          ;
    break;}
case 176:
#line 2207 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 177:
#line 2211 "f2jparse.y"
{
              yyval.ptnode=addnode();
              yyvsp[0].ptnode->parent = yyval.ptnode;  /* 9-4-97 - Keith */
              yyval.ptnode->token = NOT;
              yyval.ptnode->nodetype = Logicalop;
              yyval.ptnode->astnode.expression.lhs = 0;
              yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
            ;
    break;}
case 178:
#line 2222 "f2jparse.y"
{
               yyval.ptnode = yyvsp[0].ptnode;
             ;
    break;}
case 179:
#line 2225 "f2jparse.y"
{temptok = yylval.tok;;
    break;}
case 180:
#line 2226 "f2jparse.y"
{
               yyval.ptnode=addnode();
               yyvsp[-3].ptnode->expr_side = left;
               yyvsp[0].ptnode->expr_side = right;
               yyvsp[-3].ptnode->parent = yyval.ptnode;
               yyvsp[0].ptnode->parent = yyval.ptnode;
               yyval.ptnode->nodetype = Relationalop;
               yyval.ptnode->token = temptok;
               yyval.ptnode->astnode.expression.lhs = yyvsp[-3].ptnode;
               yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
             ;
    break;}
case 181:
#line 2240 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 182:
#line 2244 "f2jparse.y"
{
              if(yyvsp[0].ptnode->nodetype == Constant) {
                prepend_minus(yyvsp[0].ptnode->astnode.constant.number);
                yyval.ptnode = yyvsp[0].ptnode;
              }
              else {
                yyval.ptnode = addnode();
                yyvsp[0].ptnode->parent = yyval.ptnode;
                yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
                yyval.ptnode->astnode.expression.lhs = 0;
                yyval.ptnode->astnode.expression.minus = '-';   
                yyval.ptnode->nodetype = Unaryop;
              }
            ;
    break;}
case 183:
#line 2259 "f2jparse.y"
{
              if(yyvsp[0].ptnode->nodetype == Constant) {
                yyval.ptnode = yyvsp[0].ptnode;
              }
              else {
                yyval.ptnode = addnode();
                yyvsp[0].ptnode->parent = yyval.ptnode;
                yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
                yyval.ptnode->astnode.expression.lhs = 0;
                yyval.ptnode->astnode.expression.minus = '+';
                yyval.ptnode->nodetype = Unaryop;
              }
            ;
    break;}
case 184:
#line 2273 "f2jparse.y"
{
              yyval.ptnode=addnode();
              yyvsp[-2].ptnode->expr_side = left;
              yyvsp[0].ptnode->expr_side = right;
              yyval.ptnode->token = PLUS;
              yyvsp[-2].ptnode->parent = yyval.ptnode;
              yyvsp[0].ptnode->parent = yyval.ptnode;
              yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
              yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
              yyval.ptnode->nodetype = Binaryop;
              yyval.ptnode->astnode.expression.optype = '+';
            ;
    break;}
case 185:
#line 2286 "f2jparse.y"
{
              yyval.ptnode=addnode();
              yyval.ptnode->token = MINUS;
              yyvsp[-2].ptnode->expr_side = left;
              yyvsp[0].ptnode->expr_side = right;
              yyvsp[-2].ptnode->parent = yyval.ptnode;
              yyvsp[0].ptnode->parent = yyval.ptnode;
              yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
              yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
              yyval.ptnode->nodetype = Binaryop;
              yyval.ptnode->astnode.expression.optype = '-';
            ;
    break;}
case 186:
#line 2301 "f2jparse.y"
{
        yyval.ptnode = yyvsp[0].ptnode;
      ;
    break;}
case 187:
#line 2305 "f2jparse.y"
{
        yyval.ptnode=addnode();
        yyvsp[-2].ptnode->expr_side = left;
        yyvsp[0].ptnode->expr_side = right;
        yyval.ptnode->token = DIV;
        yyvsp[-2].ptnode->parent = yyval.ptnode;
        yyvsp[0].ptnode->parent = yyval.ptnode;
        yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
        yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
        yyval.ptnode->nodetype = Binaryop;
        yyval.ptnode->astnode.expression.optype = '/';
      ;
    break;}
case 188:
#line 2318 "f2jparse.y"
{
        yyval.ptnode=addnode();
        yyval.ptnode->token = STAR;
        yyvsp[-2].ptnode->expr_side = left;
        yyvsp[0].ptnode->expr_side = right;
        yyvsp[-2].ptnode->parent = yyval.ptnode;
        yyvsp[0].ptnode->parent = yyval.ptnode;
        yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
        yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
        yyval.ptnode->nodetype = Binaryop;
        yyval.ptnode->astnode.expression.optype = '*';
      ;
    break;}
case 189:
#line 2333 "f2jparse.y"
{
          yyval.ptnode = yyvsp[0].ptnode;
        ;
    break;}
case 190:
#line 2337 "f2jparse.y"
{
          yyval.ptnode=addnode();
          yyvsp[-2].ptnode->parent = yyval.ptnode;
          yyvsp[0].ptnode->parent = yyval.ptnode;
	  yyval.ptnode->nodetype = Power;
	  yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
	  yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
        ;
    break;}
case 191:
#line 2348 "f2jparse.y"
{
             yyval.ptnode = yyvsp[0].ptnode;
           ;
    break;}
case 192:
#line 2352 "f2jparse.y"
{
             yyval.ptnode=addnode();
             yyval.ptnode->token = CAT;
             yyvsp[-2].ptnode->expr_side = left;
             yyvsp[0].ptnode->expr_side = right;
             yyvsp[-2].ptnode->parent = yyval.ptnode;
             yyvsp[0].ptnode->parent = yyval.ptnode;
             yyval.ptnode->astnode.expression.lhs = yyvsp[-2].ptnode;
             yyval.ptnode->astnode.expression.rhs = yyvsp[0].ptnode;
             yyval.ptnode->nodetype = Binaryop;
             yyval.ptnode->astnode.expression.optype = '+';
           ;
    break;}
case 193:
#line 2366 "f2jparse.y"
{yyval.ptnode=yyvsp[0].ptnode;;
    break;}
case 194:
#line 2368 "f2jparse.y"
{
	       yyval.ptnode = yyvsp[0].ptnode;
	     ;
    break;}
case 195:
#line 2372 "f2jparse.y"
{yyval.ptnode=yyvsp[0].ptnode;;
    break;}
case 196:
#line 2373 "f2jparse.y"
{yyval.ptnode=yyvsp[0].ptnode;;
    break;}
case 197:
#line 2375 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyvsp[-1].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
               yyval.ptnode->nodetype = Expression;
               yyval.ptnode->astnode.expression.parens = TRUE;
               yyval.ptnode->astnode.expression.rhs = yyvsp[-1].ptnode;
               yyval.ptnode->astnode.expression.lhs = 0;
             ;
    break;}
case 198:
#line 2394 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyval.ptnode->token = TrUE;
               yyval.ptnode->nodetype = Constant;
               strcpy(yyval.ptnode->astnode.constant.number, "true");
               yyval.ptnode->vartype = Logical;
             ;
    break;}
case 199:
#line 2402 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyval.ptnode->token = FaLSE;
               yyval.ptnode->nodetype = Constant;
               strcpy(yyval.ptnode->astnode.constant.number, "false");
               yyval.ptnode->vartype = Logical;
             ;
    break;}
case 200:
#line 2414 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 201:
#line 2418 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 202:
#line 2422 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 203:
#line 2426 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 204:
#line 2430 "f2jparse.y"
{ 
           yyval.ptnode = yyvsp[0].ptnode; 
         ;
    break;}
case 205:
#line 2436 "f2jparse.y"
{
               yyval.ptnode = addnode();
               yyval.ptnode->token = INTEGER;
               yyval.ptnode->nodetype = Constant;
               strcpy(yyval.ptnode->astnode.constant.number, yylval.lexeme);
               yyval.ptnode->vartype = Integer;
             ;
    break;}
case 206:
#line 2446 "f2jparse.y"
{
               yyval.ptnode = addnode();
	       yyval.ptnode->token = DOUBLE;
               yyval.ptnode->nodetype = Constant;
               strcpy(yyval.ptnode->astnode.constant.number, yylval.lexeme);
               yyval.ptnode->vartype = Double;
             ;
    break;}
case 207:
#line 2472 "f2jparse.y"
{
               yyval.ptnode = addnode();
	       yyval.ptnode->token = EXPONENTIAL;
               yyval.ptnode->nodetype = Constant;
	       exp_to_double(yylval.lexeme, tempname);
               strcpy(yyval.ptnode->astnode.constant.number, tempname);
               yyval.ptnode->vartype = Double;
             ;
    break;}
case 208:
#line 2485 "f2jparse.y"
{
                yyval.ptnode= addnode();
             ;
    break;}
case 209:
#line 2491 "f2jparse.y"
{
          yyval.ptnode = addnode();
          yyval.ptnode->nodetype = Stop;
        ;
    break;}
case 210:
#line 2498 "f2jparse.y"
{
          yyval.ptnode = addnode();
          yyvsp[-1].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
          yyval.ptnode->nodetype = Goto;
	  if(debug)
            printf("goto label: %d\n", atoi(yylval.lexeme)); 
          yyval.ptnode->astnode.go_to.label = atoi(yylval.lexeme);
        ;
    break;}
case 211:
#line 2509 "f2jparse.y"
{
                  yyval.ptnode = addnode();
                  yyvsp[-3].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
                  yyvsp[-1].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
                  yyval.ptnode->nodetype = ComputedGoto;
                  yyval.ptnode->astnode.computed_goto.name = yyvsp[-1].ptnode;
                  yyval.ptnode->astnode.computed_goto.intlist = switchem(yyvsp[-3].ptnode);
        	  if(debug)
        	    printf("Computed go to,\n");
                ;
    break;}
case 212:
#line 2520 "f2jparse.y"
{
                  yyval.ptnode = addnode();
                  yyvsp[-4].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
                  yyvsp[-1].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
                  yyval.ptnode->nodetype = ComputedGoto;
                  yyval.ptnode->astnode.computed_goto.name = yyvsp[-1].ptnode;
                  yyval.ptnode->astnode.computed_goto.intlist = switchem(yyvsp[-4].ptnode);
        	  if(debug)
        	    printf("Computed go to,\n");
                ;
    break;}
case 213:
#line 2533 "f2jparse.y"
{
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 214:
#line 2537 "f2jparse.y"
{
              yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode;
              yyval.ptnode = yyvsp[0].ptnode;
            ;
    break;}
case 215:
#line 2544 "f2jparse.y"
{
	       yyval.ptnode = addnode();
               yyvsp[-2].ptnode->parent = yyval.ptnode;   /* 9-4-97 - Keith */
	       yyval.ptnode->nodetype = Specification;
	       yyval.ptnode->astnode.typeunit.specification = Parameter;
               yyval.ptnode->astnode.typeunit.declist = switchem(yyvsp[-2].ptnode); 
             ;
    break;}
case 216:
#line 2554 "f2jparse.y"
{ 
            yyval.ptnode=yyvsp[0].ptnode;
          ;
    break;}
case 217:
#line 2558 "f2jparse.y"
{
            yyvsp[0].ptnode->prevstmt = yyvsp[-2].ptnode; 
            yyval.ptnode=yyvsp[0].ptnode;
          ;
    break;}
case 218:
#line 2565 "f2jparse.y"
{
            double constant_eval;
            AST *temp;

            if(debug)
              printf("Parameter...\n");

            yyval.ptnode = yyvsp[0].ptnode;
            yyval.ptnode->nodetype = Assignment;
                                                                                                      
            constant_eval = eval_const_expr(yyval.ptnode->astnode.assignment.rhs);
            
            temp = addnode();
            temp->nodetype = Constant;
            temp->vartype = yyval.ptnode->astnode.assignment.rhs->vartype;
            
            switch(yyval.ptnode->astnode.assignment.rhs->vartype) {
              case String:
              case Character:
                temp->token = STRING;
                strcpy(temp->astnode.constant.number, 
                       yyval.ptnode->astnode.assignment.rhs->astnode.constant.number);
                break;
              case Complex:
                fprintf(stderr,"Pdec: Complex not yet supported.\n");
                break;
              case Logical:
                temp->token = yyval.ptnode->astnode.assignment.rhs->token;
                strcpy(temp->astnode.constant.number, 
                       temp->token == TrUE ? "true" : "false");
                break;
              case Float:
              case Double:
                temp->token = DOUBLE;
                sprintf(temp->astnode.constant.number,"%f",constant_eval);
                break;
              case Integer:
                temp->token = INTEGER;
                sprintf(temp->astnode.constant.number,"%d",(int)constant_eval);
                break;
              default:
                fprintf(stderr,"Pdec: bad vartype!\n");
            }

            yyval.ptnode->astnode.assignment.rhs = temp;
                                                      
            type_insert(parameter_table, temp, 0,
               yyval.ptnode->astnode.assignment.lhs->astnode.ident.name);

            /*
             *  $$->astnode.typeunit.specification = Parameter; 
             *
             * Attach the Assignment node to a list... Hack.
             *  $$->astnode.typeunit.declist = $1;  
             */
          ;
    break;}
case 219:
#line 2624 "f2jparse.y"
{
             yyval.ptnode=addnode(); 
             yyvsp[-1].ptnode->parent = yyval.ptnode;  /* 9-3-97 - Keith */
             yyval.ptnode->nodetype = Specification;
             yyval.ptnode->token = EXTERNAL;
             yyval.ptnode->astnode.typeunit.declist = switchem(yyvsp[-1].ptnode);
             yyval.ptnode->astnode.typeunit.specification = External;
           ;
    break;}
case 220:
#line 2635 "f2jparse.y"
{
             yyval.ptnode=addnode(); 
             yyvsp[-1].ptnode->parent = yyval.ptnode;  /* 9-3-97 - Keith */
             yyval.ptnode->nodetype = Specification;
	     yyval.ptnode->token = INTRINSIC;
             yyval.ptnode->astnode.typeunit.declist = switchem(yyvsp[-1].ptnode);
             yyval.ptnode->astnode.typeunit.specification = Intrinsic;
           ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 2646 "f2jparse.y"



/*****************************************************************************
 *                                                                           *
 * yyerror                                                                   *
 *                                                                           *
 * The standard error routine, which is not currently implemented.           *
 *                                                                           *
 *****************************************************************************/

void 
yyerror(char *s)
{
  printf("%d: %s\n", lineno, s);
}


/*****************************************************************************
 *                                                                           *
 * addnode                                                                   *
 *                                                                           *
 * To keep things simple, there is only one type of parse tree               *
 * node.  If there is any way to ensure that all the pointers                *
 * in this are NULL, it would be a good idea to do that.  I am               *
 * not sure what the default behavior is.                                    *
 *                                                                           *
 *****************************************************************************/

AST * 
addnode() 
{
  return (AST*)f2jcalloc(1,sizeof(AST));
}


/*****************************************************************************
 *                                                                           *
 * switchem                                                                  *
 *                                                                           *
 * Need to turn the linked list around,                                      *
 * so that it can traverse forward instead of in reverse.                    *
 * What I do here is create a doubly linked list.                            *
 * Note that there is no `sentinel' or `head' node                           *
 * in this list.  It is acyclic and terminates in                            *
 * NULL pointers.                                                            *
 *                                                                           *
 *****************************************************************************/

AST * 
switchem(AST * root) 
{

  if (root->prevstmt == NULL) 
    return root;

  while (root->prevstmt != 0) 
  {
    root->prevstmt->nextstmt = root;
    root = root->prevstmt;
  }

  return root;
}

/*****************************************************************************
 *                                                                           *
 * type_hash                                                                 *
 *                                                                           *
 * For now, type_hash takes a tree (linked list) of type                     *
 * declarations from the Decblock rule.  It will need to                     *
 * get those from Intrinsic, External, Parameter, etc.                       *
 *                                                                           *
 *****************************************************************************/

void 
type_hash(AST * types)
{
  HASHNODE *hash_entry;
  AST * temptypes, * tempnames;
  int return_type;
  extern SYMTABLE * type_table, * intrinsic_table, * external_table; 
   
   /* Outer for loop traverses typestmts, inner for()
    * loop traverses declists. Code for stuffing symbol table is
    * is in inner for() loop.   
    */
  for (temptypes = types; temptypes; temptypes = temptypes->nextstmt)
  {
      /* Long assignment, set up the for() loop here instead of
         the expression list.  */
    tempnames = temptypes->astnode.typeunit.declist;

      /* Need to set the return value here before entering
         the next for() loop.  */
    return_type = temptypes->astnode.typeunit.returns;

    for (; tempnames; tempnames = tempnames->nextstmt)
    {
      /* Stuff names and return types into the symbol table. */
      if(debug)printf("Type hash: %s\n", tempnames->astnode.ident.name);

      hash_entry = type_lookup(type_table,tempnames->astnode.ident.name);

      if(hash_entry == NULL) {
        tempnames->vartype = return_type;
      }
      else {
        if(debug)
          printf("Duplicate entry.\n");  

        tempnames->vartype = hash_entry->variable->vartype;
      }

      /* 
       * All names go into the name table.  
       */

      type_insert(type_table, tempnames, return_type, tempnames->astnode.ident.name);

      /* Now separate out the EXTERNAL from the INTRINSIC on the
         fortran side.  */

      if(temptypes->token != 0)
        switch (temptypes->token)
        {
          case INTRINSIC:
            type_insert(intrinsic_table, 
                    tempnames, return_type, tempnames->astnode.ident.name);
            break;
          case EXTERNAL:
            type_insert(external_table,
                    tempnames, return_type, tempnames->astnode.ident.name);
            break;
        } /* Close switch().  */
    }  /* Close inner for() loop.  */
  }    /* Close outer for() loop.  */
}      /* Close type_hash().       */


/*****************************************************************************
 *                                                                           *
 * exp_to_double                                                             *
 *                                                                           *
 *  Since jasmin doesn't have any EXPONENTIAL data types, these              *
 * have to be turned into floats.  exp_to_double really just                 *
 * replaces instances of 'd' and 'D' in the exponential number               *
 * with 'e' so that c can convert it on a string scan and                    *
 * string print.  Java does recognize numbers of the                         *
 * form 1.0e+1, so the `d' and `d' need to be replaced with                  *
 * `e'.  For now, leave as double for uniformity with jasmin.                *
 *                                                                           *
 *****************************************************************************/

void 
exp_to_double (char *lexeme, char *temp)
{
  char *cp = lexeme;

  while (*cp)           /* While *cp != '\0'...  */
  {
    if (*cp == 'd' ||   /*  sscanf can recognize 'E'. */
        *cp == 'D')
    {
       *cp = 'e';       /* Replace the 'd' or 'D' with 'e'. */
       break;           /* Should be only one 'd', 'D', etc. */
    }
    cp++;               /* Examine the next character. */
  }

  /* Java should be able to handle exponential notation as part
   * of the float or double constant. 
   */

 strcpy(temp,lexeme);
}  /*  Close exp_to_double().  */


/*****************************************************************************
 *                                                                           *
 * arg_table_load                                                            *
 *                                                                           *
 * Initialize and fill a table with the names of the                         *
 * variables passed in as arguments to the function or                       *
 * subroutine.  This table is later checked when variable                    *
 * types are declared so that variables are not declared                     *
 * twice.                                                                    *  
 *                                                                           *
 *****************************************************************************/

void
arg_table_load(AST * arglist)
{
  AST * temp;
  extern SYMTABLE * args_table;

  /* We traverse down `prevstmt' because the arglist is
   * built with right recursion, i.e. in reverse.  This
   * procedure, 'arg_table_load()' is called when the non-
   * terminal `functionargs' is reduced, before the
   * argument list is reversed. Note that a NULL pointer
   * at either end of the list terminates the for() loop. 
   */

   for(temp = arglist; temp; temp = temp->nextstmt)
   {
     type_insert(args_table, temp, 0, temp->astnode.ident.name);
     if(debug)printf("Arglist var. name: %s\n", temp->astnode.ident.name);
   }
}


/*****************************************************************************
 *                                                                           *
 * lowercase                                                                 *
 *                                                                           *
 * This function takes a string and converts all characters to               *
 * lowercase.                                                                *
 *                                                                           *
 *****************************************************************************/

char * lowercase(char * name)
{
  char *ptr = name;

  while (*name)
  {
    *name = tolower(*name);
     name++;
  }

  return ptr;
}

/*****************************************************************************
 *                                                                           *
 * store_array_var                                                           *
 *                                                                           *
 * We need to make a table of array variables, because                       *
 * fortran accesses arrays by columns instead of rows                        *
 * as C and java does.  During code generation, the array                    *
 * variables are emitted in reverse to get row order.                        *
 *                                                                           *
 *****************************************************************************/

void
store_array_var(AST * var)
{
  extern SYMTABLE * array_table;

  type_insert(array_table, var, 0, var->astnode.ident.name);

  if(debug)
    printf("Array name: %s\n", var->astnode.ident.name);
}

/*****************************************************************************
 *                                                                           *
 * mypow                                                                     *
 *                                                                           *
 * Double power function.  writing this here so that we                      *
 * dont have to link in the math library.                                    *
 *                                                                           *
 *****************************************************************************/

double
mypow(double x, double y)
{
  int i;

  if(y < 0)
  {
    fprintf(stderr,"Warning: got negative exponent in mypow!\n");
    return 0;
  }

  if(y == 0)
    return 1;

  if(y == 1)
    return x;
  
  for(i=0;i<y-1;i++)
    x *= x;
  
  return x;
}

/*****************************************************************************
 *                                                                           *
 * init_tables                                                               *
 *                                                                           *
 * This function initializes all the symbol tables we'll need during         *
 * parsing and code generation.                                              *
 *                                                                           *
 *****************************************************************************/

void
init_tables()
{
  if(debug)
    printf("Initializing tables.\n");

  array_table     = (SYMTABLE *) new_symtable(211);
  format_table    = (SYMTABLE *) new_symtable(211);
  data_table      = (SYMTABLE *) new_symtable(211);
  save_table      = (SYMTABLE *) new_symtable(211);
  common_table    = (SYMTABLE *) new_symtable(211);
  parameter_table = (SYMTABLE *) new_symtable(211);
  type_table      = (SYMTABLE *) new_symtable(211);
  intrinsic_table = (SYMTABLE *) new_symtable(211);
  external_table  = (SYMTABLE *) new_symtable(211);
  args_table      = (SYMTABLE *) new_symtable(211);
  constants_table = make_dl();
  equivList       = NULL;
}

/*****************************************************************************
 *                                                                           *
 * merge_common_blocks                                                       *
 *                                                                           *
 * In Fortran, different declarations of the same COMMON block may use       *
 * differently named variables.  Since f2j is going to generate only one     *
 * class file to represent the COMMON block, we can only use one of these    *
 * variable names.  What we attempt to do here is take the different names   *
 * and merge them into one name, which we use wherever that common variable  *
 * is used.                                                                  *
 *                                                                           *
 *****************************************************************************/

void
merge_common_blocks(AST *root)
{
  HASHNODE *ht;
  AST *Clist, *temp;
  int count;
  char ** name_array;
  char *comvar = NULL, *var = NULL, und_var[80], 
       var_und[80], und_var_und[80], *t;

  for(Clist = root; Clist != NULL; Clist = Clist->nextstmt)
  {
    /* 
     * First check whether this common block is already in
     * the table.
     */

    ht=type_lookup(common_block_table,Clist->astnode.common.name);

    for(temp=Clist->astnode.common.nlist, count = 0; 
              temp!=NULL; temp=temp->nextstmt) 
      count++;

    name_array = (char **) f2jalloc( count * sizeof(name_array) );

    for(temp=Clist->astnode.common.nlist, count = 0;
              temp!=NULL; temp=temp->nextstmt, count++)
    {
      name_array[count] = (char *) f2jalloc( 80 );
    }

    /* foreach COMMON variable */

    for(temp=Clist->astnode.common.nlist, count = 0; 
               temp!=NULL; temp=temp->nextstmt, count++) 
    {
      var = temp->astnode.ident.name;

      /* to merge two names we concatenate the second name
       * to the first name, separated by an underscore.
       */

      if(ht != NULL) {
        comvar = ((char **)ht->variable)[count];
        und_var[0] = '_';
        und_var[1] = 0;
        strcat(und_var,var);
        strcpy(var_und,var);
        strcat(var_und,"_");
        strcpy(und_var_und,und_var);
        strcat(und_var_und,"_");
      }

      if(ht == NULL)
        name_array[count] = strdup(var);
      else {
        if(!strcmp(var,comvar) || 
             strstr(comvar,und_var_und) ||
             (((t=strstr(comvar,var_und)) != NULL) && t == comvar) ||
             (((t=strstr(comvar,und_var)) != NULL) && 
               (t+strlen(t) == comvar+strlen(comvar))))
        {
          name_array[count] = strdup(comvar);
        }
        else {
          name_array[count] = (char *) f2jalloc(strlen(temp->astnode.ident.name) 
             + strlen(((char **)ht->variable)[count]) + 2);
  
          strcpy(name_array[count],temp->astnode.ident.name);
          strcat(name_array[count],"_");
          strcat(name_array[count],((char **)ht->variable)[count]);
        }
      }
    }

    type_insert(common_block_table, (AST *)name_array, Float,
         Clist->astnode.common.name);
  }
}

/*****************************************************************************
 *                                                                           *
 * addEquiv                                                                  *
 *                                                                           *
 * Insert the given node (which is itself a list of variables) into a list   *
 * of equivalences.  We end up with a list of lists.                         *
 *                                                                           *
 *****************************************************************************/

void
addEquiv(AST *node)
{
  static int id = 1;

  /* if the list is NULL, create one */

  if(equivList == NULL) {
    equivList = addnode(); 
    equivList->nodetype = Equivalence;
    equivList->token = id++;
    equivList->nextstmt = NULL;
    equivList->prevstmt = NULL;
    equivList->astnode.equiv.clist = node;
  }
  else {
    AST *temp = addnode();

    temp->nodetype = Equivalence;
    temp->token = id++;
    temp->astnode.equiv.clist = node;

    temp->nextstmt = equivList; 
    temp->prevstmt = NULL;

    equivList = temp;
  }
}

/*****************************************************************************
 *                                                                           *
 * eval_const_expr                                                           *
 *                                                                           *
 * This function evaluates a floating-point expression which should consist  *
 * of only parameters and constants.  The floating-point result is returned. *
 *                                                                           *
 *****************************************************************************/

double
eval_const_expr(AST *root)
{
  HASHNODE *p;
  double result1, result2;

  if(root == NULL)
    return 0.0;

  switch (root->nodetype)
  {
    case Identifier:
      if(!strcmp(root->astnode.ident.name,"*"))
        return 0;

      p = type_lookup(parameter_table, root->astnode.ident.name);

      if(p == NULL)
      {
        /* The array size is specified with a variable, but we
         * cant find it in the parameter table.  it is probably
         * an argument to the function.  do nothing here, just
         * fall through and hit the 'return 0' below.  --keith
         */
      }
      else
      {
         if(p->variable->nodetype == Constant) {
           root->vartype = p->variable->vartype;
           return ( atof(p->variable->astnode.constant.number) );
         }
      }
      return 0;
      break;
    case Expression:
      if (root->astnode.expression.lhs != NULL)
        result1 = eval_const_expr (root->astnode.expression.lhs);

      result2 = eval_const_expr (root->astnode.expression.rhs);
      root->token = root->astnode.expression.rhs->token;
      root->nodetype = root->astnode.expression.rhs->nodetype;
      root->vartype = root->astnode.expression.rhs->vartype;
      strcpy(root->astnode.constant.number,
          root->astnode.expression.rhs->astnode.constant.number);
      return (result2);
      break;
    case Power:
      result1 = eval_const_expr (root->astnode.expression.lhs);
      result2 = eval_const_expr (root->astnode.expression.rhs);
      root->vartype = MIN(root->astnode.expression.lhs->vartype,
                          root->astnode.expression.rhs->vartype);
      return( mypow(result1,result2) );
      break;
    case Binaryop:
      result1 = eval_const_expr (root->astnode.expression.lhs);
      result2 = eval_const_expr (root->astnode.expression.rhs);
      root->vartype = MIN(root->astnode.expression.lhs->vartype,
                          root->astnode.expression.rhs->vartype);
      if(root->astnode.expression.optype == '-')
        return (result1 - result2);
      else if(root->astnode.expression.optype == '+')
        return (result1 + result2);
      else if(root->astnode.expression.optype == '*')
        return (result1 * result2);
      else if(root->astnode.expression.optype == '/')
        return (result1 / result2);
      else
        fprintf(stderr,"eval_const_expr: Bad optype!\n");
      return 0;
      break;
    case Unaryop:
      root->vartype = root->astnode.expression.rhs->vartype;
     /*
      result1 = eval_const_expr (root->astnode.expression.rhs);
      if(root->astnode.expression.minus == '-')
        return -result1;
     */
      break;
    case Constant:
      if(root->token == STRING)
        fprintf (stderr, "String in array dec!\n");
      else
        return( atof(root->astnode.constant.number) );
      break;
    case ArrayIdxRange:
      /* I dont think it really matters what the type of this node is. --kgs */
      root->vartype = MIN(root->astnode.expression.lhs->vartype,
                          root->astnode.expression.rhs->vartype);
      return(  eval_const_expr(root->astnode.expression.rhs) - 
               eval_const_expr(root->astnode.expression.lhs) );
      break;
    case Logicalop:
      {
        int left=0, right=0;

        root->nodetype = Constant;
        root->vartype = Logical;

        eval_const_expr(root->astnode.expression.lhs);
        eval_const_expr(root->astnode.expression.rhs);

        if(root->token != NOT)
          left = root->astnode.expression.lhs->token == TrUE;
        right = root->astnode.expression.rhs->token == TrUE;

        switch (root->token) {
          case EQV:
            root->token = left == right ? TrUE : FaLSE;
            break;
          case NEQV:
            root->token = left != right ? TrUE : FaLSE;
            break;
          case AND:
            root->token = left && right ? TrUE : FaLSE;
            break;
          case OR:
            root->token = left || right ? TrUE : FaLSE;
            break;
          case NOT:
            root->token = ! right ? TrUE : FaLSE;
            break;
        }
        strcpy(root->astnode.constant.number,root->token == TrUE ? "true" : "false");
      }
      break;
    default:
      fprintf(stderr,"eval_const_expr(): bad nodetype!\n");
      return 0;
  }
  return 0;
}

void
printbits(char *header, void *var, int len)
{
  int i;

  printf("%s: ", header);
  for(i=0;i<len;i++) {
      printf("%1x", ((unsigned char *)var)[i] >> 7 );
      printf("%1x", ((unsigned char *)var)[i] >> 6 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 5 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 4 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 3 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 2 & 1 );
      printf("%1x", ((unsigned char *)var)[i] >> 1 & 1 );
      printf("%1x", ((unsigned char *)var)[i] & 1 );
  }
  printf("\n");
}

/*****************************************************************************
 *                                                                           *
 * prepend_minus                                                             *
 *                                                                           *
 * This function accepts a string and prepends a '-' in front of it.         *
 * We assume that the string pointer passed in has enough storage space.     *
 *                                                                           *
 *****************************************************************************/

void
prepend_minus(char *num) {
  char * tempstr;

  /* allocate enough for the number, minus sign, and null char */
  tempstr = (char *)f2jalloc(strlen(num) + 2);

  strcpy(tempstr,"-");
  strcat(tempstr,num);
  strcpy(num,tempstr);

  free(tempstr);
}

/*****************************************************************************
 *                                                                           *
 * gen_incr_expr                                                             *
 *                                                                           *
 * this function creates an AST sub-tree representing a calculation of the   *
 * increment for this loop.  for null increments, add one.  for non-null     *
 * increments, add the appropriate value.
 *                                                                           *
 *****************************************************************************/

AST *
gen_incr_expr(AST *counter, AST *incr)
{
  AST *plus_node, *const_node, *assign_node, *lhs_copy, *rhs_copy, *incr_copy;

  lhs_copy = addnode();
  memcpy(lhs_copy, counter, sizeof(AST));
  rhs_copy = addnode();
  memcpy(rhs_copy, counter, sizeof(AST));

  if(incr == NULL) {
    const_node = addnode();
    const_node->token = INTEGER;
    const_node->nodetype = Constant;
    strcpy(const_node->astnode.constant.number, "1");
    const_node->vartype = Integer;

    plus_node = addnode();
    plus_node->token = PLUS;
    rhs_copy->parent = plus_node;
    const_node->parent = plus_node;
    plus_node->astnode.expression.lhs = rhs_copy;
    plus_node->astnode.expression.rhs = const_node;
    plus_node->nodetype = Binaryop;
    plus_node->astnode.expression.optype = '+';
  }
  else {
    incr_copy = addnode();
    memcpy(incr_copy, incr, sizeof(AST));

    plus_node = addnode();
    plus_node->token = PLUS;
    rhs_copy->parent = plus_node;
    incr_copy->parent = plus_node;
    plus_node->astnode.expression.lhs = rhs_copy;
    plus_node->astnode.expression.rhs = incr_copy;
    plus_node->nodetype = Binaryop;
    plus_node->astnode.expression.optype = '+';
  }

  assign_node = addnode();
  assign_node->nodetype = Assignment;
  lhs_copy->parent = assign_node;
  plus_node->parent = assign_node;
  assign_node->astnode.assignment.lhs = lhs_copy;
  assign_node->astnode.assignment.rhs = plus_node;

  return assign_node;
}

/*****************************************************************************
 *                                                                           *
 * gen_iter_expr                                                             *
 *                                                                           *
 * this function creates an AST sub-tree representing a calculation of the   *
 * number of iterations of a DO loop:                                        *
 *     (stop-start+incr)/incr                                                *
 * the full expression is MAX(INT((stop-start+incr)/incr),0) but we will     *
 * worry about the rest of it at code generation time.                       *
 *                                                                           *
 *****************************************************************************/

AST *
gen_iter_expr(AST *start, AST *stop, AST *incr)
{
  AST *minus_node, *plus_node, *div_node, *expr_node, *incr_node;
  
  minus_node = addnode();
  minus_node->token = MINUS;
  minus_node->astnode.expression.lhs = stop;
  minus_node->astnode.expression.rhs = start;
  minus_node->nodetype = Binaryop;
  minus_node->astnode.expression.optype = '-';
  
  if(incr == NULL) {
    incr_node = addnode();
    incr_node->token = INTEGER;
    incr_node->nodetype = Constant;
    strcpy(incr_node->astnode.constant.number, "1");
    incr_node->vartype = Integer;
  }
  else 
    incr_node = incr;
  
  plus_node = addnode();
  plus_node->token = PLUS;
  plus_node->astnode.expression.lhs = minus_node;
  plus_node->astnode.expression.rhs = incr_node;
  plus_node->nodetype = Binaryop;
  plus_node->astnode.expression.optype = '+';

  if(incr == NULL)
    return plus_node;
    
  expr_node = addnode();
  expr_node->nodetype = Expression;
  expr_node->astnode.expression.parens = TRUE;
  expr_node->astnode.expression.rhs = plus_node;
  expr_node->astnode.expression.lhs = NULL;

  div_node = addnode();
  div_node->token = DIV;
  div_node->astnode.expression.lhs = expr_node;
  div_node->astnode.expression.rhs = incr_node;
  div_node->nodetype = Binaryop;
  div_node->astnode.expression.optype = '/';

  return div_node;
}
