public class TestT2
{
    public double[] te_temp = null;
    public double[] t2_temp = null;
    public double[] b = null;
    public double[] x = null;

    public static void main(String args[])
    {
        TestT2 t = new TestT2();
    }

    public TestT2()
    {
        System.out.println("Test::Test()");

        setupAb();
        NNLST2 nnlsobj = new NNLST2();
        nnlsobj.create(te_temp, t2_temp);
        nnlsobj.compute(b, x);

        for(int ii=0; ii<x.length; ii++) {
            if( x[ii] > 0.0 ) {
                System.out.println("" + x[ii] + " " + t2_temp[ii]);
            }
        }
    }

    private void setupAb() {
        int ii;

        int nte = 32;
        int nt2 = 81;

        te_temp = new double[nte];
        for(ii=1; ii<=nte; ii++) {
            te_temp[ii-1] = ((double)ii*10.0)/1000.0;
        }

        x = new double[nt2];
           t2_temp = new double[nt2];
        ii=0;
        t2_temp[ii++] = 0.150000E-01;
        t2_temp[ii++] = 0.159584E-01;
        t2_temp[ii++] = 0.169780E-01;
        t2_temp[ii++] = 0.180628E-01;
        t2_temp[ii++] = 0.192169E-01;
        t2_temp[ii++] = 0.204447E-01;
        t2_temp[ii++] = 0.217510E-01;
        t2_temp[ii++] = 0.231407E-01;
        t2_temp[ii++] = 0.246193E-01;
        t2_temp[ii++] = 0.261923E-01;
        t2_temp[ii++] = 0.278658E-01;
        t2_temp[ii++] = 0.296462E-01;
        t2_temp[ii++] = 0.315404E-01;
        t2_temp[ii++] = 0.335556E-01;
        t2_temp[ii++] = 0.356996E-01;
        t2_temp[ii++] = 0.379805E-01;
        t2_temp[ii++] = 0.404072E-01;
        t2_temp[ii++] = 0.429890E-01;
        t2_temp[ii++] = 0.457357E-01;
        t2_temp[ii++] = 0.486578E-01;
        t2_temp[ii++] = 0.517667E-01;
        t2_temp[ii++] = 0.550743E-01;
        t2_temp[ii++] = 0.585931E-01;
        t2_temp[ii++] = 0.623368E-01;
        t2_temp[ii++] = 0.663197E-01;
        t2_temp[ii++] = 0.705571E-01;
        t2_temp[ii++] = 0.750652E-01;
        t2_temp[ii++] = 0.798614E-01;
        t2_temp[ii++] = 0.849639E-01;
        t2_temp[ii++] = 0.903926E-01;
        t2_temp[ii++] = 0.961680E-01;
        t2_temp[ii++] = 0.102312E+00;
        t2_temp[ii++] = 0.108850E+00;
        t2_temp[ii++] = 0.115804E+00;
        t2_temp[ii++] = 0.123203E+00;
        t2_temp[ii++] = 0.131075E+00;
        t2_temp[ii++] = 0.139450E+00;
        t2_temp[ii++] = 0.148360E+00;
        t2_temp[ii++] = 0.157839E+00;
        t2_temp[ii++] = 0.167924E+00;
        t2_temp[ii++] = 0.178653E+00;
        t2_temp[ii++] = 0.190068E+00;
        t2_temp[ii++] = 0.202212E+00;
        t2_temp[ii++] = 0.215132E+00;
        t2_temp[ii++] = 0.228877E+00;
        t2_temp[ii++] = 0.243501E+00;
        t2_temp[ii++] = 0.259059E+00;
        t2_temp[ii++] = 0.275611E+00;
        t2_temp[ii++] = 0.293220E+00;
        t2_temp[ii++] = 0.311955E+00;
        t2_temp[ii++] = 0.331887E+00;
        t2_temp[ii++] = 0.353092E+00;
        t2_temp[ii++] = 0.375652E+00;
        t2_temp[ii++] = 0.399654E+00;
        t2_temp[ii++] = 0.425189E+00;
        t2_temp[ii++] = 0.452356E+00;
        t2_temp[ii++] = 0.481258E+00;
        t2_temp[ii++] = 0.512007E+00;
        t2_temp[ii++] = 0.544721E+00;
        t2_temp[ii++] = 0.579525E+00;
        t2_temp[ii++] = 0.616553E+00;
        t2_temp[ii++] = 0.655946E+00;
        t2_temp[ii++] = 0.697856E+00;
        t2_temp[ii++] = 0.742445E+00;
        t2_temp[ii++] = 0.789882E+00;
        t2_temp[ii++] = 0.840350E+00;
        t2_temp[ii++] = 0.894042E+00;
        t2_temp[ii++] = 0.951165E+00;
        t2_temp[ii++] = 0.101194E+01;
        t2_temp[ii++] = 0.107659E+01;
        t2_temp[ii++] = 0.114538E+01;
        t2_temp[ii++] = 0.121856E+01;
        t2_temp[ii++] = 0.129642E+01;
        t2_temp[ii++] = 0.137925E+01;
        t2_temp[ii++] = 0.146738E+01;
        t2_temp[ii++] = 0.156113E+01;
        t2_temp[ii++] = 0.166088E+01;
        t2_temp[ii++] = 0.176700E+01;
        t2_temp[ii++] = 0.187990E+01;
        t2_temp[ii++] = 0.200001E+01;
        t2_temp[ii++] = 999999.0;

        b = new double[nte];
        ii = 0;
        b[ii++] = 1585 ;
        b[ii++] = 1389 ;
        b[ii++] = 1214 ;
        b[ii++] = 1068 ;
        b[ii++] = 943 ;
        b[ii++] = 862 ;
        b[ii++] = 741 ;
        b[ii++] = 656 ;
        b[ii++] = 564 ;
        b[ii++] = 510 ;
        b[ii++] = 422 ;
        b[ii++] = 408;
        b[ii++] = 350 ;
        b[ii++] = 311 ;
        b[ii++] = 280 ;
        b[ii++] = 211 ;
        b[ii++] = 177 ;
        b[ii++] = 222 ;
        b[ii++] = 165 ;
        b[ii++] = 140 ;
        b[ii++] = 131 ;
        b[ii++] = 121 ;
        b[ii++] = 91 ;
        b[ii++] = 125 ;
        b[ii++] = 103 ;
        b[ii++] = 97;
        b[ii++] = 56 ;
        b[ii++] = 46 ;
        b[ii++] = 39 ;
        b[ii++] = 61 ;
        b[ii++] = 20 ;
        b[ii++] = 76;
    }
}
